//
//  Input.c
//  BreakBlocks
//
//  Created by Dayle Flowers on 1/5/12.
//  Copyright (c) 2012 Zimmdot. All rights reserved.
//

#include <stdio.h>
#include "Input.h"
#include "iOSMain.h"

MouseStatus g_mouseStatus[MAX_MICE];
unsigned int g_dwCurrentTime;

void MouseDown(int iIndex, float fX, float fY)
{
	int i, j;
	//printf("MouseDown %i %f %f %u\n", iIndex, fX, fY, g_dwCurrentTime);
	
	for (i = 0, j = -1; i < MAX_MICE; i++)
	{
		if (g_mouseStatus[i].m_iIndex == iIndex)
			j = i;
		else if (j == -1 && g_mouseStatus[i].m_bInUse == 0)
			j = i;
	}
	
	if (j == -1)
		return;
	
	g_mouseStatus[j].m_iIndex = iIndex;
	
	g_mouseStatus[j].m_bInUse = 1;
	g_mouseStatus[j].m_fPrevX = fX;
	g_mouseStatus[j].m_fPrevY = fY;
	g_mouseStatus[j].m_uiPressTime = g_dwCurrentTime;
	
	MainTouchOrDrag(1, &g_mouseStatus[j], j, fX, fY);
}

void MouseMove(int iIndex, float fX, float fY)
{
	int i, j;

	for (i = 0, j = -1; i < MAX_MICE; i++)
	{
		if (g_mouseStatus[i].m_iIndex == iIndex)
		{
			j = i;
			break;
		}
	}
	
	//printf("MouseMove %i %f %f %i\n", iIndex, fX, fY, g_mouseStatus[j].m_bInUse);

	if (j == -1 || g_mouseStatus[j].m_bInUse == 1)
		return;

	MainTouchOrDrag(g_mouseStatus[j].m_bInUse == 0, &g_mouseStatus[j], j, fX, fY);

	g_mouseStatus[j].m_fPrevX = fX;
	g_mouseStatus[j].m_fPrevY = fY;
	g_mouseStatus[j].m_bInUse = 1;
}

void MouseUp(int iIndex, float fX, float fY)
{
	int i, j;
	
	//printf("MouseUp %i %f %f\n", iIndex, fX, fY);

	for (i = 0, j = -1; i < MAX_MICE; i++)
	{
		if (g_mouseStatus[i].m_iIndex == iIndex)
		{
			j = i;
			break;
		}
	}
	
	if (j == -1)
		return;

	g_mouseStatus[j].m_bInUse = 0;

	MainTouchOrDrag(0, &g_mouseStatus[j], j, fX, fY);

	g_mouseStatus[j].m_iIndex = 0;
}

bool GameWantsTouch(float fX, float fY)
{
	return MainGameWantsTouch(fX, fY);
}
