//
//  Matrix.h
//  BreakBlocks
//
//  Created by Dayle Flowers on 1/5/12.
//  Copyright (c) 2012 Zimmdot. All rights reserved.
//

#ifndef BreakBlocks_Matrix_h
#define BreakBlocks_Matrix_h

typedef struct
{
	float m[16];
} Matrix4;

typedef struct
{
	float m[9];
} Matrix3;

Matrix4* Matrix4GenPerspective(Matrix4 *pResult, float fFOV, float fAspectRatio, float fNearPlane, float fFarPlane);
Matrix4* Matrix4GenOrtho(Matrix4 *pResult, float fLeft, float fRight, float fTop, float fBottom, float fNearPlane, float fFarPlane);
Matrix4* Matrix4GenLookAt(Matrix4 *pResult, float eyePositionX, float eyePositionY, float eyePositionZ, float centerX, float centerY, float centerZ, float upVectorX, float upVectorY, float upVectorZ);
Matrix4* Matrix4LoadIdentity(Matrix4 *pResult);
Matrix4* Matrix4MakeFromArray(Matrix4 *pResult, float *pArray);
Matrix4* Matrix4MakeTranslation(Matrix4 *pResult, float fX, float fY, float fZ);
Matrix4* Matrix4MakeRotation(Matrix4 *pResult, float fRotation, float fX, float fY, float fZ);
Matrix4* Matrix4Translate(Matrix4 *pInOutResult, float fX, float fY, float fZ);
Matrix4* Matrix4Rotate(Matrix4 *pInOutResult, float fRotation, float fX, float fY, float fZ);
Matrix4* Matrix4Multiply(Matrix4 *__restrict pResult, Matrix4 *__restrict pMat1, Matrix4 *__restrict pMat2);

Matrix3* Matrix4ToMatrix3(Matrix3 *pResult, Matrix4 *pSource);

Matrix3* Matrix3Invert(Matrix3 *__restrict pResult, Matrix3 *__restrict pSource);
Matrix3* Matrix3InvertAndTranspose(Matrix3 *__restrict pResult, Matrix3 *__restrict pSource);

#endif
