//
//  AppDelegate.m
//  BreakBlocks
//
//  Created by Dayle Flowers on 1/6/12.
//  Copyright (c) 2012 Greater Good Games. All rights reserved.
//

#import "xAppDelegate.h"
#import "Paper.h"

#define PASTEBOARD_NAME	@"GGGBreakBlocksUID"

char g_strAvailableChars[49] = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ!#$@&()-/[]_";

@implementation xAppDelegate

@synthesize window = _window;

@synthesize viewController = _viewController;

- (void)dealloc
{
    [super dealloc];
}

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
	char device[256];
	int stringlength, value;

	self.window.rootViewController = self.viewController;
	
	UIPasteboard *pasteboard = [UIPasteboard pasteboardWithName:PASTEBOARD_NAME create:NO];
	if(pasteboard != nil)
	{
		strcpy(device, [[pasteboard string] UTF8String]);
	}
	else
	{
		CFUUIDRef theUUID = CFUUIDCreate(NULL);
		CFStringRef string = CFUUIDCreateString(NULL, theUUID);

		UIPasteboard *pasteboard = [UIPasteboard pasteboardWithName:PASTEBOARD_NAME create:YES];
		[pasteboard setPersistent:YES];
		[pasteboard setString:((__bridge NSString*)string)];
		
		CFStringGetCString(string, device, 256, kCFStringEncodingUTF8);
	}
	
	stringlength = strlen(device);
	
	memset(g_xPaperAPI.m_strMobileIdentifier, 0, 32);
	
	g_xPaperAPI.m_strMobileIdentifier[0] = '~';
	g_xPaperAPI.m_strMobileIdentifier[1] = '!';
	g_xPaperAPI.m_strMobileIdentifier[2] = '%';
	g_xPaperAPI.m_strMobileIdentifier[3] = '4';
	g_xPaperAPI.m_strMobileIdentifier[4] = '0';
	
	for(int i = 0; i < stringlength; i++)
	{
		if(device[i * 2] == '\0')
			break;
	
		if(device[i * 2] <= '9')
		{
			value = device[i * 2] - '0';
		}
		else
		{
			value = 10 + (device[i * 2] - 'A');
		}
		
		if(device[i * 2 + 1] != '\0')
		{			
			if(device[i * 2 + 1] <= '9')
			{
				value = 16 + device[i * 2 + 1] - '0';
			}
			else
			{
				value = 16 + 10 + (device[i * 2 + 1] - 'A');
			}
		}
		
		g_xPaperAPI.m_strMobileIdentifier[i + 5] = g_strAvailableChars[value];
	}
	
    return YES;
}

- (void)applicationWillResignActive:(UIApplication *)application
{
	/*
	 Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
	 Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
	 */
	[self.viewController stopAnimation];
}

- (void)applicationDidEnterBackground:(UIApplication *)application
{
	/*
	 Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later. 
	 If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
	 */
}

- (void)applicationWillEnterForeground:(UIApplication *)application
{
	/*
	 Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
	 */
}

- (void)applicationDidBecomeActive:(UIApplication *)application
{
	/*
	 Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
	 */
	[self.viewController startAnimation];
}

- (void)applicationWillTerminate:(UIApplication *)application
{
	/*
	 Called when the application is about to terminate.
	 Save data if appropriate.
	 See also applicationDidEnterBackground:.
	 */
	[self.viewController stopAnimation];
}

@end
