// peGame.cpp : Defines the entry point for the DLL application.

#include "peGame.h"

xGameState		*g_pCurGameState		= 0;
xGame			 g_xGame;
xMenu			 g_xMenu;
xOptions		 g_xOptions;
xGameOptions	 g_xGameOptions;
xPlayerProfile	 g_xCurrentProfile;

// Credits Helpers
bool		  g_bCreditsRolling = 0;
bool		  g_bTourComplete = 0;
int			  g_iMaxCreditLines = 0;
xGUIText	**g_pCreditTextArray = 0;
int			  g_iCurTextLine = 0;
int			  g_iCurCreditLine = 0;
char		 *g_strCredits[CREDIT_LINES] = {"BREAK BLOCKS",
											"",
											"TECHNICAL DIRECTOR",
											"and LEAD PROGRAMMER",
											"Dayle \"Xienen\" Flowers",
											"",
											"ART DIRECTOR",
											"and LEAD ARTIST",
											"Noah Wood",
											"",
											"MUSIC COMPOSED BY",
											"Stephen White",
											"",
											"WRITER",
											"Jenny Flowers",
											"",
											"VOICE ACTORS",
											"Jarrod Lipshy",
											"Jenny Flowers",
											"",
											"SOUND ENGINEER",
											"Bobby Arlauskus",
											"",
											"ADDITIONAL PROGRAMMING",
											"Wesley Valentijn",
											"",
											"FONTS",
											"JW/SWE, \"AAAIIGHT!\"",
											"Manfred Klein, \"Old Sans Black\"",
											"",
											"SPECIAL THANKS",
											"David Hensley",
											"Alan Wilson",
											"Jesse van Dongen",
											"Stuart Jenkins",
											"Olivier Brault",
											"Carl Gustav",
											"Trent Gotay",
											"Blender 3D Tools",
											"",
											"PLATINUM SUPPORTER",
											"Mikko Jaaskelainen",
											"",
											"SILVER SUPPORTER",
											"Henry Lu",
											"",
											"BRONZE SUPPORTER",
											"Aaron Meehan"};

// Encrypted Strings
uint32_t	g_pEncryptedCDKeyFile[BB_ENCRYPTED_LENGTH_CDKEYFILE] = {531295934u, 1513120809u, 2236083992u, 2318724615u};
uint32_t	g_pEncryptedCDKeyWindow[BB_ENCRYPTED_LENGTH_CDKEYWINDOW] = {3322750688u, 505214705u, 1653821638u};
uint32_t	g_pEncryptedStoreKeyString[BB_ENCRYPTED_LENGTH_STOREKEY] = {4113581217u, 1475318751u};
char		g_strStoreKey[32];
uint32_t	g_pEncryptedCDKeyInvalid1[BB_ENCRYPTED_LENGTH_CDKEYINVALID1] = {3941185058u, 3269028709u, 2161118720u, 3918776771u, 3258004910u, 833992439u, 2590823140u, 974391537u, 1573920286u, 496914515u, 376208391u, 347177947u, 360166330u, 3954036512u, 2349704710u};
uint32_t	g_pEncryptedCDKeyInvalid2[BB_ENCRYPTED_LENGTH_CDKEYINVALID2] = {3972537757u, 153692799u, 2142806705u, 2712733511u, 3372786210u, 3569245909u, 1070641100u, 1897640306u, 669905518u, 2574873300u, 1887099588u};
uint32_t	g_pEncryptedSingleplayerString[BB_ENCRYPTED_LENGTH_SINGLEPLAYER] = {2879178348, 2370741887, 1935515360};
char		g_strSingleplayer[32];
uint32_t	g_pEncryptedChallengesString[BB_ENCRYPTED_LENGTH_CHALLENGES] = {2557610992, 4035313810, 1355511692};
char		g_strChallenges[32];
uint32_t	g_pEncryptedFreePlayString[BB_ENCRYPTED_LENGTH_FREEPLAY] = {3101358384, 807509860};
char		g_strFreePlay[32];
uint32_t	g_pEncryptedContinueSingleplayerString[BB_ENCRYPTED_LENGTH_CONTINUESINGLEPLAYER] = {1293069194, 607179436, 3139836262, 1002417071, 3453668257};
char		g_strContinueSingleplayer[32];

#if WITH_BALANCESTATS
	xBalanceStats	 g_xBalanceStats;
#endif

#ifndef FINAL_RELEASE
	xFileIO	g_xLog;
#endif

#ifdef _DEBUG
	xFont	g_xDebugFont;
#endif

void RunPlayerMovesFunction(xParser* pParser, char *strFunction, char* strParam1, char* strParam2, char* strParam3);

void GameInitEngineSettings()
{
	//Unencrypt any needed strings
	xDecryptString(g_pEncryptedStoreKeyString, BB_ENCRYPTED_LENGTH_STOREKEY, g_strStoreKey, PRIVATE_KEY_KEY0, PRIVATE_KEY_KEY1, PRIVATE_KEY_KEY2, PRIVATE_KEY_KEY3);
	xDecryptString(g_pEncryptedSingleplayerString, BB_ENCRYPTED_LENGTH_SINGLEPLAYER, g_strSingleplayer, PRIVATE_KEY_KEY0, PRIVATE_KEY_KEY1, PRIVATE_KEY_KEY2, PRIVATE_KEY_KEY3);
	xDecryptString(g_pEncryptedChallengesString, BB_ENCRYPTED_LENGTH_CHALLENGES, g_strChallenges, PRIVATE_KEY_KEY0, PRIVATE_KEY_KEY1, PRIVATE_KEY_KEY2, PRIVATE_KEY_KEY3);
	xDecryptString(g_pEncryptedFreePlayString, BB_ENCRYPTED_LENGTH_FREEPLAY, g_strFreePlay, PRIVATE_KEY_KEY0, PRIVATE_KEY_KEY1, PRIVATE_KEY_KEY2, PRIVATE_KEY_KEY3);
	xDecryptString(g_pEncryptedContinueSingleplayerString, BB_ENCRYPTED_LENGTH_CONTINUESINGLEPLAYER, g_strContinueSingleplayer, PRIVATE_KEY_KEY0, PRIVATE_KEY_KEY1, PRIVATE_KEY_KEY2, PRIVATE_KEY_KEY3);

	g_xOptions.LoadOptions(BB_SETTINGSPATH);

	if(g_xOptions.m_bFirstRun)
	{
		xGraphicsGetDesktopResolution(&g_xOptions.m_iScreenWidth, &g_xOptions.m_iScreenHeight);
		g_xOptions.m_bFullScreen = true;
		g_xOptions.SaveOptions(BB_SETTINGSPATH);
	}

	g_xPaperAPI.m_xEngineSettings.m_iScreenWidth = g_xOptions.m_iScreenWidth;
	g_xPaperAPI.m_xEngineSettings.m_iScreenHeight = g_xOptions.m_iScreenHeight;
	g_xPaperAPI.m_xEngineSettings.m_bFullScreen = g_xOptions.m_bFullScreen;
	g_xPaperAPI.m_xEngineSettings.m_bForce4x3WhenWideScreen = true;
}

void GameInit()
{
	//This is called when the engine is initializing
	g_pCurGameState = &g_xMenu;

	g_pCurGameState->Init("");

	g_xGame.Init();

#ifdef _DEBUG
	xFontLoad(&g_xDebugFont, "OldSansBlack-22pt");
#endif
}

void GamePreUpdate(DWORD dwTime)
{
	//NOTE: This is called before the engine renders everything(Generally used to handle Input)

	if(g_pCurGameState->m_iPreLoadFramesSkipped < 2)
		return;

	g_pCurGameState->PreUpdate(dwTime);
}

void GameUpdate(double dTime)
{
	//NOTE: This is called inside the engine's render loop

	if(g_pCurGameState->m_iPreLoadFramesSkipped < 2)
	{
		g_pCurGameState->m_iPreLoadFramesSkipped++;
		return;
	}

	g_pCurGameState->Update(dTime);
}

void GameRefreshAllRenderables()
{
	g_xGame.RefreshAllRenderables();

	g_xMenu.RefreshAllRenderables();
}

void GameShutdown()
{
	//NOTE: This is called just before the engine shuts itself down

	g_xGame.Shutdown();

	g_xMenu.Shutdown();

	if(g_pCurGameState != &g_xGame && g_pCurGameState != &g_xMenu)
	{
		g_pCurGameState->Shutdown();
		delete g_pCurGameState;
	}
}

void ExecTextCommand(char* &strOutput, int iMaxSize, char *strCommand, char **strParams)
{
}
