#ifndef XAUDIOSTREAM_H_
#define XAUDIOSTREAM_H_

#include <CoreFoundation/CoreFoundation.h>
#include <AudioToolbox/AudioToolbox.h>
#include "openal/al.h"

#define PE_OPENAL_OGG_NUMBUFFERS	5

enum xAudioStreamState
{
	PE_AUDIOSTREAMSTATE_NULL = 0,
	PE_AUDIOSTREAMSTATE_INITIALIZED,
	PE_AUDIOSTREAMSTATE_STOPPED,
	PE_AUDIOSTREAMSTATE_PLAYING
};

class xAudioStream
{
public:
	xAudioStream()
	{
		m_refExtAudioFile	= 0;
		m_pDecodeBuffer		= 0;
		m_bPlaying			= 0;
		m_bDone				= 0;
		m_bLooping			= 0;
		m_bAnalyzing		= 0;
	}

	int  Open(const char *strPathName, bool bLooping = false, bool bAnalyzing = false);
	int  Play();
	void ContinuePlaying();
	int  Stop();
	int  Release();

	//int Pause();
	//int UnPause();

	void  SetVolume(float fVolume = 1.0);
	DWORD GetTime();
	int   SetTime(DWORD dwMilliseconds);
	DWORD GetLength() { return m_dwLength; }
	bool  IsDone() { return m_bDone; }
	bool  IsPlaying() { return m_bPlaying; }

	unsigned long	GetChannelCount() { return m_ulChannels; }
	unsigned long	GetSampleRate() { return m_ulFrequency; }
	unsigned long	DecodeStream();
	char*			GetDecodeBuffer() { return m_pDecodeBuffer; }

	xAudioStreamState m_xAudioStreamState;

protected:
	bool			 m_bPlaying;
	bool			 m_bDone;
	bool			 m_bLooping;
	bool			 m_bAnalyzing;
	DWORD			 m_dwLength;
	ExtAudioFileRef	 m_refExtAudioFile;
	AudioBufferList	 m_listAudioBuffer;
	char			*m_pDecodeBuffer;
	unsigned long	 m_ulChannels;
	unsigned long	 m_ulFormat;
	unsigned long	 m_ulBufferSize;
	unsigned long	 m_ulFrequency;
	ALuint			 m_uiSource;
	ALuint			 m_uiBuffers[PE_OPENAL_OGG_NUMBUFFERS];
	CFURLRef		 m_refURL;
};

#endif
