#ifndef XBALANCESTATS_H_
#define XBALANCESTATS_H_

#define	BB_BALANCESTATSVERSION	3
#define	BB_BALANCESTATSFTP		"ftp.greatergoodgames.org"
#define	BB_BALANCESTATSFTPPORT	21
#define	BB_BALANCESTATSFTPUSER	"statsupload"
#define	BB_BALANCESTATSFTPPASS	"qwerty1"
#define	BB_BALANCESTATSFTPPATH	"/stats.greatergoodgames.org/%s"

struct xBalanceStatStruct
{
	uint8_t		m_byteVersion;
	char		m_strLevelName[64];
	bool		m_bWonGame;
	uint32_t	m_u32HighScore;
	uint32_t	m_u32Score;
	uint16_t	m_u16BlocksCleared;
	uint32_t	m_u32NumBlocks;
	uint16_t	m_u16NumPieces;
	uint16_t	m_u16WrongColors;
	uint16_t	m_u16MissedBeats;
	uint16_t	m_u16MaxComboCount;
	uint32_t	m_u32TimeRemaining;
	uint8_t		m_byteRemoved[255];
	uint8_t		m_byteRemoved2[255];
	uint8_t		m_byteRemoved3[10];
	uint16_t	m_u16Removed[10];
};

class xBalanceStats
{
public:
	xBalanceStats()
	{
		m_bCommitting = false;

		Reset();
	}

	void Reset();
	void Commit();
	void Update();

	void SetPlayerName(char strPlayerName[BB_MAXPROFILENAMELENGTH]) { strcpy(m_strPlayerName, strPlayerName); }

	void SetLevelName(const char *strLevel) { strcpy(m_xBalanceStats.m_strLevelName, strLevel); }
	void SetWonGame(bool bWonGame, uint32_t u32TimeRemaining) { m_xBalanceStats.m_bWonGame = bWonGame; m_xBalanceStats.m_u32TimeRemaining = u32TimeRemaining; }
	void SetScore(uint32_t u32Score, uint32_t u32HighScore) { m_xBalanceStats.m_u32Score = u32Score; m_xBalanceStats.m_u32HighScore = u32HighScore; }

	void NewPiece() { m_xBalanceStats.m_u16NumPieces++; }
	void BlocksCleared(int iBlockCount) { m_xBalanceStats.m_u16BlocksCleared += iBlockCount; }
	void HitWrongColor() { m_xBalanceStats.m_u16WrongColors++; m_xBalanceStats.m_u32NumBlocks++; }
	void MissedBeat() { m_xBalanceStats.m_u16MissedBeats++; m_xBalanceStats.m_u32NumBlocks++; }

	void AddedBlock(uint16_t u16ComboCount) { if(u16ComboCount > m_xBalanceStats.m_u16MaxComboCount) m_xBalanceStats.m_u16MaxComboCount = u16ComboCount; m_xBalanceStats.m_u32NumBlocks++; }

private:
	void	Connect();
	void	ParsePassiveResponse(char *strResponse);

	char	m_strPlayerName[BB_MAXPROFILENAMELENGTH];
	bool	m_bCommitting;
	int		m_iCommitStep;
	bool	m_bStatsSent;

	char	m_strFileTransferIP[16];
	int		m_iFileTransferPort;

	xBalanceStatStruct	m_xBalanceStats;
};

#endif