/////////////////////////////////////////////////////////////////
// Name: xBeatManager.h
/////////////////////////////////////////////////////////////////
// Description:
// - Keeps up with beats for the Beat Marker rendering.
/////////////////////////////////////////////////////////////////
// - 11.14.2009, Update, Dayle Flowers(Xienen)
//   File Created
/////////////////////////////////////////////////////////////////
#ifndef XBEATMANAGER_H_
#define XBEATMANAGER_H_

#include "xGameDefines.h"

#define BB_MAXBEATS			1024

class xBeatManager
{
public:
	xBeatManager()
	{
		m_iNumBeats				= 0;
		m_iCurBeatIndex			= 0;
		m_bAddedBlockAlready	= false;
		m_dwLastHitTime			= 0;
		m_iHitTimeIndex			= 0;
	}

	float	AddBeat(DWORD dwTime, char cNextBeat);
	bool	HitBeat(DWORD dwPressTime);
	void	ResetBeats();
	bool	BeatsInitialized() { return m_iNumBeats > 0; }

	FORCE_INLINE void SetHitTimeIndex(xGameOptions &xGameSettings, int iHitTime);

	DWORD	 m_dwBeatTimes[BB_MAXBEATS];
	int		 m_iNumBeats;
	int		 m_iCurBeatIndex;
	bool	 m_bAddedBlockAlready;

	int		 m_dwLastHitTime;
	int		 m_iHitTimeIndex;
	float	m_fHitTimeScale;
};

void xBeatManager::SetHitTimeIndex(xGameOptions &xGameSettings, int iHitTime)
{
	if(iHitTime <= BB_HITTIME5)
		m_iHitTimeIndex = 5;
	else if(xGameSettings.m_iHitTime >= BB_HITTIME4)
	{
		if(iHitTime <= BB_HITTIME4)
			m_iHitTimeIndex = 4;
		else if(xGameSettings.m_iHitTime >= BB_HITTIME3)
		{
			if(iHitTime <= BB_HITTIME3)
				m_iHitTimeIndex = 3;
			else if(xGameSettings.m_iHitTime >= BB_HITTIME2) 
			{
				if(iHitTime <= BB_HITTIME2)
					m_iHitTimeIndex = 2;
				else if(xGameSettings.m_iHitTime >= BB_HITTIME1)
				{
					if(iHitTime <= BB_HITTIME1 || !xGameSettings.m_bShowMissed)
						m_iHitTimeIndex = 1;
					else
						m_iHitTimeIndex = 0;
				}
				else
					m_iHitTimeIndex = 0;
			}
			else
				m_iHitTimeIndex = 0;
		}
		else
			m_iHitTimeIndex = 0;
	}
	else
		m_iHitTimeIndex = 0;

	m_fHitTimeScale = (float)m_iHitTimeIndex / 5.0f * 0.75f + 0.75f;
}

#endif