/////////////////////////////////////////////////////////////////
// Name: xBlock.h
/////////////////////////////////////////////////////////////////
// Description:
// - Serves as a place holder for a block in a piece or field.
/////////////////////////////////////////////////////////////////
// - 7.15.2004, Update, Dayle Flowers(Xienen)
//   File Created
/////////////////////////////////////////////////////////////////
// - 7.26.2004, Update, Greg Feldman
//	 Modified xBlock to use xList instead of hard-coded next and
//	 prev pointers
/////////////////////////////////////////////////////////////////
// - 9.12.2004, Update Greg Feldman
//   added fields to keep track of the number of lines cleared
//   so  that the score can be calculated
/////////////////////////////////////////////////////////////////
#ifndef XBLOCK_H_
#define XBLOCK_H_

#include "xList.h"

enum xBlockType
{
	TEMPLATE = -1,
	NOT_SPECIAL,
};

struct xBlock
{
	xBlock()
	{
		m_iRowID				= 0;
		m_iColumnID				= 0;
		m_pBlockObject			= 0;
		m_iType					= NOT_SPECIAL;
		m_iColorIndex			= -1;
		m_iUnfilledColorIndex	= -1;
		m_iNewColorIndex		= -1;
		m_bClearable			= 0;

		m_pNext	= 0;
		m_pPrev	= 0;
	}

	int					  m_iRowID;
	int					  m_iColumnID;
	xRenderable2DQuad	 *m_pBlockObject;
	xRenderable2DQuad	 *m_pBlockGlowObject;
	xRenderable2DQuad	 *m_pBlockOverlayObject;
	xTexture			 *m_pBlockTexture;
	xTexture			**m_pBuildArrowTextures;
	xTexture			 *m_pShadowTexture;
	xBlockType			  m_iType;
	int					  m_iColorIndex;
	int					  m_iUnfilledColorIndex;
	int					  m_iNewColorIndex;
	DWORD				  m_dwColorAnimStartTime;
	int					  m_bClearable;

	xBlock	*m_pNext;
	xBlock	*m_pPrev;
};

#endif