#ifndef XENGINEDEFINES_H_
#define XENGINEDEFINES_H_

#define FORCE_INLINE	inline//__attribute__((always_inline))

//#define __FRAGSHADER_NOARB

#define PI 3.1415926536

// Shader Parameter Index Defines
#define	PE_SHADERPARAM_ALPHA_GREYSCALE		0
#define	PE_SHADERPARAM_MASKED_TEXTUREOFFSET	0
#define	PE_SHADERPARAM_MASKED_TEXTURERATIO	1
#define	PE_SHADERPARAM_MASKED_GREYSCALE		2
#define	PE_SHADERPARAM_2COLOR_COLOR2		0
#define	PE_SHADERPARAM_2COLOR_COLORDIFF		1
#define	PE_SHADERPARAM_2COLOR_GREYSCALE		2

#define stricmp strcasecmp

#ifdef _WIN32
typedef	__int16				int16;
typedef	unsigned __int8		uint8_t;
typedef	unsigned __int16	uint16_t;
typedef	unsigned __int32	uint32_t;
#else
typedef	SInt16		int16;
typedef	UInt8		uint8_t;
typedef	UInt16		uint16_t;
typedef UInt32		DWORD;

struct RECT
{
	SInt32 left;
	SInt32 top;
	SInt32 right;
	SInt32 bottom;	
};
#endif

#define PE_UINT16_UPPER8BITS	0xff00
#define PE_UINT16_LOWER8BITS	0x00ff

enum xBlendModes
{
	PE_BLEND_MODE_ALPHA = 0,
	PE_BLEND_MODE_ALPHA_NOSHADER,
	PE_BLEND_MODE_INVERTED_COLOR,
	PE_BLEND_MODE_MASKED,
	PE_BLEND_MODE_2COLOR,
	PE_BLEND_MODE_NONE_OUTLINED,
	PE_BLEND_MODE_NONE
};

#define dlmalloc malloc
#define dlfree free

inline char* itoa(int iValue, char *strOut, int iBase)
{
	int decimal = 1000000000;
	int position = 0;
	bool started = false;
	
	while(decimal > 0)
	{
		if(iValue >= decimal || started)
		{
			strOut[position++] = '0' + iValue / decimal;
			iValue = iValue % decimal;
			started = true;
		}
		
		decimal /= 10;
	}
	
	strOut[position] = '\0';
	
	return strOut;
}

#ifndef FINAL_RELEASE
class xFileIO;
extern xFileIO g_xLog;
#ifndef CREATELOG
#define DEBUGCHECK(x)	if(x) assert(0);
#define CREATELOG()		if(!g_xLog.IsOpen()) { if(g_xPaperAPI.m_iNetMode == PE_NETMODE_LISTENSERVER) g_xLog.OpenFile("ServerLog.txt", false, false); else g_xLog.OpenFile("ClientLog.txt", false, false); }
#define	LOG(...)		if(g_xLog.IsOpen()) { char temp[10240]; sprintf(temp, __VA_ARGS__); g_xLog.WriteString(temp); }
#define	DEBUGLOG(...)	{ printf(__VA_ARGS__); }
#endif
#else
#define DEBUGCHECK(x)	NULL
#define CREATELOG()		NULL
#define	LOG(...)		NULL
#define	DEBUGLOG(...)	NULL
#endif

#endif