#include "Paper.h"

int xGUICheckBox::LoadObject(const char *strThemeName)
{
	char *tempvariable;

	xGUIObject::LoadObject(strThemeName);

	m_bChecked = m_pParser->ToBool("m_bChecked");

	tempvariable = m_pParser->GetVariable("m_strBackground");
	if(!tempvariable || tempvariable[0] == '\0')
		sprintf(m_strBackgroundPath, "data/Themes/%s/CheckBoxBG.p2d", strThemeName);
	else
		strcpy(m_strBackgroundPath, tempvariable);

	m_pBackground = xSceneGraphCreateQuad(m_strBackgroundPath, m_bChecked ? PE_GUI_CHECKBOXSTATE_CHECKED : PE_GUI_CHECKBOXSTATE_NONE);
	xRenderable2DQuadSetPosition(m_pBackground, GetAbsoluteX(), GetAbsoluteY());
	xRenderable2DQuadSetSize(m_pBackground, GetWidth(), GetHeight());
	xRenderable2DQuadSetRotation(m_pBackground, GetRotation());

	if(m_bStretch)
	{
		xSceneGraphInsertQuad(m_pSceneGraph, m_pBackground, 9, GetAbsoluteDepth(), 0, 1);
		xRenderable2DQuad9Update(m_pBackground);
	}
	else
	{
		xSceneGraphInsertQuad(m_pSceneGraph, m_pBackground, 1, GetAbsoluteDepth(), 0, 1);
		xRenderable2DQuadUpdate(m_pBackground);
	}

	xGraphicsGetTextures(m_strBackgroundPath, &m_pTextures);

	tempvariable = m_pParser->GetVariable("m_strText");
	if(tempvariable && tempvariable[0] != '\0')
	{
		m_pTextObject				= new xGUIText;
		m_pTextObject->m_pParent	= this;
		m_pTextObject->m_pFont		= m_pFont;
		m_pTextObject->m_bDisabled	= m_bDisabled;
		m_pTextObject->SetX(GetWidth() + 3);
		m_pTextObject->SetY(0);
		m_pTextObject->SetWidth(xFontGetWidth(m_pFont, tempvariable));
		m_pTextObject->SetHeight(GetHeight());
		m_pTextObject->SetText(tempvariable);

		m_pParser->ToColor("m_colText", &m_pTextObject->m_xRenderable.m_xColor);
		m_pParser->ToColor("m_colDisabledText", &m_pTextObject->m_xDisabledColor);
		m_pParser->ToColor("m_colHoverText", &m_pTextObject->m_xHoverColor);
	}

	return PE_RES_NOERROR;
}

void xGUICheckBoxPreUpdate(xGUIObject* pThis, DWORD dwTime)
{
	if(!pThis->m_pParent->GetAbsoluteFocus())
		pThis->m_bHasFocus = false;

	xGUIObjectPreUpdate(pThis, dwTime);

	if(pThis->m_bDisabled)
	{
		pThis->m_bClicked = false;
		pThis->UpdateState(false, dwTime);
		((xGUICheckBox*)pThis)->m_bWasClicked = false;
		((xGUICheckBox*)pThis)->SetState(PE_GUI_CHECKBOXSTATE_CLICKED);
		pThis->m_bHasFocus = false;
	}

	if(((xGUICheckBox*)pThis)->m_pTextObject)
		((xGUICheckBox*)pThis)->m_pTextObject->m_bDisabled = pThis->m_bDisabled;

	if((g_xPaperAPI.m_xInput.m_lMouseX >= pThis->GetAbsoluteX() && g_xPaperAPI.m_xInput.m_lMouseX <= pThis->GetAbsoluteX() + pThis->GetWidth() &&
	    g_xPaperAPI.m_xInput.m_lMouseY >= pThis->GetAbsoluteY() && g_xPaperAPI.m_xInput.m_lMouseY <= pThis->GetAbsoluteY() + pThis->GetHeight()) ||
	   (((xGUICheckBox*)pThis)->m_pTextObject && g_xPaperAPI.m_xInput.m_lMouseX >= ((xGUICheckBox*)pThis)->m_pTextObject->GetAbsoluteX() && 
	    g_xPaperAPI.m_xInput.m_lMouseX <= ((xGUICheckBox*)pThis)->m_pTextObject->GetAbsoluteX() + ((xGUICheckBox*)pThis)->m_pTextObject->GetWidth() &&
	    g_xPaperAPI.m_xInput.m_lMouseY >= ((xGUICheckBox*)pThis)->m_pTextObject->GetAbsoluteY() &&
		g_xPaperAPI.m_xInput.m_lMouseY <= ((xGUICheckBox*)pThis)->m_pTextObject->GetAbsoluteY() + ((xGUICheckBox*)pThis)->m_pTextObject->GetHeight()))
	{
		if(!pThis->m_bDisabled && !pThis->GetAbsoluteHidden())
		{
			if(g_xPaperAPI.m_xInput.m_buttonMouseLeft.JustPressed(true))
			{
				g_xPaperAPI.m_xInput.m_buttonMouseLeft.Eaten();

				pThis->UpdateState(true, dwTime);

				((xGUICheckBox*)pThis)->SetState(PE_GUI_CHECKBOXSTATE_CLICKED);
				((xGUICheckBox*)pThis)->m_bWasClicked = true;
				pThis->m_bHasFocus = true;
			}
			else
			{
				if(g_xPaperAPI.m_xInput.m_buttonMouseLeft.IsDown())
				{
					pThis->UpdateState(true, dwTime);

					if(((xGUICheckBox*)pThis)->m_bWasClicked)
						((xGUICheckBox*)pThis)->SetState(PE_GUI_CHECKBOXSTATE_CLICKED);
					else if(((xGUICheckBox*)pThis)->m_bChecked)
						((xGUICheckBox*)pThis)->SetState(PE_GUI_CHECKBOXSTATE_CHECKED);
					else
						((xGUICheckBox*)pThis)->SetState(PE_GUI_CHECKBOXSTATE_NONE);
				}
				else
				{
					if(((xGUICheckBox*)pThis)->m_bWasClicked)
					{
						pThis->m_bClicked = true;
						((xGUICheckBox*)pThis)->m_bChecked = !((xGUICheckBox*)pThis)->m_bChecked;

						if(pThis->m_strLClickCommand)
							pThis->m_pGUI->pfnRunInputCommand(pThis->m_strLClickCommand, pThis->m_strLClickParams, pThis->m_pOwningWindow, pThis);

						pThis->UpdateState(false, dwTime);
						((xGUICheckBox*)pThis)->m_bWasClicked = false;
					}
					else
					{
						pThis->m_bClicked = false;

						if(((xGUICheckBox*)pThis)->m_bChecked)
							((xGUICheckBox*)pThis)->SetState(PE_GUI_CHECKBOXSTATE_CHECKEDHOVER);
						else
							((xGUICheckBox*)pThis)->SetState(PE_GUI_CHECKBOXSTATE_HOVER);
					}
				}
			}
		}

		if(pThis->m_pParent->GetAbsoluteFocus())
		{
			if(!pThis->m_bHovered)
			{
				pThis->m_bHovered = 1;
				pThis->m_bRanHoveredCommand = 0;
				pThis->m_dwHoverStateTime = dwTime;

				if(!pThis->m_bDisabled && !pThis->GetAbsoluteHidden())
				{
					if(((xGUICheckBox*)pThis)->m_bChecked)
						((xGUICheckBox*)pThis)->SetState(PE_GUI_CHECKBOXSTATE_CHECKEDHOVER);
					else
						((xGUICheckBox*)pThis)->SetState(PE_GUI_CHECKBOXSTATE_HOVER);
				}
			}
			else if(!pThis->m_bRanHoveredCommand && pThis->m_strHoverCommand && dwTime - pThis->m_dwHoverStateTime > pThis->m_dwHoverDelay)
				pThis->m_pGUI->RunHoverCommand(pThis);
		}
		else
		{
			if(((xGUICheckBox*)pThis)->m_bChecked)
				((xGUICheckBox*)pThis)->SetState(PE_GUI_CHECKBOXSTATE_CHECKED);
			else
				((xGUICheckBox*)pThis)->SetState(PE_GUI_CHECKBOXSTATE_NONE);
		}
	}
	else
	{
		if(!((xGUICheckBox*)pThis)->m_bWasClicked)
			pThis->m_bClicked = false;

		pThis->m_bHovered = false;

		if(!pThis->m_bDisabled)
		{
			if(((xGUICheckBox*)pThis)->m_bChecked)
				((xGUICheckBox*)pThis)->SetState(PE_GUI_CHECKBOXSTATE_CHECKED);
			else
				((xGUICheckBox*)pThis)->SetState(PE_GUI_CHECKBOXSTATE_NONE);
		}

		pThis->UpdateState(false, dwTime);

		if(g_xPaperAPI.m_xInput.m_buttonMouseLeft.JustPressed())
			pThis->m_bHasFocus = false;
	}
}

void xGUICheckBoxClearState(xGUIObject* pThis, DWORD dwTime)
{
	pThis->m_bHasFocus = false;
	pThis->m_bHovered = false;
	pThis->m_bClicked = false;
	pThis->UpdateState(false, dwTime);
	((xGUICheckBox*)pThis)->m_bWasClicked = false;
	((xGUICheckBox*)pThis)->m_bChecked = false;
	((xGUICheckBox*)pThis)->m_iCheckBoxState = PE_GUI_CHECKBOXSTATE_NONE;

	xGUIObjectClearState(pThis, dwTime);
}

void xGUICheckBoxUpdate(xGUIObject* pThis, double dTime)
{
	if(!pThis->m_pParent->GetAbsoluteFocus())
		pThis->m_bHasFocus = false;

	if(!pThis->m_bHasFocus)
		pThis->UpdateState(false, 0);

	if(!pThis->m_xAnimation.m_bDone)
	{
		xAnimationUpdate(&pThis->m_xAnimation, dTime);

		if(((xGUIButton*)pThis)->m_pTextObject)
			((xGUIButton*)pThis)->m_pTextObject->SetAlpha(pThis->GetAlpha());
	}

	if(((xGUICheckBox*)pThis)->m_pTextObject)
	{
		((xGUICheckBox*)pThis)->m_pTextObject->m_bHovered = ((xGUICheckBox*)pThis)->m_iCheckBoxState == PE_GUI_CHECKBOXSTATE_HOVER || ((xGUICheckBox*)pThis)->m_iCheckBoxState == PE_GUI_CHECKBOXSTATE_CLICKED;
		((xGUICheckBox*)pThis)->m_pTextObject->SetState(pThis->GetState());
		((xGUICheckBox*)pThis)->m_pTextObject->pfnUpdate(((xGUICheckBox*)pThis)->m_pTextObject, dTime);
	}

	xGUIObjectUpdate(pThis, dTime);
}

void xGUICheckBoxUpdateRenderables(xGUIObject* pThis)
{
	xColor tempcolor;

	xRenderable2DQuadSetPosition(((xGUICheckBox*)pThis)->m_pBackground, pThis->GetAbsoluteX(), pThis->GetAbsoluteY());
	xRenderable2DQuadSetSize(((xGUICheckBox*)pThis)->m_pBackground, pThis->GetWidth(), pThis->GetHeight());
	xRenderable2DQuadUpdateVisibility(((xGUICheckBox*)pThis)->m_pBackground, !pThis->GetAbsoluteHidden());
	xRenderable2DQuadUpdateAlpha(((xGUICheckBox*)pThis)->m_pBackground, pThis->GetAbsoluteColor(&tempcolor)->A);

	if(((xGUIImage*)pThis)->m_bStretch)
		xRenderable2DQuad9Update(((xGUICheckBox*)pThis)->m_pBackground);
	else
		xRenderable2DQuadUpdate(((xGUICheckBox*)pThis)->m_pBackground);
}

void xGUICheckBoxRefreshRenderables(xGUIObject* pThis)
{
	xGraphicsGetTextures(((xGUICheckBox*)pThis)->m_strBackgroundPath, &((xGUICheckBox*)pThis)->m_pTextures);
	((xGUICheckBox*)pThis)->SetState(((xGUICheckBox*)pThis)->m_iCheckBoxState);
}

void xGUICheckBox::Shutdown()
{
	xGUIObject::Shutdown();
}