#include "Paper.h"

void xGUIComboBox::InitRenderable(const char *strThemeName, const char *strTextBoxBackground, const char *strButtonBackground, const char *strListBoxBackground, const char *strListBoxSelectedBackground, const char *strScrollbarBackground, const char *strScrollUpArrowBackground, const char *strScrollDownArrowBackground, const char *strScrollThumb)
{
	char imagepath[256] = {0};

	m_xTextBox.m_pParent = this;
	m_xTextBox.m_pGUI = m_pGUI;
	m_xTextBox.m_pOwningWindow = m_pOwningWindow;
	m_xTextBox.m_pSceneGraph = m_pSceneGraph;
	m_xTextBox.m_pFont = m_pFont;
	m_xTextBox.m_bStretch = true;
	m_xTextBox.m_bEditable = false;
	m_xTextBox.m_fBorder = m_fTextBoxBorder;
	m_xTextBox.SetDepth(0.002);
	m_xTextBox.SetX(0.0);
	m_xTextBox.SetY(0.0);
	m_xTextBox.SetWidth(GetWidth());
	m_xTextBox.SetHeight(GetHeight());
	m_xTextBox.InitRenderable(strThemeName, strTextBoxBackground);

	if(!strButtonBackground || strButtonBackground[0] == '\0')
		sprintf(imagepath, "data/Themes/%s/ScrollDownArrowButtonBG.p2d", strThemeName);
	else
		strcpy(imagepath, strButtonBackground);

	m_xDownButton.Init();
	m_xDownButton.m_pParent = this;
	m_xDownButton.m_pGUI = m_pGUI;
	m_xDownButton.m_pOwningWindow = m_pOwningWindow;
	m_xDownButton.m_pSceneGraph = m_pSceneGraph;
	m_xDownButton.m_bStretch = 0;
	m_xDownButton.SetDepth(0.003);
	m_xDownButton.SetX(GetWidth() - m_fDownButtonWidth - m_fDownButtonButtonOffsetX);
	m_xDownButton.SetY(m_fDownButtonButtonOffsetY);
	m_xDownButton.SetWidth(m_fDownButtonWidth);
	m_xDownButton.SetHeight(m_fDownButtonHeight);
	m_xDownButton.InitRenderable(strThemeName, imagepath);

	m_xListBox.m_pParent = this;
	m_xListBox.m_pGUI = m_pGUI;
	m_xListBox.m_pOwningWindow = m_pOwningWindow;
	m_xListBox.m_pSceneGraph = m_pSceneGraph;
	m_xListBox.m_pFont = m_pFont;
	m_xListBox.m_bStretch = 1;
	m_xListBox.m_fItemSpacing = 0.0;
	m_xListBox.m_fBorder = m_fListBorder;
	m_xListBox.m_bScrollbar = 1;
	m_xListBox.m_fScrollbarOffset = m_fListScrollbarOffsetX;
	m_xListBox.m_iScrollbarWidth = m_fListScrollbarWidth;
	m_xListBox.SetDepth(0.001);
	m_xListBox.SetX(0.0);
	m_xListBox.SetY(GetHeight() - m_fListOffsetY);
	m_xListBox.SetWidth(GetWidth() - (m_bListScrollbarInset ? 0 : m_xListBox.m_iScrollbarWidth));
	m_xListBox.SetHeight(m_fListHeight);
	m_xListBox.SetHidden(1);
	m_xListBox.InitRenderable(strThemeName, strListBoxBackground, strListBoxSelectedBackground, strScrollbarBackground, strScrollUpArrowBackground, strScrollDownArrowBackground, strScrollThumb);

	m_iSelected = m_xListBox.m_iSelected;
}

int xGUIComboBox::LoadObject(const char *strThemeName)
{
	m_xTextBox.m_xTextObject.Init();

	xGUIObject::LoadObject(strThemeName);

	m_fTextBoxBorder = m_pParser->ToFlt("m_fTextBoxBorder", 2.0);
	m_fDownButtonWidth = m_pParser->ToFlt("m_fDownButtonWidth", GetHeight());
	m_fDownButtonHeight = m_pParser->ToFlt("m_fDownButtonHeight", GetHeight());
	m_fDownButtonButtonOffsetX = m_pParser->ToFlt("m_fButtonOffsetX", 0.0);
	m_fDownButtonButtonOffsetY = m_pParser->ToFlt("m_fButtonOffsetY", 0.0);
	m_fListHeight = m_pParser->ToFlt("m_fListHeight", 100);
	m_fListBorder = m_pParser->ToFlt("m_fListBorder", 4.0);
	m_fListOffsetY = m_pParser->ToFlt("m_fListOffsetY", 0.0);
	m_bListScrollbarInset = m_pParser->ToBool("m_bListScrollbarInset");
	m_fListScrollbarOffsetX = m_pParser->ToFlt("m_fListScrollbarOffsetX", m_fListBorder);
	m_fListScrollbarWidth = m_pParser->ToFlt("m_fListScrollbarWidth", 16.0);

	m_xTextBox.m_iMaxLength = m_pParser->ToInt("m_iMaxTextLength");

	m_pParser->ToColor("m_colText", &m_xTextBox.m_xTextObject.m_xNormalColor);
	m_pParser->ToColor("m_colOutline", &m_xTextBox.m_xTextObject.m_xOutlineColor);

	InitRenderable(strThemeName, m_pParser->GetVariable("m_strBackground"), m_pParser->GetVariable("m_strButtonBackground"), m_pParser->GetVariable("m_strListBoxBackground"), m_pParser->GetVariable("m_strListBoxSelectedBackground"), m_pParser->GetVariable("m_strScrollbarBackground"), m_pParser->GetVariable("m_strScrollUpArrowBackground"), m_pParser->GetVariable("m_strScrollDownArrowBackground"), m_pParser->GetVariable("m_strScrollThumb"));

	return PE_RES_NOERROR;
}

void xGUIComboBoxPreUpdate(xGUIObject* pThis, DWORD dwTime)
{
	if(!pThis->m_pParent->GetAbsoluteFocus())
		pThis->m_bHasFocus = false;

	xGUIObjectPreUpdate(pThis, dwTime);

	if(pThis->m_bDisabled || pThis->GetAbsoluteHidden())
		((xGUIScrollbar*)pThis)->m_bDragging = false;

	((xGUIComboBox*)pThis)->m_xDownButton.pfnPreUpdate(&((xGUIComboBox*)pThis)->m_xDownButton, dwTime);

	if(((xGUIComboBox*)pThis)->m_bListVisible)
		((xGUIComboBox*)pThis)->m_xListBox.pfnPreUpdate(&((xGUIComboBox*)pThis)->m_xListBox, dwTime);

	if(((xGUIComboBox*)pThis)->m_xDownButton.m_bClicked)
	{
		((xGUIComboBox*)pThis)->m_bListVisible = !((xGUIComboBox*)pThis)->m_bListVisible;

		((xGUIComboBox*)pThis)->m_xListBox.SetHidden(!((xGUIComboBox*)pThis)->m_bListVisible);
		((xGUIComboBox*)pThis)->UpdateRenderables();
	}
	else if(((xGUIComboBox*)pThis)->m_xListBox.m_iSelected != ((xGUIComboBox*)pThis)->m_iSelected)
	{
		((xGUIComboBox*)pThis)->m_iSelected = ((xGUIComboBox*)pThis)->m_xListBox.m_iSelected;

		((xGUIComboBox*)pThis)->m_xTextBox.SetText(((xGUIComboBox*)pThis)->m_xListBox.GetSelectedString());

		((xGUIComboBox*)pThis)->m_bListVisible = false;
		((xGUIComboBox*)pThis)->m_xListBox.SetHidden(true);
		((xGUIComboBox*)pThis)->UpdateRenderables();

		if(pThis->m_strLClickCommand)
			pThis->m_pGUI->pfnRunInputCommand(pThis->m_strLClickCommand, pThis->m_strLClickParams, pThis->m_pOwningWindow, pThis);
	}
}

/*void xGUIComboBoxUpdate(xGUIObject* pThis, double dTime)
{
	xGUIObjectUpdate(pThis, dTime);
}*/

void xGUIComboBoxUpdateRenderables(xGUIObject* pThis)
{
	xGUITextBoxUpdateRenderables(&((xGUIComboBox*)pThis)->m_xTextBox);
	xGUIButtonUpdateRenderables(&((xGUIComboBox*)pThis)->m_xDownButton);
	xGUIListBoxUpdateRenderables(&((xGUIComboBox*)pThis)->m_xListBox);
}

void xGUIComboBoxRefreshRenderables(xGUIObject* pThis)
{
	xGUITextBoxRefreshRenderables(&((xGUIComboBox*)pThis)->m_xTextBox);
	xGUIButtonRefreshRenderables(&((xGUIComboBox*)pThis)->m_xDownButton);
	xGUIListBoxRefreshRenderables(&((xGUIComboBox*)pThis)->m_xListBox);
}

void xGUIComboBox::Shutdown()
{
	m_xListBox.Shutdown();
	m_xDownButton.Shutdown();
	m_xTextBox.Shutdown();
	
	xGUIObject::Shutdown();
}