#include "Paper.h"

int xGUIModel::LoadObject(const char *strThemeName)
{
	xGUIObject::LoadObject(strThemeName);

	m_fZ = m_pParser->ToFlt("m_iZ");
	m_iAnimArrayCount = m_pParser->ToIntArray("m_iAnimation", &m_pAnimArray);

	if(!m_pModel)
	{
		m_pModel = new xMD3Model;
		m_pModel->Init(m_pParser->GetVariable("m_strModel"), m_pAnimArray[m_iAnimArrayCount - 1] + 1, m_pSceneGraph, GetAbsoluteDepth());
	}

	m_pModel->pfnOnAnimationCompleted = &xGUIModelAnimationComplete;
	m_pModel->m_pAnimCompleteCallbackObject = this;

	xGUIModelAnimationComplete(m_pModel, this);
	m_pModel->SetTranslation(GetAbsoluteX(), GetAbsoluteY(), m_fZ);
	m_pModel->SetRotation(-180.0f, 0.0f, 0.0f);

	return PE_RES_NOERROR;
}

void xGUIModelPreUpdate(xGUIObject* pThis, DWORD dwTime)
{
	xGUIObjectPreUpdate(pThis, dwTime);

	((xGUIModel*)pThis)->m_pModel->PreUpdate(dwTime);
}

void xGUIModelUpdate(xGUIObject* pThis, double dTime)
{
	xGUIObjectUpdate(pThis, dTime);

	((xGUIModel*)pThis)->m_pModel->Update(dTime);
}

void xGUIModelUpdateRenderable(xGUIObject* pThis)
{
	((xGUIModel*)pThis)->m_pModel->SetTranslation(pThis->GetAbsoluteX(), pThis->GetAbsoluteY(), ((xGUIModel*)pThis)->m_pModel->m_vecTranslation.z);
}

void xGUIModelUpdateDepth(xGUIObject* pThis)
{
	//xRenderable2DQuadUpdateDepth(((xGUIImage*)pThis)->m_pImageObject, pThis->m_pSceneGraph, pThis->GetAbsoluteDepth());
}

void xGUIModelRefreshRenderables(xGUIObject* pThis)
{
	((xGUIModel*)pThis)->m_pModel->RefreshTextures();
}

void xGUIModel::Shutdown()
{
	xGUIObject::Shutdown();

	if(m_pModel)
	{
		m_pModel->Delete();
		delete m_pModel;
		m_pModel = 0;
	}
}

void xGUIModelAnimationComplete(xMD3Model* pModel, void *pCallbackObject)
{
	pModel->SetAnimation(((xGUIModel*)pCallbackObject)->m_pAnimArray[rand() % ((xGUIModel*)pCallbackObject)->m_iAnimArrayCount], 100);
}