/////////////////////////////////////////////////////////////////
// Name: xGUIModel.h
/////////////////////////////////////////////////////////////////
// Description:
// - This handles 3D Models for the GUI.
/////////////////////////////////////////////////////////////////
// - 01.23.2010, Note, DayleFlowers (Xienen)
//   File created
/////////////////////////////////////////////////////////////////
#ifndef XGUIMODEL_H_
#define XGUIMODEL_H_

#include "xGUIObject.h"

void xGUIModelPreUpdate(xGUIObject* pThis, DWORD dwTime);
void xGUIModelUpdate(xGUIObject* pThis, double dTime);
void xGUIModelUpdateRenderable(xGUIObject* pThis);
void xGUIModelUpdateDepth(xGUIObject* pThis);
void xGUIModelRefreshRenderables(xGUIObject* pThis);
void xGUIModelAnimationComplete(xMD3Model* pModel, void *pCallbackObject);

class xGUIModel : public xGUIObject
{
public:
	xGUIModel()
	{
		pfnPreUpdate			= &xGUIModelPreUpdate;
		pfnUpdate				= &xGUIModelUpdate;
		pfnUpdateRenderables	= &xGUIModelUpdateRenderable;
		pfnUpdateDepth			= &xGUIModelUpdateDepth;
		pfnRefreshRenderables	= &xGUIModelRefreshRenderables;

		m_pModel = 0;
	}

	int  LoadObject(const char *strThemeName);
	void Shutdown();

	void SetModel(const char *strNewModel) { if(m_pModel) m_pModel->Delete(); m_pModel->Init(strNewModel, m_pAnimArray[m_iAnimArrayCount - 1] + 1, m_pSceneGraph, GetAbsoluteDepth()); m_pModel->SetAnimation(m_pAnimArray[0], 100); }

	xMD3Model	*m_pModel;
	float		 m_fZ;
	int			*m_pAnimArray;
	int			 m_iAnimArrayCount;
};

#endif