#include "Paper.h"

void xGUIScrollbar::InitRenderable(const char *strThemeName, const char *strBackground, const char *strThumb, const char *strUpLeftArrow, const char* strDownRightArrow)
{
	char imagepath[256] = {0};

	if(!strUpLeftArrow || strUpLeftArrow[0] == '\0')
		sprintf(imagepath, "data/Themes/%s/ScrollUpArrowButtonBG.p2d", strThemeName);
	else
		strcpy(imagepath, strUpLeftArrow);

	m_pUpArrowButton = new xGUIButton;
	m_pUpArrowButton->Init();
	m_pUpArrowButton->m_pParent = this;
	m_pUpArrowButton->m_pGUI = m_pGUI;
	m_pUpArrowButton->m_pOwningWindow = m_pOwningWindow;
	m_pUpArrowButton->m_pSceneGraph = m_pSceneGraph;
	m_pUpArrowButton->m_bStretch = false;
	m_pUpArrowButton->SetDepth(0.003);
	m_pUpArrowButton->SetX(0);
	m_pUpArrowButton->SetY(0);
	m_pUpArrowButton->SetWidth(m_fScrollButtonWidth);
	m_pUpArrowButton->SetHeight(m_fScrollButtonHeight);
	m_pUpArrowButton->InitRenderable(strThemeName, imagepath);

	if(!strDownRightArrow || strDownRightArrow[0] == '\0')
		sprintf(imagepath, "data/Themes/%s/ScrollDownArrowButtonBG.p2d", strThemeName);
	else
		strcpy(imagepath, strDownRightArrow);

	m_pDownArrowButton = new xGUIButton;
	m_pDownArrowButton->Init();
	m_pDownArrowButton->m_pParent = this;
	m_pDownArrowButton->m_pGUI = m_pGUI;
	m_pDownArrowButton->m_pOwningWindow = m_pOwningWindow;
	m_pDownArrowButton->m_pSceneGraph = m_pSceneGraph;
	m_pDownArrowButton->m_bStretch = false;
	m_pDownArrowButton->SetDepth(0.003);
	m_pDownArrowButton->SetX(0);
	m_pDownArrowButton->SetY(GetHeight() - m_fScrollButtonHeight);
	m_pDownArrowButton->SetWidth(m_fScrollButtonWidth);
	m_pDownArrowButton->SetHeight(m_fScrollButtonHeight);
	m_pDownArrowButton->InitRenderable(strThemeName, imagepath);

	if(!strBackground || strBackground[0] == '\0')
		sprintf(imagepath, "data/Themes/%s/ScrollbarBG.p2d", strThemeName);
	else
		strcpy(imagepath, strBackground);

	m_pBackground = xSceneGraphCreateQuad(imagepath, 0);
	xRenderable2DQuadSetPosition(m_pBackground, GetAbsoluteX(), GetAbsoluteY() + m_fScrollButtonHeight);
	xRenderable2DQuadSetSize(m_pBackground, GetWidth(), GetHeight() - 2.0 * m_fScrollButtonHeight);
	xSceneGraphInsertQuad(m_pSceneGraph, m_pBackground, 3, GetAbsoluteDepth() + 0.001, 0, 1);
	xRenderable2DQuad3VerticalUpdate(m_pBackground);

	if(!strThumb || strThumb[0] == '\0')
		sprintf(imagepath, "data/Themes/%s/ScrollThumb.p2d", strThemeName);
	else
		strcpy(imagepath, strThumb);

	m_pThumb = xSceneGraphCreateQuad(imagepath, 0);
	xRenderable2DQuadSetPosition(m_pThumb, GetAbsoluteX(), GetAbsoluteY() + m_fScrollButtonHeight);
	xRenderable2DQuadSetSize(m_pThumb, GetWidth(), GetHeight() - 2.0 * m_fScrollButtonHeight);
	xSceneGraphInsertQuad(m_pSceneGraph, m_pThumb, 3, GetAbsoluteDepth() + 0.002, 0, 1);
	xRenderable2DQuad3VerticalUpdate(m_pThumb);
}

int xGUIScrollbar::LoadObject(const char *strThemeName)
{
	xGUIObject::LoadObject(strThemeName);

	InitRenderable(strThemeName, m_pParser->GetVariable("m_strBackground"), m_pParser->GetVariable("m_strThumb"), m_pParser->GetVariable("m_strUpArrow"), m_pParser->GetVariable("m_strDownArrow"));

	return PE_RES_NOERROR;
}

void xGUIScrollbarPreUpdate(xGUIObject* pThis, DWORD dwTime)
{
	if(!pThis->m_pParent->GetAbsoluteFocus())
		pThis->m_bHasFocus = false;

	xGUIObjectPreUpdate(pThis, dwTime);

	if(pThis->m_bDisabled || pThis->GetAbsoluteHidden())
		((xGUIScrollbar*)pThis)->m_bDragging = false;

	if(((xGUIScrollbar*)pThis)->m_pUpArrowButton)
	{
		((xGUIScrollbar*)pThis)->m_pUpArrowButton->pfnPreUpdate(((xGUIScrollbar*)pThis)->m_pUpArrowButton, dwTime);

		if(((xGUIScrollbar*)pThis)->m_pUpArrowButton->m_bClicked)
		{
			if(((xGUIScrollbar*)pThis)->m_iTopObject > 0)
			{
				((xGUIScrollbar*)pThis)->m_iTopObject--;
				xGUIScrollbarUpdateRenderables(pThis);
			}
		}
	}

	if(((xGUIScrollbar*)pThis)->m_pDownArrowButton)
	{
		((xGUIScrollbar*)pThis)->m_pDownArrowButton->pfnPreUpdate(((xGUIScrollbar*)pThis)->m_pDownArrowButton, dwTime);

		if(((xGUIScrollbar*)pThis)->m_pDownArrowButton->m_bClicked)
		{
			if(((xGUIScrollbar*)pThis)->m_iTopObject < ((xGUIScrollbar*)pThis)->m_iNumObjects - ((xGUIScrollbar*)pThis)->m_iVisibleObjects)
			{
				((xGUIScrollbar*)pThis)->m_iTopObject++;
				xGUIScrollbarUpdateRenderables(pThis);
			}
		}
	}

	if(((xGUIScrollbar*)pThis)->m_bDragging)
	{
		if(g_xPaperAPI.m_xInput.m_buttonMouseLeft.IsDown())
		{
			((xGUIScrollbar*)pThis)->m_pThumb->m_xRenderable2D.m_fY = g_xPaperAPI.m_xInput.m_lMouseY - ((xGUIScrollbar*)pThis)->m_dwThumbClickOffset;

			if(((xGUIScrollbar*)pThis)->m_pThumb->m_xRenderable2D.m_fY < pThis->GetAbsoluteY() + ((xGUIScrollbar*)pThis)->m_fScrollButtonHeight)
				((xGUIScrollbar*)pThis)->m_pThumb->m_xRenderable2D.m_fY = pThis->GetAbsoluteY() + ((xGUIScrollbar*)pThis)->m_fScrollButtonHeight;
			else if(((xGUIScrollbar*)pThis)->m_pThumb->m_xRenderable2D.m_fY + ((xGUIScrollbar*)pThis)->m_pThumb->m_xRenderable2D.m_fHeight > pThis->GetAbsoluteY() + pThis->GetHeight() - ((xGUIScrollbar*)pThis)->m_fScrollButtonHeight)
				((xGUIScrollbar*)pThis)->m_pThumb->m_xRenderable2D.m_fY = pThis->GetAbsoluteY() + pThis->GetHeight() - ((xGUIScrollbar*)pThis)->m_fScrollButtonHeight - ((xGUIScrollbar*)pThis)->m_pThumb->m_xRenderable2D.m_fHeight;

			if(((xGUIScrollbar*)pThis)->m_iNumObjects - ((xGUIScrollbar*)pThis)->m_iVisibleObjects > 0)
			{
				float objectsize = (pThis->GetHeight() - 2.0 * ((xGUIScrollbar*)pThis)->m_fScrollButtonHeight) / (float)((xGUIScrollbar*)pThis)->m_iNumObjects;
				((xGUIScrollbar*)pThis)->m_iTopObject = (((xGUIScrollbar*)pThis)->m_pThumb->m_xRenderable2D.m_fY - pThis->GetAbsoluteY() - ((xGUIScrollbar*)pThis)->m_fScrollButtonHeight) / objectsize;
			}

			xRenderable2DQuad3VerticalUpdate(((xGUIScrollbar*)pThis)->m_pThumb);
		}
		else
			((xGUIScrollbar*)pThis)->m_bDragging = false;
	}
	else if(g_xPaperAPI.m_xInput.m_lMouseX >= pThis->GetAbsoluteX() && g_xPaperAPI.m_xInput.m_lMouseX <= pThis->GetAbsoluteX() + pThis->GetWidth() &&
			g_xPaperAPI.m_xInput.m_lMouseY >= pThis->GetAbsoluteY() && g_xPaperAPI.m_xInput.m_lMouseY <= pThis->GetAbsoluteY() + pThis->GetHeight())
	{
		if(!pThis->m_bDisabled && !pThis->GetAbsoluteHidden())
		{
			if(g_xPaperAPI.m_xInput.m_buttonMouseLeft.JustPressed(true))
			{
				g_xPaperAPI.m_xInput.m_buttonMouseLeft.Eaten();

				if(g_xPaperAPI.m_xInput.m_lMouseX >= ((xGUIScrollbar*)pThis)->m_pThumb->m_xRenderable2D.m_fX && g_xPaperAPI.m_xInput.m_lMouseX <= ((xGUIScrollbar*)pThis)->m_pThumb->m_xRenderable2D.m_fX + ((xGUIScrollbar*)pThis)->m_pThumb->m_xRenderable2D.m_fWidth &&
				   g_xPaperAPI.m_xInput.m_lMouseY >= ((xGUIScrollbar*)pThis)->m_pThumb->m_xRenderable2D.m_fY && g_xPaperAPI.m_xInput.m_lMouseY <= ((xGUIScrollbar*)pThis)->m_pThumb->m_xRenderable2D.m_fY + ((xGUIScrollbar*)pThis)->m_pThumb->m_xRenderable2D.m_fHeight)
				{
					((xGUIScrollbar*)pThis)->m_dwThumbClickOffset = g_xPaperAPI.m_xInput.m_lMouseY - ((xGUIScrollbar*)pThis)->m_pThumb->m_xRenderable2D.m_fY;
					((xGUIScrollbar*)pThis)->m_bDragging = true;
				}
			}
		}
	}
	else
	{
		if(g_xPaperAPI.m_xInput.m_buttonMouseLeft.JustPressed())
			pThis->m_bHasFocus = false;
	}
}

void xGUIScrollbarUpdate(xGUIObject* pThis, double dTime)
{
	if(!pThis->m_pParent->GetAbsoluteFocus())
		pThis->m_bHasFocus = false;

	if(!pThis->m_xAnimation.m_bDone)
		xAnimationUpdate(&pThis->m_xAnimation, dTime);

	if(((xGUIScrollbar*)pThis)->m_pUpArrowButton)
		((xGUIScrollbar*)pThis)->m_pUpArrowButton->pfnUpdate(((xGUIScrollbar*)pThis)->m_pUpArrowButton, dTime);

	if(((xGUIScrollbar*)pThis)->m_pDownArrowButton)
		((xGUIScrollbar*)pThis)->m_pDownArrowButton->pfnUpdate(((xGUIScrollbar*)pThis)->m_pDownArrowButton, dTime);

	xGUIObjectUpdate(pThis, dTime);
}

void xGUIScrollbarUpdateRenderables(xGUIObject* pThis)
{
	xColor tempcolor;
	float scrollarea = pThis->GetHeight() - 2.0 * ((xGUIScrollbar*)pThis)->m_fScrollButtonHeight;
	float objectsize = scrollarea / (float)((xGUIScrollbar*)pThis)->m_iNumObjects;

	xRenderable2DQuadUpdateVisibility(((xGUIScrollbar*)pThis)->m_pBackground, !pThis->GetAbsoluteHidden());
	xRenderable2DQuadUpdateVisibility(((xGUIScrollbar*)pThis)->m_pThumb, !pThis->GetAbsoluteHidden());

	xGUIButtonUpdateRenderables(((xGUIScrollbar*)pThis)->m_pUpArrowButton);
	xGUIButtonUpdateRenderables(((xGUIScrollbar*)pThis)->m_pDownArrowButton);

	xRenderable2DQuadUpdateAlpha(((xGUIScrollbar*)pThis)->m_pBackground, pThis->GetAbsoluteColor(&tempcolor)->A);
	xRenderable2DQuadSetPosition(((xGUIScrollbar*)pThis)->m_pBackground, pThis->GetAbsoluteX(), pThis->GetAbsoluteY() + ((xGUIScrollbar*)pThis)->m_fScrollButtonHeight);
	xRenderable2DQuadSetSize(((xGUIScrollbar*)pThis)->m_pBackground, pThis->GetWidth(), scrollarea);
	xRenderable2DQuad3VerticalUpdate(((xGUIScrollbar*)pThis)->m_pBackground);

	xRenderable2DQuadUpdateAlpha(((xGUIScrollbar*)pThis)->m_pThumb, tempcolor.A);
	xRenderable2DQuadSetPosition(((xGUIScrollbar*)pThis)->m_pThumb, pThis->GetAbsoluteX(), pThis->GetAbsoluteY() + ((xGUIScrollbar*)pThis)->m_fScrollButtonHeight + (float)((xGUIScrollbar*)pThis)->m_iTopObject * objectsize);
	xRenderable2DQuadSetSize(((xGUIScrollbar*)pThis)->m_pThumb, pThis->GetWidth(), (float)((xGUIScrollbar*)pThis)->m_iVisibleObjects * objectsize);
	xRenderable2DQuad3VerticalUpdate(((xGUIScrollbar*)pThis)->m_pThumb);
}

void xGUIScrollbarRefreshRenderables(xGUIObject* pThis)
{
	xRenderable2DQuadUpdateTexture(((xGUIScrollbar*)pThis)->m_pBackground, ((xGUIScrollbar*)pThis)->m_pBackground->m_pTextures[0]);
	xRenderable2DQuadUpdateTexture(((xGUIScrollbar*)pThis)->m_pThumb, ((xGUIScrollbar*)pThis)->m_pThumb->m_pTextures[0]);

	xGUIButtonRefreshRenderables(((xGUIScrollbar*)pThis)->m_pUpArrowButton);
	xGUIButtonRefreshRenderables(((xGUIScrollbar*)pThis)->m_pDownArrowButton);
}

void xGUIScrollbar::Shutdown()
{
	xGUIObject::Shutdown();

	if(m_pBackground)
		xSceneGraphDeleteQuad(m_pSceneGraph, m_pBackground, true);

	if(m_pThumb)
		xSceneGraphDeleteQuad(m_pSceneGraph, m_pThumb, true);

	if(m_pUpArrowButton)
	{
		m_pUpArrowButton->Shutdown();
		delete m_pUpArrowButton;
	}

	if(m_pDownArrowButton)
	{
		m_pDownArrowButton->Shutdown();
		delete m_pDownArrowButton;
	}
}
