/////////////////////////////////////////////////////////////////
// Name: xGUIScrollbar.h
/////////////////////////////////////////////////////////////////
// Description:
// - This handles scrollbars for the GUI.
/////////////////////////////////////////////////////////////////
// - 07.11.2004, Note, DayleFlowers (Xienen)
//   File created
/////////////////////////////////////////////////////////////////
#ifndef XGUISCROLLBAR_H_
#define XGUISCROLLBAR_H_

#include "xGUIObject.h"
#include "xGUIButton.h"

void xGUIScrollbarPreUpdate(xGUIObject* pThis, DWORD dwTime);
void xGUIScrollbarUpdate(xGUIObject* pThis, double dTime);
void xGUIScrollbarUpdateRenderables(xGUIObject* pThis);
void xGUIScrollbarRefreshRenderables(xGUIObject* pThis);

class xGUIScrollbar : public xGUIObject
{
public:
	xGUIScrollbar()
	{
		pfnPreUpdate			= &xGUIScrollbarPreUpdate;
		pfnUpdate				= &xGUIScrollbarUpdate;
		pfnUpdateRenderables	= &xGUIScrollbarUpdateRenderables;
		pfnRefreshRenderables	= &xGUIScrollbarRefreshRenderables;

		m_pBackground		= 0;
		m_pThumb			= 0;
		m_pUpArrowButton	= 0;
		m_pDownArrowButton	= 0;
		m_bDragging			= false;
		m_iNumObjects		= 0;
		m_iVisibleObjects	= 1;
		m_iTopObject		= 0;
	}

	void InitRenderable(const char *strThemeName, const char *strBackground = 0, const char *strThumb = 0, const char *strUpLeftArrow = 0, const char* strDownRightArrow = 0);
	int  LoadObject(const char *strThemeName);
	void Shutdown();

	xRenderable2DQuad	*m_pBackground;
	xRenderable2DQuad	*m_pThumb;
	xGUIButton			*m_pUpArrowButton;
	xGUIButton			*m_pDownArrowButton;
	float				 m_fScrollButtonWidth;
	float				 m_fScrollButtonHeight;
	bool				 m_bDragging;
	DWORD				 m_dwThumbClickOffset;

	int	m_iNumObjects;
	int	m_iVisibleObjects;
	int	m_iTopObject;
};

#endif