#include "Paper.h"

void xGUIText::InitRenderable()
{
	xRenderable2DTextInit(&m_xText, GetAbsoluteDepth());
	xRenderable2DTextSetPosition(&m_xText, GetAbsoluteX(), GetAbsoluteY());
	xRenderable2DTextSetFont(&m_xText, m_pFont);
    
	if(m_bColorized)
		xRenderable2DTextSetDualColor(&m_xText, &m_xNormalColor, &m_xOutlineColor);
	else
		xRenderable2DSetColor(&m_xRenderable, &m_xNormalColor);
}

int xGUIText::LoadObject(const char *strThemeName)
{
	xGUIObject::LoadObject(strThemeName);

	m_xAlignment		= (xGUITextAlignment)m_pParser->ToInt("m_iAlignment");
	m_iMaxLength	= m_pParser->ToInt("m_iMaxLength");
	m_bMasked		= m_pParser->ToBool("m_bMasked");
	m_bUniqueColorData	= m_pParser->ToBool("m_bUniqueColorData");
	m_bColorized	= m_pParser->ToBool("m_bColorized");

	m_pParser->ToColor("m_colText", &m_xNormalColor);
	m_pParser->ToColor("m_colHoverText", &m_xHoverColor, &m_xNormalColor);
	m_pParser->ToColor("m_colDisabledText", &m_xDisabledColor, &m_xNormalColor);
	m_pParser->ToColor("m_colOutline", &m_xOutlineColor);

	InitRenderable();
    
	SetText(m_pParser->GetVariable("m_strText"));
    
	//See if m_strBuffer is a command
	char function[256] = {0}, **params;
	GetCommandAndParams(function, params, m_strBuffer);
	if(function[0] != '\0')
		ExecTextCommand(m_strBuffer, -1, function, params);
    
	if(m_xAlignment != PE_GUITEXT_ALIGNMENT_JUSTIFIED)
		SetWidth(xFontGetWidth(m_pFont, m_strBuffer));

	if(m_xAlignment != PE_GUITEXT_ALIGNMENT_JUSTIFIED)
		SetWidth(xFontGetWidth(m_pFont, m_strBuffer) * GetAbsoluteScaleX());

	SetHeight(xFontGetSize(m_pFont));
	UpdateAlignedPosition();
    
	char *tempvariable = m_pParser->GetVariable("m_strSelBGImage");
	if(tempvariable && !m_pSelectedEmitter && tempvariable[0] != '\0')
	{
		strcpy(m_strSelectedEmitter, tempvariable);

		m_pSelectedEmitter = new xEmitter;
		m_pSelectedEmitter->Init(tempvariable, GetAbsoluteDepth() - 0.001, 0, m_pSceneGraph);
        
		float widthadjust = m_pParser->ToFlt("m_fSelBGWidthAdjust");
		float heightadjust = m_pParser->ToFlt("m_fSelBGHeightAdjust");
        
		m_pSelectedEmitter->SetSize(GetWidth() + widthadjust, GetHeight() + heightadjust);
		m_pSelectedEmitter->SetPosition(GetAbsoluteX() - widthadjust / 2.0, GetAbsoluteY() + (GetHeight() + heightadjust) / 2.0);
        
		if(!m_bSelected)
			m_pSelectedEmitter->Kill();
	}
    
	m_iBufferLen = strlen(m_strBuffer);
    
	return PE_RES_NOERROR;
}

void xGUITextPreUpdate(xGUIObject* pThis, DWORD dwTime)
{
	xColor tempcolor;
    
	if(pThis->GetHidden() || !((xGUIText*)pThis)->m_strBuffer)
		return;
    
	xGUIObjectPreUpdate(pThis, dwTime);

	if(!pThis->m_pParent->GetAbsoluteFocus())
		pThis->m_bHasFocus = false;
    
	if(pThis->m_bDisabled)
	{
		//DEBUGLOG("%s Disabled\n", ((xGUIText*)pThis)->m_strBuffer);
		pThis->m_bClicked = false;
		pThis->m_bHasFocus = false;
		pThis->m_bHovered = false;
        
		if(pThis->m_xAnimation.m_bDone)
		if(pThis->m_xAnimation.m_bDone)
			xRenderable2DTextUpdateColor(&((xGUIText*)pThis)->m_xText, xColorMultiply(&tempcolor, &((xGUIText*)pThis)->m_xDisabledColor, pThis->GetAbsoluteColor(&tempcolor)));
	}
	else if(pThis->m_bShouldSelect)
	{
		//DEBUGLOG("%s Should Select\n", ((xGUIText*)pThis)->m_strBuffer);
		if(pThis->m_pSelectionGroup && ((xGUIText*)pThis)->m_pSelectedEmitter)
		{
			if(!pThis->m_bSelected)
			{
				if(pThis->m_pHoverSound)
					pThis->m_pHoverSound->Play(g_xPaperAPI.m_fVolume);
                
				pThis->m_pSelectionGroup->ClearSelected();
				pThis->m_bSelected = true;
                
				((xGUIText*)pThis)->m_pSelectedEmitter->Reset();
			}
		}
        
		pThis->m_bShouldSelect = false;
	}
	else if(g_xPaperAPI.m_xInput.m_lMouseX > ((xGUIText*)pThis)->m_xText.m_xRenderable.m_xRenderable2D.m_fX && g_xPaperAPI.m_xInput.m_lMouseX < ((xGUIText*)pThis)->m_xText.m_xRenderable.m_xRenderable2D.m_fX + pThis->GetWidth() &&
			g_xPaperAPI.m_xInput.m_lMouseY > ((xGUIText*)pThis)->m_xText.m_xRenderable.m_xRenderable2D.m_fY && g_xPaperAPI.m_xInput.m_lMouseY < ((xGUIText*)pThis)->m_xText.m_xRenderable.m_xRenderable2D.m_fY + pThis->GetHeight())
	{
		//DEBUGLOG("%s mouse over\n", ((xGUIText*)pThis)->m_strBuffer);
		if(pThis->m_pParent->GetAbsoluteFocus())
		{
			if(!pThis->m_bHovered)
			{
				//DEBUGLOG("%s Hovering\n", ((xGUIText*)pThis)->m_strBuffer);
				pThis->m_bHovered = 1;
				pThis->m_bRanHoveredCommand = 0;
				pThis->m_dwHoverStateTime = dwTime;
                
				if(pThis->m_xAnimation.m_bDone)
				if(pThis->m_xAnimation.m_bDone)
					xRenderable2DTextUpdateColor(&((xGUIText*)pThis)->m_xText, xColorMultiply(&tempcolor, &((xGUIText*)pThis)->m_xHoverColor, pThis->GetAbsoluteColor(&tempcolor)));
                
				if(pThis->m_pSelectionGroup && ((xGUIText*)pThis)->m_pSelectedEmitter)
				{
					if(!pThis->m_bSelected)
					{
						if(pThis->m_pHoverSound)
							pThis->m_pHoverSound->Play(g_xPaperAPI.m_fVolume);
                        
						pThis->m_pSelectionGroup->ClearSelected();
						pThis->m_bSelected = true;
                        
						((xGUIText*)pThis)->m_pSelectedEmitter->Reset();
					}
				}
				else if(pThis->m_pHoverSound)
					pThis->m_pHoverSound->Play(g_xPaperAPI.m_fVolume);
			}
			else if(!pThis->m_bRanHoveredCommand && pThis->m_strHoverCommand && dwTime - pThis->m_dwHoverStateTime > pThis->m_dwHoverDelay)
				pThis->m_pGUI->RunHoverCommand(pThis);
		}
        
		if(g_xPaperAPI.m_xInput.m_buttonMouseLeft.JustPressed(true))
		{
			g_xPaperAPI.m_xInput.m_buttonMouseLeft.Eaten();
            
			pThis->m_bHasFocus = true;
			pThis->m_bClicked = true;
            
			if(pThis->m_strLClickCommand)
			{
				pThis->m_pGUI->pfnRunInputCommand(pThis->m_strLClickCommand, pThis->m_strLClickParams, pThis->m_pOwningWindow, pThis);
                
				if(pThis->m_pClickSound)
					pThis->m_pClickSound->Play(g_xPaperAPI.m_fVolume);
			}
		}
		else
			pThis->m_bClicked = false;
	}
	else if(pThis->m_bSelected)
	{
		pThis->m_bHovered = false;
		pThis->m_bClicked = false;
        
		if(g_xPaperAPI.m_xInput.m_buttonMouseLeft.JustPressed())
			pThis->m_bHasFocus = false;

		//DEBUGLOG("%s Selected - %i\n", ((xGUIText*)pThis)->m_strBuffer, pThis->m_xAnimation.m_bDone);
		if(g_xPaperAPI.m_xInput.m_keyLeft.JustPressed(true) || g_xPaperAPI.m_xInput.m_keyUp.JustPressed(true))
		{
			g_xPaperAPI.m_xInput.m_keyLeft.Eaten();
			g_xPaperAPI.m_xInput.m_keyUp.Eaten();
			pThis->SelectPrevious();
            
			if(pThis->m_pHoverSound)
				pThis->m_pHoverSound->Play(g_xPaperAPI.m_fVolume);
		}
		else if(g_xPaperAPI.m_xInput.m_keyRight.JustPressed(true) || g_xPaperAPI.m_xInput.m_keyDown.JustPressed(true))
		{
			g_xPaperAPI.m_xInput.m_keyRight.Eaten();
			g_xPaperAPI.m_xInput.m_keyDown.Eaten();
			pThis->SelectNext();
            
			if(pThis->m_pHoverSound)
				pThis->m_pHoverSound->Play(g_xPaperAPI.m_fVolume);
		}
		else if(g_xPaperAPI.m_xInput.m_keyEnter.JustPressed(true) || g_xPaperAPI.m_xInput.m_keySpace.JustPressed(true) || g_xPaperAPI.m_xInput.m_keyNumEnter.JustPressed(true))
		{
			if(pThis->m_strLClickCommand)
			{
				g_xPaperAPI.m_xInput.m_keyEnter.Eaten();
				g_xPaperAPI.m_xInput.m_keySpace.Eaten();
				g_xPaperAPI.m_xInput.m_keyNumEnter.Eaten();
                
				pThis->m_pGUI->pfnRunInputCommand(pThis->m_strLClickCommand, pThis->m_strLClickParams, pThis->m_pOwningWindow, pThis);
                
				if(pThis->m_pClickSound)
					pThis->m_pClickSound->Play(g_xPaperAPI.m_fVolume);
			}
		}
        
		if(pThis->m_xAnimation.m_bDone)
		if(pThis->m_xAnimation.m_bDone)
			xRenderable2DTextUpdateColor(&((xGUIText*)pThis)->m_xText, xColorMultiply(&tempcolor, &((xGUIText*)pThis)->m_xHoverColor, pThis->GetAbsoluteColor(&tempcolor)));
	}
	else
	{
		pThis->m_bHovered = false;
		pThis->m_bClicked = false;

		if(g_xPaperAPI.m_xInput.m_buttonMouseLeft.JustPressed())
			pThis->m_bHasFocus = false;

		if(pThis->m_xAnimation.m_bDone)
			xRenderable2DTextUpdateColor(&((xGUIText*)pThis)->m_xText, xColorMultiply(&tempcolor, &((xGUIText*)pThis)->m_xNormalColor, pThis->GetAbsoluteColor(&tempcolor)));
	}
}

void xGUITextClearState(xGUIObject* pThis, DWORD dwTime)
{
	pThis->m_bHasFocus = false;
	pThis->m_bHovered = false;
	pThis->m_bClicked = false;
    
	xGUIObjectClearState(pThis, dwTime);
}

void xGUITextUpdate(xGUIObject* pThis, double dTime)
{
	if(pThis->GetHidden() || !((xGUIText*)pThis)->m_strBuffer)
		return;

	if(!pThis->m_pParent->GetAbsoluteFocus())
		pThis->m_bHasFocus = false;
    
	if(!pThis->m_bHasFocus)
		pThis->UpdateState(false, 0);
    
	if(!pThis->m_xAnimation.m_bDone)
	{
		if(dTime > 0.0 && pThis->m_xAnimation.m_fCurAlphaChange > 0.0)
			xAnimationUpdate(&pThis->m_xAnimation, dTime);
		else
			xAnimationUpdate(&pThis->m_xAnimation, dTime);
	}

	char *renderstring;
	char  maskedstring[256] = {0};
    
	if(((xGUIText*)pThis)->m_bMasked)
	{
		int stringlen = strlen(((xGUIText*)pThis)->m_strBuffer);
		for(int i = 0; i < 254 && i < stringlen; i++)
			maskedstring[i] = '*';
        
		renderstring = maskedstring;
	}
	else
		renderstring = ((xGUIText*)pThis)->m_strBuffer;

	if(!pThis->m_bDisabled && !pThis->GetAbsoluteHidden())
	{
		if(((xGUIText*)pThis)->m_pSelectedEmitter)
		{
			if(pThis->m_bSelected)
				((xGUIText*)pThis)->m_pSelectedEmitter->Update(dTime);
			else if(!((xGUIText*)pThis)->m_pSelectedEmitter->IsDone())
			{
				((xGUIText*)pThis)->m_pSelectedEmitter->Kill();
				((xGUIText*)pThis)->m_pSelectedEmitter->Update(dTime);
			}
		}
	}
    
	xGUIObjectUpdate(pThis, dTime);
}

void xGUITextUpdateRenderable(xGUIObject* pThis)
{
	xColor tempcolor;
    
	xRenderable2DTextSetPosition(&((xGUIText*)pThis)->m_xText, pThis->GetAbsoluteX(), pThis->GetAbsoluteY());
	xRenderable2DTextSetScale(&((xGUIText*)pThis)->m_xText, pThis->GetAbsoluteScaleX(), pThis->GetAbsoluteScaleY());
	xRenderable2DTextSetRotation(&((xGUIText*)pThis)->m_xText, pThis->GetRotation());
	xRenderable2DTextUpdateVisibility(&((xGUIText*)pThis)->m_xText, !pThis->GetAbsoluteHidden());
	xRenderable2DTextUpdateAlpha(&((xGUIText*)pThis)->m_xText, pThis->GetAbsoluteColor(&tempcolor)->A);
    
	((xGUIText*)pThis)->UpdateRenderable();
}

void xGUITextUpdateDepth(xGUIObject* pThis)
{
	xRenderable2DTextUpdateDepth(&((xGUIText*)pThis)->m_xText, pThis->m_pSceneGraph, pThis->GetAbsoluteDepth());
}

void xGUITextRefreshRenderables(xGUIObject* pThis)
{
	xRenderable2DTextRefreshTextures(&((xGUIText*)pThis)->m_xText);

	if(((xGUIText*)pThis)->m_pSelectedEmitter && ((xGUIText*)pThis)->m_pSelectedEmitter->m_pTextures)
		xGraphicsGetTextures(((xGUIText*)pThis)->m_strSelectedEmitter, &((xGUIText*)pThis)->m_pSelectedEmitter->m_pTextures);

	((xGUIText*)pThis)->UpdateRenderable();
}

void xGUIText::Shutdown()
{
	xGUIObject::Shutdown();
    
	xRenderable2DTextDelete(&m_xText, m_pSceneGraph);
    
	if(m_pSelectedEmitter)
	{
		m_pSelectedEmitter->Reset();
		m_pSelectedEmitter->Kill();
	}
}
