#include "Paper.h"
/*#include <intrin.h>

FORCEINLINE bool SSEAvailable()
{
	int id[4];
	__cpuid(id, 1);
	return id[3] & 25;
}*/

void xMD3Model::Init(const char* strName, int iAnimationCount, xSceneGraph *pSceneGraph, float fRenderDepth)
{
	char filepath[256];
	xVector rotation;
	GLushort *indices;
	int index, i, j;

	m_pSceneGraph = pSceneGraph;

	sprintf(filepath, "models/%s/model.md3", strName);
	LoadMD3File(filepath);

	sprintf(filepath, "models/%s/model.skin", strName);
	LoadSkinFile(filepath);

	sprintf(filepath, "models/%s/animation.cfg", strName);
	LoadAnimationFile(filepath, iAnimationCount);

	xVectorInit(&rotation, -90.0, 0.0, 0.0);

	m_pRenderables = (xRenderable3D**)dlmalloc(sizeof(xRenderable3D*) * m_iMeshCount);

	for(i = 0; i < m_iMeshCount; i++)
	{
		m_pRenderables[i] = xSceneGraphCreateMesh(m_pMeshes[i].m_pTexture);

		if(!g_xPaperAPI.m_bOutlineModels)
			xRenderable3DSetBlendMode(m_pRenderables[i], PE_BLEND_MODE_NONE);
		else if(!m_pMeshes[i].m_pTexture->m_bHasAlpha)
			xRenderable3DSetBlendMode(m_pRenderables[i], PE_BLEND_MODE_NONE_OUTLINED);

		xRenderable3DSetRotation(m_pRenderables[i], &rotation);

		xSceneGraphInsertMesh(pSceneGraph, m_pRenderables[i], m_pMeshes[i].m_iFaceCount, fRenderDepth, 0);
		
		indices = (GLushort*)dlmalloc(sizeof(GLushort) * m_pMeshes[i].m_iFaceCount * 3);

		for(j = 0; j < m_pMeshes[i].m_iFaceCount; j++)
		{
			index = m_pMeshes[i].m_pFaces[j].m_iVertIndicies[0];
			indices[j * 3] = j * 3;
			xVector2DInit(&m_pRenderables[i]->m_pVertData->m_xVertices[j * 3].m_xTextureCoords, m_pMeshes[i].m_pTexVertices[index].x, m_pMeshes[i].m_pTexVertices[index].y);

			index = m_pMeshes[i].m_pFaces[j].m_iVertIndicies[1];
			indices[j * 3 + 1] = j * 3 + 1;
			xVector2DInit(&m_pRenderables[i]->m_pVertData->m_xVertices[j * 3 + 1].m_xTextureCoords, m_pMeshes[i].m_pTexVertices[index].x, m_pMeshes[i].m_pTexVertices[index].y);

			index = m_pMeshes[i].m_pFaces[j].m_iVertIndicies[2];
			indices[j * 3 + 2] = j * 3 + 2;
			xVector2DInit(&m_pRenderables[i]->m_pVertData->m_xVertices[j * 3 + 2].m_xTextureCoords, m_pMeshes[i].m_pTexVertices[index].x, m_pMeshes[i].m_pTexVertices[index].y);
		}

		glGenBuffers(1, &m_pRenderables[i]->m_pVertData->m_uiIndexBuffer);
		glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, m_pRenderables[i]->m_pVertData->m_uiIndexBuffer);
		glBufferData(GL_ELEMENT_ARRAY_BUFFER, sizeof(GLushort) * m_pMeshes[i].m_iFaceCount * 3, indices, GL_STATIC_DRAW);
		dlfree(indices);

#ifdef DONOTRENDER
		m_pRenderables[i]->m_bVisible = false;
		m_pRenderables[i]->m_pVertData->m_bRender = false;
#endif
	}
}

void xMD3ModelPreUpdate(xModel* pThis, DWORD dwTime)
{
	xVector translation;
	float elapsedtime;

	if(((xMD3Model*)pThis)->m_iCurrentAnim == -1)
		return;

	xMD3Animation *anim = &((xMD3Model*)pThis)->m_pAnimations[((xMD3Model*)pThis)->m_iCurrentAnim];

	if(((xMD3Model*)pThis)->m_dwFrameStartTime == 0)
		((xMD3Model*)pThis)->m_dwFrameStartTime = dwTime - 1;

	if(dwTime > 1 || !((xMD3Model*)pThis)->m_dwFrameStartTime)
	{
		//DEBUGLOG("xMD3ModelUpdate %i %u %u %i %i\n", ((xMD3Model*)pThis)->m_iCurrentAnim, dwTime, ((xMD3Model*)pThis)->m_dwFrameStartTime, ((xMD3Model*)pThis)->m_iCurrentFrame, anim->m_iLastFrame);
		if(((xMD3Model*)pThis)->m_iCurrentFrame >= anim->m_iFirstFrame && ((xMD3Model*)pThis)->m_iCurrentFrame <= anim->m_iLastFrame)
		{
			if(((xMD3Model*)pThis)->m_iCurrentFrame + 1 <= anim->m_iLastFrame)
				((xMD3Model*)pThis)->m_iNextFrame = ((xMD3Model*)pThis)->m_iCurrentFrame + 1;
			else
			{
				if(((xMD3Model*)pThis)->pfnOnAnimationCompleted)
				{
					((xMD3Model*)pThis)->pfnOnAnimationCompleted((xMD3Model*)pThis, ((xMD3Model*)pThis)->m_pAnimCompleteCallbackObject);

					if(((xMD3Model*)pThis)->m_iCurrentAnim == -1)
						return;
				}
				else
					((xMD3Model*)pThis)->m_iNextFrame = anim->m_iFirstFrame;
			}
		}

		elapsedtime = dwTime - ((xMD3Model*)pThis)->m_dwFrameStartTime;

		do
		{
			// Get a percentage of the Frame time, from 0.0f to 1.0f
			((xMD3Model*)pThis)->m_fFrameTimePct = elapsedtime / (1000.0f / ((xMD3Model*)pThis)->m_fCurrentFPS);

			if(elapsedtime >= (1000.0f / ((xMD3Model*)pThis)->m_fCurrentFPS))
			{
				// Goto the next frame
				((xMD3Model*)pThis)->m_iCurrentFrame = ((xMD3Model*)pThis)->m_iNextFrame;

				((xMD3Model*)pThis)->m_dwFrameStartTime = dwTime - ((((xMD3Model*)pThis)->m_fFrameTimePct - 1.0) * (1000.0f / ((xMD3Model*)pThis)->m_fCurrentFPS));
			}

			elapsedtime = dwTime - ((xMD3Model*)pThis)->m_dwFrameStartTime;
		} while(elapsedtime > (1000.0f / ((xMD3Model*)pThis)->m_fCurrentFPS));
	}
}

void xMD3ModelUpdate(xModel* pThis, double dTime)
{
	xMesh *object;
	xFace *curface, *lastface;
	int currentindex, nextindex, index1, index2, index3, i;
	xVector translation, *point11, *point12, *point21, *point22, *point31, *point32;
	xTexturedVert *vertex;
	xRenderDataVerts *vertdata;
	float frametime;

	if(((xMD3Model*)pThis)->m_iCurrentAnim == -1)
		return;

	translation = pThis->m_vecTranslation;
	frametime = ((xMD3Model*)pThis)->m_fFrameTimePct;

	for(i = 0; i < ((xMD3Model*)pThis)->m_iMeshCount; i++)
	{
		object = &((xMD3Model*)pThis)->m_pMeshes[i];
		currentindex = ((xMD3Model*)pThis)->m_iCurrentFrame * object->m_iVertCount;
		nextindex = ((xMD3Model*)pThis)->m_iNextFrame * object->m_iVertCount;

		curface = object->m_pFaces;
		lastface = &object->m_pFaces[object->m_iFaceCount - 1];
		vertdata = ((xMD3Model*)pThis)->m_pRenderables[i]->m_pVertData;
		vertex = vertdata->m_xVertices;
		for(; curface <= lastface; curface++)
		{
			index1 = curface->m_iVertIndicies[0];
			index2 = curface->m_iVertIndicies[1];
			index3 = curface->m_iVertIndicies[2];

			point11 = &object->m_pVertices[currentindex + index1];
			point12 = &object->m_pVertices[nextindex + index1];
			point21 = &object->m_pVertices[currentindex + index2];
			point22 = &object->m_pVertices[nextindex + index2];
			point31 = &object->m_pVertices[currentindex + index3];
			point32 = &object->m_pVertices[nextindex + index3];

			xVectorInit(&(vertex++)->m_xVector, translation.x + point11->x + frametime * (point12->x - point11->x), translation.y + point11->y + frametime * (point12->y - point11->y), translation.z + point11->z + frametime * (point12->z - point11->z));
			xVectorInit(&(vertex++)->m_xVector, translation.x + point21->x + frametime * (point22->x - point21->x), translation.y + point21->y + frametime * (point22->y - point21->y), translation.z + point21->z + frametime * (point22->z - point21->z));
			xVectorInit(&(vertex++)->m_xVector, translation.x + point31->x + frametime * (point32->x - point31->x), translation.y + point31->y + frametime * (point32->y - point31->y), translation.z + point31->z + frametime * (point32->z - point31->z));
		}

		if(!vertdata->m_uiVertexBuffer)
			glGenBuffers(1, &vertdata->m_uiVertexBuffer);
		glBindBuffer(GL_ARRAY_BUFFER, vertdata->m_uiVertexBuffer);
		glBufferData(GL_ARRAY_BUFFER, sizeof(xTexturedVert) * vertdata->m_iVectorArrayLength, vertdata->m_xVertices, GL_STREAM_DRAW);
	}
}

void xMD3Model::RefreshTextures()
{
	int i;

	for(i = 0; i < m_iMeshCount; i++)
		xRenderable3DRefreshTextures(m_pRenderables[i]);
}

void xMD3Model::Delete()
{
	int i;

	for(i = 0; i < m_iMeshCount; i++)
	{
		delete [] m_pMeshes[i].m_pVertices;
		delete [] m_pMeshes[i].m_pTexVertices;
		delete [] m_pMeshes[i].m_pFaces;
	}

	if(m_pTags)
	{
		delete [] m_pTags;
		delete [] m_pMeshes;
		m_pTags = 0;
		m_pMeshes = 0;
	}

	if(m_pAnimations)
	{
		delete [] m_pAnimations;
		m_pAnimations = 0;
	}

	if(m_pRenderables)
	{
		for(i = 0; i < m_iMeshCount; i++)
			xSceneGraphDeleteMesh(m_pSceneGraph, m_pRenderables[i], 1);

		dlfree(m_pRenderables);
		m_pRenderables = 0;
	}

	m_iCurrentAnim = 0;
	m_iCurrentFrame = -1;
	m_iNextFrame = 1;
	m_dwFrameStartTime = 0;
}

void xMD3Model::LoadMD3File(char* strFile)
{
	if(m_xFile.OpenFile(strFile, true, true))
		assert(0);

	m_xFile.ReadData(&m_xHeader, sizeof(xMD3Header));

	if(m_xHeader.m_strFileID[0] != 'I' || m_xHeader.m_strFileID[1] != 'D' || m_xHeader.m_strFileID[2] != 'P' || m_xHeader.m_strFileID[3] != '3' || m_xHeader.m_iVersion != 15)
		assert(0);

	//Skip over Bones
	m_xFile.SkipAhead(m_xHeader.m_iNumFrames * sizeof(xMD3Bone));

	m_iTagCount = m_xHeader.m_iNumFrames * m_xHeader.m_iNumTags;
	m_pTags = new xMD3Tag[m_iTagCount];
	m_xFile.ReadData(m_pTags, sizeof(xMD3Tag) * m_iTagCount);

	m_iMeshCount = m_xHeader.m_iNumMeshes;
	m_pMeshes = new xMesh[m_iMeshCount];

	xMD3MeshInfo meshinfo;
	long meshoffset = m_xFile.GetCurrentOffset();

	for(int i = 0; i < m_iMeshCount; i++)
	{
		xMesh *currentmesh = &m_pMeshes[i];

		currentmesh->m_pTexture = NULL;

		m_xFile.SetPosition(meshoffset);
		m_xFile.ReadData(&meshinfo, sizeof(xMD3MeshInfo));

		xMD3Skin *skins			= new xMD3Skin[meshinfo.m_iNumSkins];
		xMD3TexCoord *texcoords	= new xMD3TexCoord[meshinfo.m_iNumVertices];
		xMD3Face *faces			= new xMD3Face[meshinfo.m_iNumTriangles];
		xMD3Triangle *triangles	= new xMD3Triangle[meshinfo.m_iNumVertices * meshinfo.m_iNumMeshFrames];

		m_xFile.ReadData(skins, sizeof(xMD3Skin) * meshinfo.m_iNumSkins);

		m_xFile.SetPosition(meshoffset + meshinfo.m_iVertexStart);
		m_xFile.ReadData(triangles, sizeof(xMD3Triangle) * meshinfo.m_iNumVertices * meshinfo.m_iNumMeshFrames);

		m_xFile.SetPosition(meshoffset + meshinfo.m_iUVStart);
		m_xFile.ReadData(texcoords, sizeof(xMD3TexCoord) * meshinfo.m_iNumVertices);

		m_xFile.SetPosition(meshoffset + meshinfo.m_iTriangleStart);
		m_xFile.ReadData(faces, sizeof(xMD3Face) * meshinfo.m_iNumTriangles);

		strcpy(currentmesh->m_strName, meshinfo.m_strName);

		currentmesh->m_iVertCount		= meshinfo.m_iNumVertices;
		currentmesh->m_iTexVertCount	= meshinfo.m_iNumVertices;
		currentmesh->m_iFaceCount		= meshinfo.m_iNumTriangles;

		currentmesh->m_pVertices			= new xVector[currentmesh->m_iVertCount * meshinfo.m_iNumMeshFrames];
		currentmesh->m_pTexVertices			= new xVector2D[currentmesh->m_iTexVertCount];
		currentmesh->m_pFaces				= new xFace[currentmesh->m_iFaceCount];

		for(int j = 0; j < currentmesh->m_iVertCount * meshinfo.m_iNumMeshFrames; j++)
		{
			currentmesh->m_pVertices[j].x = triangles[j].m_s8Vertex[0] / 64.0f;
			currentmesh->m_pVertices[j].y = triangles[j].m_s8Vertex[1] / 64.0f;
			currentmesh->m_pVertices[j].z = triangles[j].m_s8Vertex[2] / 64.0f;
		}

		for(int j = 0; j < currentmesh->m_iTexVertCount; j++)
		{
			currentmesh->m_pTexVertices[j].x = texcoords[j].m_fTextureCoord[0];
			currentmesh->m_pTexVertices[j].y = 1.0 - texcoords[j].m_fTextureCoord[1];
		}

		for(int j = 0; j < currentmesh->m_iFaceCount; j++)
		{
			currentmesh->m_pFaces[j].m_iVertIndicies[0] = faces[j].m_iVertexIndices[0];
			currentmesh->m_pFaces[j].m_iVertIndicies[1] = faces[j].m_iVertexIndices[1];
			currentmesh->m_pFaces[j].m_iVertIndicies[2] = faces[j].m_iVertexIndices[2];
		}

		meshoffset += meshinfo.m_iMeshSize;

		delete [] skins;
		delete [] texcoords;
		delete [] faces;
		delete [] triangles;
	}

	m_xFile.CloseFile();
}

void xMD3Model::LoadSkinFile(char* strFile)
{
	if(m_xFile.OpenFile(strFile, true, false))
		assert(0);

	char line[256], file[256];
	while(!m_xFile.ReadLine(line, 256))
	{
		for(int i = 0; i < m_iMeshCount; i++)
		{
			if(strstr(line, m_pMeshes[i].m_strName))
			{
				int linelen = strlen(line);
				int texturenamestart = -1;
				for(int j = 0; j < linelen - 1; j++)
				{
					if(line[j] == ',')
					{
						texturenamestart = j + 1;
						break;
					}
				}

				if(texturenamestart == -1)
					assert(0);

				strcpy(file, &line[texturenamestart]);

				m_pMeshes[i].m_pTexture = xGraphicsGetTexture(file, 0);

				if(m_pMeshes[i].m_pTexture && texturenamestart > 3 && line[texturenamestart - 3] == '|' && line[texturenamestart - 2] == 'A')
					m_pMeshes[i].m_pTexture->m_bHasAlpha = true;
			}
		}
	}

	m_xFile.CloseFile();
}

void xMD3Model::LoadAnimationFile(char* strFile, int iAnimationCount)
{
	if(m_xFile.OpenFile(strFile, true, false))
		assert(0);

	m_pAnimations = new xMD3Animation[iAnimationCount];

	int curanimindex = 0;
	char line[256];
	while(curanimindex < iAnimationCount && !m_xFile.ReadLine(line, 256))
	{
		// Our test to find the first line of animations in the animation file
		if(!isdigit(line[0]))
			continue;

		char firstframe[8] = {0};
		char lastframe[8] = {0};
		char numbeats[8] = {0};
		int tmpr = 0;

		bool foundfirst = false;
		bool foundlast = false;
		bool foundnumbeats = false;

		int linelen = strlen(line);
		for(int i = 0; i < linelen; i++)
		{
			if(isdigit(line[i]) && !foundnumbeats)
			{
				if(!foundfirst)
				{
					firstframe[tmpr] = line[i];
					tmpr++;
				}
				else if(!foundlast)
				{
					lastframe[tmpr] = line[i];
					tmpr++;
				}
				else if(!foundnumbeats)
				{
					numbeats[tmpr] = line[i];
					tmpr++;
				}
			}
			else
			{
				if(line[i] == ' ' || line[i] == '	')
				{
					tmpr = 0;
					if(!foundfirst)
						foundfirst = true;
					else if(!foundlast)
						foundlast = true;
					else if(!foundnumbeats)
						break;

					while(line[i + 1] == ' ' || line[i + 1] == '	')
						i++;
				}
				else if(line[i] == '\n')
					break;
			}
		}

		m_pAnimations[curanimindex].m_iFirstFrame	= atoi(firstframe) - 1;
		m_pAnimations[curanimindex].m_iLastFrame	= atoi(lastframe) - 1;
		m_pAnimations[curanimindex].m_iNumBeats		= atoi(numbeats);

		curanimindex++;
	}
	
	m_xFile.CloseFile();
}

void xMD3Model::SetRotation(float fX, float fY, float fZ)
{
	xVector rotation;
	int i;

	xVectorInit(&rotation, fX, fY, fZ);

	for(i = 0; i < m_iMeshCount; i++)
		xRenderable3DUpdateRotation(m_pRenderables[i], &rotation);
}
