#include "peGame.h"

#define IOS_PROFILE	"Player.bbp"

int xOptions::LoadOptions(const char *strOptionsFile)
{
	m_bFirstRun = true;

	if(!m_pButtons[KEY_RED])
		m_pButtons[KEY_RED] = &g_xPaperAPI.m_xInput.m_keyUp;

	if(!m_pButtons[KEY_BLUE])
		m_pButtons[KEY_BLUE] = &g_xPaperAPI.m_xInput.m_keyRight;

	if(!m_pButtons[KEY_YELLOW])
		m_pButtons[KEY_YELLOW] = &g_xPaperAPI.m_xInput.m_keyLeft;

	if(!m_pButtons[KEY_ROTATEPIECE])
		m_pButtons[KEY_ROTATEPIECE] = &g_xPaperAPI.m_xInput.m_keyS;

	if(!m_pButtons[KEY_ROTATEPIECE_ALT])
		m_pButtons[KEY_ROTATEPIECE_ALT] = &g_xPaperAPI.m_xInput.m_keyDown;

	if(!m_pButtons[KEY_ROTATEBOARDCLOCKWISE])
		m_pButtons[KEY_ROTATEBOARDCLOCKWISE] = &g_xPaperAPI.m_xInput.m_keyD;

	if(!m_pButtons[KEY_ROTATEBOARDCLOCKWISE_ALT])
		m_pButtons[KEY_ROTATEBOARDCLOCKWISE_ALT] = &g_xPaperAPI.m_xInput.m_keyRight;

	if(!m_pButtons[KEY_ROTATEBOARDCOUNTERCLOCKWISE])
		m_pButtons[KEY_ROTATEBOARDCOUNTERCLOCKWISE] = &g_xPaperAPI.m_xInput.m_keyA;

	if(!m_pButtons[KEY_ROTATEBOARDCOUNTERCLOCKWISE_ALT])
		m_pButtons[KEY_ROTATEBOARDCOUNTERCLOCKWISE_ALT] = &g_xPaperAPI.m_xInput.m_keyLeft;

	if(!m_pButtons[KEY_DROPPIECE])
		m_pButtons[KEY_DROPPIECE] = &g_xPaperAPI.m_xInput.m_keyW;

	if(!m_pButtons[KEY_DROPPIECE_ALT])
		m_pButtons[KEY_DROPPIECE_ALT] = &g_xPaperAPI.m_xInput.m_keyUp;

	if(!m_pButtons[KEY_CLEAR])
		m_pButtons[KEY_CLEAR] = &g_xPaperAPI.m_xInput.m_keySpace;

	if(!m_pButtons[KEY_TYPEMESSAGE])
		m_pButtons[KEY_TYPEMESSAGE] = &g_xPaperAPI.m_xInput.m_keyT;

	if(!m_pButtons[KEY_PAUSE])
		m_pButtons[KEY_PAUSE] = &g_xPaperAPI.m_xInput.m_keyP;

	if(!m_pButtons[KEY_GOTOMENU])
		m_pButtons[KEY_GOTOMENU] = &g_xPaperAPI.m_xInput.m_keyEscape;

	if(g_xPaperAPI.m_xAudio.m_iMaxSourcesOverride < 0)
		g_xPaperAPI.m_xAudio.m_iMaxSourcesOverride = 0;

	g_xPaperAPI.m_bOutlineModels = m_bCharacterOutlines;
	g_xPaperAPI.m_bLimitParticles = m_bLimitedParticles;
	g_xPaperAPI.m_fVolume = m_fSoundVolume;

	return PE_RES_NOERROR;
}

int xOptions::SaveOptions(const char *strOptionsFile)
{
	return PE_RES_NOERROR;
}

bool xOptions::LoadProfileByHash(char *strHash, xPlayerProfile *pPlayer)
{
	char filepath[256];
	xFileIO fileio;
	int i;
	
	pPlayer->m_byteSelectedDifficulty = 2;
	strcpy(pPlayer->m_strLoginName, g_xPaperAPI.m_strMobileIdentifier);
	strcpy(pPlayer->m_strLoginPassword, "abcdef0123456789abcdef0123456789");

	sprintf(filepath, "%s/%s", g_strDocumentDir, IOS_PROFILE);

	if((m_iResult = fileio.OpenFile(filepath, true, true)))
		return false;

	if((m_iResult = fileio.ReadData(pPlayer, sizeof(xPlayerProfile))))
		return false;

	fileio.CloseFile();

	if(pPlayer->m_u16Version == 0)
	{
		memset(pPlayer->m_u32HighScores, 0, BB_MAXLEVELS);
		pPlayer->m_u32Currency = 0;
	}
	
/*	if(pPlayer->m_u16Version <= 1)
	{
		memset(pPlayer->m_bytePlayerMovesOwned, 0, BB_MAXPLAYERMOVES);
		pPlayer->m_bytePlayerMovesOwned[0] = 1;
		pPlayer->m_bytePlayerMovesOwned[BB_PLAYERMOVE_MOVESPERCATEGORY] = 1;

		memset(pPlayer->m_bytePlayerMovesSelected, BB_PLAYERMOVE_NONE, BB_MAXPLAYERMOVESLOTS);
		pPlayer->m_bytePlayerMovesSelected[0] = 0;
		pPlayer->m_bytePlayerMovesSelected[1] = BB_PLAYERMOVE_MOVESPERCATEGORY;
	}
	
	if(pPlayer->m_u16Version <= 2)
		pPlayer->m_bytePlayerMoveExplanationSeen = 0;
*/	
	if(pPlayer->m_u16Version <= 3)
		pPlayer->m_byteNoServerPortWarning = 0;

	if(pPlayer->m_u16Version <= 4)
	{
		pPlayer->m_byteSelectedDifficulty = 2;

		memset(pPlayer->m_u32HighScores, 0, BB_NUMDIFFICULTIES * BB_MAXLEVELS * sizeof(uint32_t));
	}

	if(pPlayer->m_u16Version <= 5)
	{
		pPlayer->m_byteSeenSingleplayerLogin = 0;
		memset(pPlayer->m_strLoginName, 0, BB_MAXLOGINNAMELENGTH);
		memset(pPlayer->m_strLoginPassword, 0, BB_MAXLOGINPASSLENGTH);
	}

	if(pPlayer->m_u16Version <= 6)
	{
		pPlayer->m_strLoginPassword[32] = '\0';
		memset(pPlayer->m_byteAchievementStatus, 0, BB_ACHIEVEMENTS_MAX);
	}

	if(pPlayer->m_u16Version <= 7)
		memset(pPlayer->m_u32LevelTimes, 0, BB_MAXLEVELS * sizeof(uint32_t));

	pPlayer->m_byteSelectedDifficulty = 2;
	
	if(pPlayer->m_byteSelectedDifficulty < BB_NUMDIFFICULTIES)
	{
		for(i = 0; i < BB_NUMDIFFICULTIES; i++)
			pPlayer->m_u32HighScores[i][BB_LEVELS_MAX + 1] = 0;

#ifdef DEMO_RELEASE
		g_xCurrentProfile.m_iCurrentLevel = 5;
		for(i = 1; i < 5; i++)
#else
		for(i = 1; i < BB_MAXLEVELS; i++)
#endif
		{
			if(pPlayer->m_u32HighScores[pPlayer->m_byteSelectedDifficulty][i] == 0)
			{
				pPlayer->m_iCurrentLevel = i;
				break;
			}
		}
	}
	
	strcpy(pPlayer->m_strLoginName, g_xPaperAPI.m_strMobileIdentifier);
	strcpy(pPlayer->m_strLoginPassword, "abcdef0123456789abcdef0123456789");

	return true;
}

//NOTE: strProfileName must be 29 characters or less(prolly best to limit it to 16, 20, or 25)
int xOptions::LoadPlayerProfile(char *strProfileName, xPlayerProfile *pPlayer)
{
	char profilehash[24];

	if(!LoadProfileByHash(profilehash, pPlayer))
	{
		strcpy(pPlayer->m_strProfileName, strProfileName);

		pPlayer->m_iCurrentLevel = 1;
	}

	return PE_RES_NOERROR;
}

int xOptions::SavePlayerProfile(xPlayerProfile *pPlayer)
{
	char filepath[256];
	xFileIO fileio;

	pPlayer->m_u16Version = BB_PLAYERPROFILEVERSION;

	sprintf(filepath, "%s/%s", g_strDocumentDir, IOS_PROFILE);

	if((m_iResult = fileio.OpenFile(filepath, false, true)))
		assert(0);

	if((m_iResult = fileio.WriteData(pPlayer, sizeof(xPlayerProfile))))
		assert(0);

	fileio.CloseFile();

	return PE_RES_NOERROR;
}

xList<xPlayerProfile>* xOptions::GetAllAvailableProfiles()
{
	xFileIO fileio;
	char curhash[24] = {0};
	char curfilename[256] = {0};
	char curfilepath[256] = {0};
	xPlayerProfile *curplayerprofile;
	xList<xPlayerProfile> *returnlist = NULL;
	xList<xPlayerProfile> *curlistitem;

	fileio.StartFindFiles("./profiles/*.bbp");

	while(fileio.GetNextFile(curfilename))
	{
		curplayerprofile = new xPlayerProfile;

		sprintf(curfilepath, "./profiles/%s", curfilename);
		fileio.OpenFile(curfilepath, true, true);
		fileio.ReadData(curplayerprofile, sizeof(xPlayerProfile));
		fileio.CloseFile();

		CreateProfileHash(curplayerprofile->m_strProfileName, curhash);

		bool bHashMatches = true;
		for(int i = 0; i < 24 && curfilename[i] != '.'; i++)
		{
			if(curfilename[i] != curhash[i])
			{
				bHashMatches = false;
				break;
			}
		}

		if(bHashMatches)
		{
			if(!returnlist)
			{
				returnlist = new xList<xPlayerProfile>;
				returnlist->m_pData = curplayerprofile;
				curlistitem = returnlist;
			}
			else
			{
				curlistitem->m_pNext			= new xList<xPlayerProfile>;
				curlistitem->m_pNext->m_pPrev	= curlistitem;
				curlistitem						= curlistitem->m_pNext;
				curlistitem->m_pData			= curplayerprofile;
			}
		}
		else
		{
			delete curplayerprofile;
		}

		memset(curfilename, 0, 255);
		memset(curhash, 0, 24);
	}

	fileio.EndFindFiles();

	return returnlist;
}

//NOTE: strProfileName must be 29 characters or less(prolly best to limit it to 16, 20, or 25)
void xOptions::CreateProfileHash(char *strProfileName, char strOutHash[24])
{
	unsigned long long ProfileHashInt = 0, HashShift;
	int i, j, shift;

	j = strlen(strProfileName);
	shift = 0;
	for(i = 0; i < j; i++)
	{
		HashShift = strProfileName[i];
		ProfileHashInt += HashShift << shift;

		shift += 2;
	}

	HashShift = 10000000000000000000ULL;
	i = 0;
	while(ProfileHashInt > 0 && i < 24 && HashShift > 1)
	{
		if(ProfileHashInt > HashShift)
		{
			j = ProfileHashInt / HashShift;
			strOutHash[i++] = '0' + j;
			ProfileHashInt = ProfileHashInt % HashShift;
		}

		HashShift /= 10;
	}

	if(ProfileHashInt < 10)
		strOutHash[i++] = '0' + ProfileHashInt;

	strOutHash[i] = '\0';
}