/////////////////////////////////////////////////////////////////
// Name: xPlayer.h
/////////////////////////////////////////////////////////////////
// Description:
// - Serves as a base class for players, locally and 
//   over the net.
/////////////////////////////////////////////////////////////////
// - 7.15.2004, Update, Dayle Flowers(Xienen)
//   File Created
/////////////////////////////////////////////////////////////////
// - 9.12.2004, Update, Greg Feldman(Greg)
//	 Added score tracking
/////////////////////////////////////////////////////////////////
#ifndef XPLAYER_H_
#define XPLAYER_H_

#include "xField.h"

class xPlayer
{
public:
	xPlayer()
	{
		m_pNext		= NULL;
		m_pPrev		= NULL;
		m_bDead		= false;
		m_bWonGame	= false;
		m_iRank		= -1;
		m_iPoints	= 0;
	}

	virtual bool Init() { return true; }
	virtual bool PreUpdate(DWORD dwTime) { return true; }
	virtual bool Update(double dTime) { return true; }
	virtual void Shutdown() {};

	bool	m_bDead;
	bool	m_bWonGame;
	int		m_iRank;
	int		m_iPoints;

	xPlayer		   *m_pNext;
	xPlayer		   *m_pPrev;
	xField			m_xField;
};

#endif