#include "Paper.h"

FORCE_INLINE void InitVector(xVector *pVector, float fX, float fY)
{
	pVector->x = fX;
	pVector->y = fY;
}

FORCE_INLINE void InitVector(xVector2D *pVector, float fX, float fY)
{
	pVector->x = fX;
	pVector->y = fY;
}

void xRenderable2DLineUpdate(xRenderable2DLine *pThis)
{
	xRenderDataVerts *vertdata;

	DEBUGCHECK(!pThis || !pThis->m_xRenderable2D.m_pVertData || !pThis->m_xRenderable2D.m_pVertData->m_pTextureData || !pThis->m_xRenderable2D.m_pVertData->m_pShaderData);

	vertdata = pThis->m_xRenderable2D.m_pVertData;

	//Start Vertex
	vertdata->m_xVertices[0].m_xVector.x = g_xPaperAPI.m_iScreenOffsetX + pThis->m_xRenderable2D.m_fX * g_xPaperAPI.m_fScreenRatioX;
	vertdata->m_xVertices[0].m_xVector.y = g_xPaperAPI.m_iScreenOffsetY + pThis->m_xRenderable2D.m_fY * g_xPaperAPI.m_fScreenRatioY;

	//End Vertex
	vertdata->m_xVertices[1].m_xVector.x = g_xPaperAPI.m_iScreenOffsetX + (pThis->m_xRenderable2D.m_fX + pThis->m_xRenderable2D.m_fWidth) * g_xPaperAPI.m_fScreenRatioX;
	vertdata->m_xVertices[1].m_xVector.y = g_xPaperAPI.m_iScreenOffsetY + (pThis->m_xRenderable2D.m_fY + pThis->m_xRenderable2D.m_fHeight) * g_xPaperAPI.m_fScreenRatioY;
}

void xRenderable2DBoxUpdate(xRenderable2DBox *pThis)
{
	xRenderDataVerts *vertdata;

	DEBUGCHECK(!pThis || !pThis->m_xRenderable2D.m_pVertData || !pThis->m_xRenderable2D.m_pVertData->m_pTextureData || !pThis->m_xRenderable2D.m_pVertData->m_pShaderData);

	vertdata = pThis->m_xRenderable2D.m_pVertData;

	//Top Left Vertex
	vertdata->m_xVertices[0].m_xVector.x = g_xPaperAPI.m_iScreenOffsetX + pThis->m_xRenderable2D.m_fX * g_xPaperAPI.m_fScreenRatioX;
	vertdata->m_xVertices[0].m_xVector.y = g_xPaperAPI.m_iScreenOffsetY + pThis->m_xRenderable2D.m_fY * g_xPaperAPI.m_fScreenRatioY;

	//Bottom Left Vertex
	vertdata->m_xVertices[1].m_xVector.x = g_xPaperAPI.m_iScreenOffsetX + pThis->m_xRenderable2D.m_fX * g_xPaperAPI.m_fScreenRatioX;
	vertdata->m_xVertices[1].m_xVector.y = g_xPaperAPI.m_iScreenOffsetY + (pThis->m_xRenderable2D.m_fY + pThis->m_xRenderable2D.m_fHeight * pThis->m_xRenderable2D.m_fScaleY) * g_xPaperAPI.m_fScreenRatioY;

	//Bottom Right Vertex
	vertdata->m_xVertices[2].m_xVector.x = g_xPaperAPI.m_iScreenOffsetX + (pThis->m_xRenderable2D.m_fX + pThis->m_xRenderable2D.m_fWidth * pThis->m_xRenderable2D.m_fScaleX) * g_xPaperAPI.m_fScreenRatioX;
	vertdata->m_xVertices[2].m_xVector.y = g_xPaperAPI.m_iScreenOffsetY + (pThis->m_xRenderable2D.m_fY + pThis->m_xRenderable2D.m_fHeight * pThis->m_xRenderable2D.m_fScaleY) * g_xPaperAPI.m_fScreenRatioY;

	//Top Right Vertex
	vertdata->m_xVertices[3].m_xVector.x = g_xPaperAPI.m_iScreenOffsetX + (pThis->m_xRenderable2D.m_fX + pThis->m_xRenderable2D.m_fWidth * pThis->m_xRenderable2D.m_fScaleX) * g_xPaperAPI.m_fScreenRatioX;
	vertdata->m_xVertices[3].m_xVector.y = g_xPaperAPI.m_iScreenOffsetY + pThis->m_xRenderable2D.m_fY * g_xPaperAPI.m_fScreenRatioY;
}

void xRenderable2DQuadUpdate(xRenderable2DQuad *pThis)
{
	xRenderDataVerts *vertdata;
	float texwidth, texheight;

	DEBUGCHECK(!pThis || !pThis->m_xRenderable2D.m_pVertData || !pThis->m_xRenderable2D.m_pVertData->m_pTextureData || !pThis->m_xRenderable2D.m_pVertData->m_pShaderData);

	vertdata = pThis->m_xRenderable2D.m_pVertData;

	if(pThis->m_xRenderable2D.m_fRotation == 0.0)
	{
		//Top Left Vertex
		vertdata->m_xVertices[0].m_xVector.x = g_xPaperAPI.m_iScreenOffsetX + pThis->m_xRenderable2D.m_fX * g_xPaperAPI.m_fScreenRatioX;
		vertdata->m_xVertices[0].m_xVector.y = g_xPaperAPI.m_iScreenOffsetY + pThis->m_xRenderable2D.m_fY * g_xPaperAPI.m_fScreenRatioY;

		//Bottom Left Vertex
		vertdata->m_xVertices[1].m_xVector.x = g_xPaperAPI.m_iScreenOffsetX + pThis->m_xRenderable2D.m_fX * g_xPaperAPI.m_fScreenRatioX;
		vertdata->m_xVertices[1].m_xVector.y = g_xPaperAPI.m_iScreenOffsetY + (pThis->m_xRenderable2D.m_fY + pThis->m_xRenderable2D.m_fHeight * pThis->m_xRenderable2D.m_fScaleY) * g_xPaperAPI.m_fScreenRatioY;

		//Bottom Right Vertex
		vertdata->m_xVertices[2].m_xVector.x = g_xPaperAPI.m_iScreenOffsetX + (pThis->m_xRenderable2D.m_fX + pThis->m_xRenderable2D.m_fWidth * pThis->m_xRenderable2D.m_fScaleX) * g_xPaperAPI.m_fScreenRatioX;
		vertdata->m_xVertices[2].m_xVector.y = g_xPaperAPI.m_iScreenOffsetY + (pThis->m_xRenderable2D.m_fY + pThis->m_xRenderable2D.m_fHeight * pThis->m_xRenderable2D.m_fScaleY) * g_xPaperAPI.m_fScreenRatioY;

		//Top Right Vertex
		vertdata->m_xVertices[3].m_xVector.x = g_xPaperAPI.m_iScreenOffsetX + (pThis->m_xRenderable2D.m_fX + pThis->m_xRenderable2D.m_fWidth * pThis->m_xRenderable2D.m_fScaleX) * g_xPaperAPI.m_fScreenRatioX;
		vertdata->m_xVertices[3].m_xVector.y = g_xPaperAPI.m_iScreenOffsetY + pThis->m_xRenderable2D.m_fY * g_xPaperAPI.m_fScreenRatioY;
	}
	else
	{
		xRenderable2DRotateVerts(&pThis->m_xRenderable2D,
								 &vertdata->m_xVertices[0].m_xVector.x, 
								 &vertdata->m_xVertices[0].m_xVector.y,
								 &vertdata->m_xVertices[1].m_xVector.x,
								 &vertdata->m_xVertices[1].m_xVector.y,
								 &vertdata->m_xVertices[2].m_xVector.x,
								 &vertdata->m_xVertices[2].m_xVector.y,
								 &vertdata->m_xVertices[3].m_xVector.x,
								 &vertdata->m_xVertices[3].m_xVector.y);
	}

	if(pThis->m_xRenderable2D.m_bMirrored)
	{
		texwidth = vertdata->m_xVertices[1].m_xVector.x;
		texheight = vertdata->m_xVertices[1].m_xVector.y;

		vertdata->m_xVertices[1].m_xVector.x = vertdata->m_xVertices[2].m_xVector.x;
		vertdata->m_xVertices[1].m_xVector.y = vertdata->m_xVertices[2].m_xVector.y;

		vertdata->m_xVertices[2].m_xVector.x = texwidth;
		vertdata->m_xVertices[2].m_xVector.y = texheight;

		texwidth = vertdata->m_xVertices[3].m_xVector.x;
		texheight = vertdata->m_xVertices[3].m_xVector.y;

		vertdata->m_xVertices[3].m_xVector.x = vertdata->m_xVertices[0].m_xVector.x;
		vertdata->m_xVertices[3].m_xVector.y = vertdata->m_xVertices[0].m_xVector.y;

		vertdata->m_xVertices[0].m_xVector.x = texwidth;
		vertdata->m_xVertices[0].m_xVector.y = texheight;
	}

	if(pThis->m_pTextures)
	{
		texwidth = pThis->m_fTextureWidth * (float)pThis->m_pTextures[0]->m_iWidth / (float)pThis->m_pTextures[0]->m_iDataWidth;
		texheight = 1.0 * pThis->m_fTextureHeight - ((float)pThis->m_pTextures[0]->m_iHeight / (float)pThis->m_pTextures[0]->m_iDataHeight);

		//Top Left Vertex
		vertdata->m_xVertices[0].m_xTextureCoords.x = 0.0;
		vertdata->m_xVertices[0].m_xTextureCoords.y = 1.0;

		//Bottom Left Vertex
		vertdata->m_xVertices[1].m_xTextureCoords.x = 0.0;
		vertdata->m_xVertices[1].m_xTextureCoords.y = texheight;

		//Bottom Right Vertex
		vertdata->m_xVertices[2].m_xTextureCoords.x = texwidth;
		vertdata->m_xVertices[2].m_xTextureCoords.y = texheight;

		//Top Right Vertex
		vertdata->m_xVertices[3].m_xTextureCoords.x = texwidth;
		vertdata->m_xVertices[3].m_xTextureCoords.y = 1.0;
	}
	
	vertdata->m_uiIndexBuffer = g_xGraphics.m_uiRectIndexBuffer;

	if(!vertdata->m_uiVertexBuffer)
		glGenBuffers(1, &vertdata->m_uiVertexBuffer);
	glBindBuffer(GL_ARRAY_BUFFER, vertdata->m_uiVertexBuffer);
	glBufferData(GL_ARRAY_BUFFER, sizeof(xTexturedVert) * vertdata->m_iVectorArrayLength, vertdata->m_xVertices, GL_STATIC_DRAW);

	xRenderable2DQuadUpdateShaderParameters(pThis);
}

void xRenderable2DQuadUpdateAnimation(xRenderable2DQuad *pThis, float fTime)
{
	pThis->m_fAnimationTime += fTime;

	while(pThis->m_fAnimationTime >= pThis->m_fAnimationRate)
	{
		pThis->m_iCurrentTexture++;

		if(pThis->m_iCurrentTexture >= pThis->m_iNumTextures)
			pThis->m_iCurrentTexture = 0;

		xRenderable2DQuadUpdateTexture(pThis, pThis->m_pTextures[pThis->m_iCurrentTexture]);

		pThis->m_fAnimationTime -= pThis->m_fAnimationRate;
	}
}

void xRenderable2DQuadUpdatePartialX(xRenderable2DQuad *pThis, float fLeftPercentage, float fRightPercentage)
{
	xRenderDataVerts *vertdata;
	float texleft, texright, texheight;

	DEBUGCHECK(!pThis || !pThis->m_xRenderable2D.m_pVertData || !pThis->m_xRenderable2D.m_pVertData->m_pTextureData || !pThis->m_xRenderable2D.m_pVertData->m_pShaderData);

	vertdata = pThis->m_xRenderable2D.m_pVertData;

	if(pThis->m_xRenderable2D.m_fRotation == 0.0)
	{
		//Top Left Vertex
		vertdata->m_xVertices[0].m_xVector.x = g_xPaperAPI.m_iScreenOffsetX + pThis->m_xRenderable2D.m_fX * g_xPaperAPI.m_fScreenRatioX;
		vertdata->m_xVertices[0].m_xVector.y = g_xPaperAPI.m_iScreenOffsetY + pThis->m_xRenderable2D.m_fY * g_xPaperAPI.m_fScreenRatioY;

		//Bottom Left Vertex
		vertdata->m_xVertices[1].m_xVector.x = g_xPaperAPI.m_iScreenOffsetX + pThis->m_xRenderable2D.m_fX * g_xPaperAPI.m_fScreenRatioX;
		vertdata->m_xVertices[1].m_xVector.y = g_xPaperAPI.m_iScreenOffsetY + (pThis->m_xRenderable2D.m_fY + pThis->m_xRenderable2D.m_fHeight * pThis->m_xRenderable2D.m_fScaleY) * g_xPaperAPI.m_fScreenRatioY;

		//Bottom Right Vertex
		vertdata->m_xVertices[2].m_xVector.x = g_xPaperAPI.m_iScreenOffsetX + (pThis->m_xRenderable2D.m_fX + pThis->m_xRenderable2D.m_fWidth * pThis->m_xRenderable2D.m_fScaleX) * g_xPaperAPI.m_fScreenRatioX;
		vertdata->m_xVertices[2].m_xVector.y = g_xPaperAPI.m_iScreenOffsetY + (pThis->m_xRenderable2D.m_fY + pThis->m_xRenderable2D.m_fHeight * pThis->m_xRenderable2D.m_fScaleY) * g_xPaperAPI.m_fScreenRatioY;

		//Top Right Vertex
		vertdata->m_xVertices[3].m_xVector.x = g_xPaperAPI.m_iScreenOffsetX + (pThis->m_xRenderable2D.m_fX + pThis->m_xRenderable2D.m_fWidth * pThis->m_xRenderable2D.m_fScaleX) * g_xPaperAPI.m_fScreenRatioX;
		vertdata->m_xVertices[3].m_xVector.y = g_xPaperAPI.m_iScreenOffsetY + pThis->m_xRenderable2D.m_fY * g_xPaperAPI.m_fScreenRatioY;
	}
	else
	{
		xRenderable2DRotateVerts(&pThis->m_xRenderable2D,
								 &vertdata->m_xVertices[0].m_xVector.x, 
								 &vertdata->m_xVertices[0].m_xVector.y,
								 &vertdata->m_xVertices[1].m_xVector.x,
								 &vertdata->m_xVertices[1].m_xVector.y,
								 &vertdata->m_xVertices[2].m_xVector.x,
								 &vertdata->m_xVertices[2].m_xVector.y,
								 &vertdata->m_xVertices[3].m_xVector.x,
								 &vertdata->m_xVertices[3].m_xVector.y);
	}

	texleft = (fLeftPercentage * (float)pThis->m_pTextures[0]->m_iWidth) / (float)pThis->m_pTextures[0]->m_iDataWidth;
	texright = (fRightPercentage * (float)pThis->m_pTextures[0]->m_iWidth) / (float)pThis->m_pTextures[0]->m_iDataWidth;
	texheight = 1.0 - ((float)pThis->m_pTextures[0]->m_iHeight / (float)pThis->m_pTextures[0]->m_iDataHeight);

	//Top Left Vertex
	vertdata->m_xVertices[0].m_xTextureCoords.x = texleft;
	vertdata->m_xVertices[0].m_xTextureCoords.y = 1.0;

	//Bottom Left Vertex
	vertdata->m_xVertices[1].m_xTextureCoords.x = texleft;
	vertdata->m_xVertices[1].m_xTextureCoords.y = texheight;

	//Bottom Right Vertex
	vertdata->m_xVertices[2].m_xTextureCoords.x = texright;
	vertdata->m_xVertices[2].m_xTextureCoords.y = texheight;

	//Top Right Vertex
	vertdata->m_xVertices[3].m_xTextureCoords.x = texright;
	vertdata->m_xVertices[3].m_xTextureCoords.y = 1.0;

	vertdata->m_uiIndexBuffer = g_xGraphics.m_uiRectIndexBuffer;

	if(!vertdata->m_uiVertexBuffer)
		glGenBuffers(1, &vertdata->m_uiVertexBuffer);
	glBindBuffer(GL_ARRAY_BUFFER, vertdata->m_uiVertexBuffer);
	glBufferData(GL_ARRAY_BUFFER, sizeof(xTexturedVert) * vertdata->m_iVectorArrayLength, vertdata->m_xVertices, GL_STATIC_DRAW);

	xRenderable2DQuadUpdateShaderParameters(pThis);
}

void xRenderable2DQuadUpdatePartialY(xRenderable2DQuad *pThis, float fPercentage)
{
	xRenderDataVerts *vertdata;
	float texwidth, textop, texbottom;

	DEBUGCHECK(!pThis || !pThis->m_xRenderable2D.m_pVertData || !pThis->m_xRenderable2D.m_pVertData->m_pTextureData || !pThis->m_xRenderable2D.m_pVertData->m_pShaderData);

	vertdata = pThis->m_xRenderable2D.m_pVertData;

	if(pThis->m_xRenderable2D.m_fRotation == 0.0)
	{
		//Top Left Vertex
		vertdata->m_xVertices[0].m_xVector.x = g_xPaperAPI.m_iScreenOffsetX + pThis->m_xRenderable2D.m_fX * g_xPaperAPI.m_fScreenRatioX;
		vertdata->m_xVertices[0].m_xVector.y = g_xPaperAPI.m_iScreenOffsetY + (pThis->m_xRenderable2D.m_fY + pThis->m_xRenderable2D.m_fHeight * (1.0f - fPercentage) * pThis->m_xRenderable2D.m_fScaleY) * g_xPaperAPI.m_fScreenRatioY;

		//Bottom Left Vertex
		vertdata->m_xVertices[1].m_xVector.x = g_xPaperAPI.m_iScreenOffsetX + pThis->m_xRenderable2D.m_fX * g_xPaperAPI.m_fScreenRatioX;
		vertdata->m_xVertices[1].m_xVector.y = g_xPaperAPI.m_iScreenOffsetY + (pThis->m_xRenderable2D.m_fY + pThis->m_xRenderable2D.m_fHeight * pThis->m_xRenderable2D.m_fScaleY) * g_xPaperAPI.m_fScreenRatioY;

		//Bottom Right Vertex
		vertdata->m_xVertices[2].m_xVector.x = g_xPaperAPI.m_iScreenOffsetX + (pThis->m_xRenderable2D.m_fX + pThis->m_xRenderable2D.m_fWidth * pThis->m_xRenderable2D.m_fScaleX) * g_xPaperAPI.m_fScreenRatioX;
		vertdata->m_xVertices[2].m_xVector.y = g_xPaperAPI.m_iScreenOffsetY + (pThis->m_xRenderable2D.m_fY + pThis->m_xRenderable2D.m_fHeight * pThis->m_xRenderable2D.m_fScaleY) * g_xPaperAPI.m_fScreenRatioY;

		//Top Right Vertex
		vertdata->m_xVertices[3].m_xVector.x = g_xPaperAPI.m_iScreenOffsetX + (pThis->m_xRenderable2D.m_fX + pThis->m_xRenderable2D.m_fWidth * pThis->m_xRenderable2D.m_fScaleX) * g_xPaperAPI.m_fScreenRatioX;
		vertdata->m_xVertices[3].m_xVector.y = g_xPaperAPI.m_iScreenOffsetY + (pThis->m_xRenderable2D.m_fY + pThis->m_xRenderable2D.m_fHeight * (1.0f - fPercentage) * pThis->m_xRenderable2D.m_fScaleY) * g_xPaperAPI.m_fScreenRatioY;
	}
	else
	{
		xRenderable2DRotateVerts(&pThis->m_xRenderable2D,
								 &vertdata->m_xVertices[0].m_xVector.x, 
								 &vertdata->m_xVertices[0].m_xVector.y,
								 &vertdata->m_xVertices[1].m_xVector.x,
								 &vertdata->m_xVertices[1].m_xVector.y,
								 &vertdata->m_xVertices[2].m_xVector.x,
								 &vertdata->m_xVertices[2].m_xVector.y,
								 &vertdata->m_xVertices[3].m_xVector.x,
								 &vertdata->m_xVertices[3].m_xVector.y);
	}

	texwidth = (float)pThis->m_pTextures[0]->m_iWidth / (float)pThis->m_pTextures[0]->m_iDataWidth;
	texbottom = 1.0 - ((float)pThis->m_pTextures[0]->m_iHeight / (float)pThis->m_pTextures[0]->m_iDataHeight);
	textop = texbottom + fPercentage * ((float)pThis->m_pTextures[0]->m_iHeight / (float)pThis->m_pTextures[0]->m_iDataHeight);

	//Top Left Vertex
	vertdata->m_xVertices[0].m_xTextureCoords.x = 0.0;
	vertdata->m_xVertices[0].m_xTextureCoords.y = textop;

	//Bottom Left Vertex
	vertdata->m_xVertices[1].m_xTextureCoords.x = 0.0;
	vertdata->m_xVertices[1].m_xTextureCoords.y = texbottom;

	//Bottom Right Vertex
	vertdata->m_xVertices[2].m_xTextureCoords.x = texwidth;
	vertdata->m_xVertices[2].m_xTextureCoords.y = texbottom;

	//Top Right Vertex
	vertdata->m_xVertices[3].m_xTextureCoords.x = texwidth;
	vertdata->m_xVertices[3].m_xTextureCoords.y = textop;

	vertdata->m_uiIndexBuffer = g_xGraphics.m_uiRectIndexBuffer;

	if(!vertdata->m_uiVertexBuffer)
		glGenBuffers(1, &vertdata->m_uiVertexBuffer);
	glBindBuffer(GL_ARRAY_BUFFER, vertdata->m_uiVertexBuffer);
	glBufferData(GL_ARRAY_BUFFER, sizeof(xTexturedVert) * vertdata->m_iVectorArrayLength, vertdata->m_xVertices, GL_STATIC_DRAW);

	xRenderable2DQuadUpdateShaderParameters(pThis);
}

void xRenderable2DQuad3HorizontalUpdate(xRenderable2DQuad *pThis)
{
	xRenderDataVerts *vertdata;
	float x0, x25, x75, x100, y0, y100;

	DEBUGCHECK(!pThis || !pThis->m_xRenderable2D.m_pVertData || !pThis->m_xRenderable2D.m_pVertData->m_pTextureData || !pThis->m_xRenderable2D.m_pVertData->m_pShaderData);

	vertdata = pThis->m_xRenderable2D.m_pVertData;

	x0 = g_xPaperAPI.m_iScreenOffsetX + pThis->m_xRenderable2D.m_fX * g_xPaperAPI.m_fScreenRatioX;
	x100 = g_xPaperAPI.m_iScreenOffsetX + (pThis->m_xRenderable2D.m_fX + pThis->m_xRenderable2D.m_fWidth * pThis->m_xRenderable2D.m_fScaleX) * g_xPaperAPI.m_fScreenRatioX;
	x25 = g_xPaperAPI.m_iScreenOffsetX + (pThis->m_xRenderable2D.m_fX + (float)pThis->m_pTextures[0]->m_iWidth * 0.25) * g_xPaperAPI.m_fScreenRatioX;
	x75 = x100 - ((float)pThis->m_pTextures[0]->m_iWidth * 0.25 * g_xPaperAPI.m_fScreenRatioX);

	y0 = g_xPaperAPI.m_iScreenOffsetY + pThis->m_xRenderable2D.m_fY * g_xPaperAPI.m_fScreenRatioY;
	y100 = g_xPaperAPI.m_iScreenOffsetY + (pThis->m_xRenderable2D.m_fY + pThis->m_xRenderable2D.m_fHeight * pThis->m_xRenderable2D.m_fScaleY) * g_xPaperAPI.m_fScreenRatioY;

//	if(pThis->m_xRenderable2D.m_fRotation == 0.0)
//	{
		// Left Quad
		InitVector(&vertdata->m_xVertices[0].m_xVector, x0, y0);
		InitVector(&vertdata->m_xVertices[1].m_xVector, x0, y100);
		InitVector(&vertdata->m_xVertices[2].m_xVector, x25, y100);
		InitVector(&vertdata->m_xVertices[3].m_xVector, x25, y0);

		// Center Quad
		InitVector(&vertdata->m_xVertices[4].m_xVector, x25, y0);
		InitVector(&vertdata->m_xVertices[5].m_xVector, x25, y100);
		InitVector(&vertdata->m_xVertices[6].m_xVector, x75, y100);
		InitVector(&vertdata->m_xVertices[7].m_xVector, x75, y0);

		// Right Quad
		InitVector(&vertdata->m_xVertices[8].m_xVector, x75, y0);
		InitVector(&vertdata->m_xVertices[9].m_xVector, x75, y100);
		InitVector(&vertdata->m_xVertices[10].m_xVector, x100, y100);
		InitVector(&vertdata->m_xVertices[11].m_xVector, x100, y0);
/*	}
	else
	{
		xRenderable2DRotateVerts(&pThis->m_xRenderable2D,
								 &vertdata->m_xVertices[0].x, 
								 &vertdata->m_xVertices[0].y,
								 &vertdata->m_xVertices[1].x,
								 &vertdata->m_xVertices[1].y,
								 &vertdata->m_xVertices[2].x,
								 &vertdata->m_xVertices[2].y,
								 &vertdata->m_xVertices[3].x,
								 &vertdata->m_xVertices[3].y);
	}
*/
	x100 = (float)pThis->m_pTextures[0]->m_iWidth / (float)pThis->m_pTextures[0]->m_iDataWidth;
	x25 = x100 * 0.25;
	x75 = x100 * 0.75;

	y100 = 1.0 - ((float)pThis->m_pTextures[0]->m_iHeight / (float)pThis->m_pTextures[0]->m_iDataHeight);

	// Left Quad
	InitVector(&vertdata->m_xVertices[0].m_xTextureCoords, 0.0, 1.0);
	InitVector(&vertdata->m_xVertices[1].m_xTextureCoords, 0.0, y100);
	InitVector(&vertdata->m_xVertices[2].m_xTextureCoords, x25, y100);
	InitVector(&vertdata->m_xVertices[3].m_xTextureCoords, x25, 1.0);

	// Center Quad
	InitVector(&vertdata->m_xVertices[4].m_xTextureCoords, x25, 1.0);
	InitVector(&vertdata->m_xVertices[5].m_xTextureCoords, x25, y100);
	InitVector(&vertdata->m_xVertices[6].m_xTextureCoords, x75, y100);
	InitVector(&vertdata->m_xVertices[7].m_xTextureCoords, x75, 1.0);

	// Right Quad
	InitVector(&vertdata->m_xVertices[8].m_xTextureCoords, x75, 1.0);
	InitVector(&vertdata->m_xVertices[9].m_xTextureCoords, x75, y100);
	InitVector(&vertdata->m_xVertices[10].m_xTextureCoords, x100, y100);
	InitVector(&vertdata->m_xVertices[11].m_xTextureCoords, x100, 1.0);

	vertdata->m_uiIndexBuffer = g_xGraphics.m_ui3RectIndexBuffer;

	if(!vertdata->m_uiVertexBuffer)
		glGenBuffers(1, &vertdata->m_uiVertexBuffer);
	glBindBuffer(GL_ARRAY_BUFFER, vertdata->m_uiVertexBuffer);
	glBufferData(GL_ARRAY_BUFFER, sizeof(xTexturedVert) * vertdata->m_iVectorArrayLength, vertdata->m_xVertices, GL_STATIC_DRAW);

	xRenderable2DQuadUpdateShaderParameters(pThis);
}

void xRenderable2DQuad3VerticalUpdate(xRenderable2DQuad *pThis)
{
	xRenderDataVerts *vertdata;
	float x0, x100, y0, y25, y75, y100;

	DEBUGCHECK(!pThis || !pThis->m_xRenderable2D.m_pVertData || !pThis->m_xRenderable2D.m_pVertData->m_pTextureData || !pThis->m_xRenderable2D.m_pVertData->m_pShaderData);

	vertdata = pThis->m_xRenderable2D.m_pVertData;

	x0 = g_xPaperAPI.m_iScreenOffsetX + pThis->m_xRenderable2D.m_fX * g_xPaperAPI.m_fScreenRatioX;
	x100 = g_xPaperAPI.m_iScreenOffsetX + (pThis->m_xRenderable2D.m_fX + pThis->m_xRenderable2D.m_fWidth * pThis->m_xRenderable2D.m_fScaleX) * g_xPaperAPI.m_fScreenRatioX;

	y0 = g_xPaperAPI.m_iScreenOffsetY + pThis->m_xRenderable2D.m_fY * g_xPaperAPI.m_fScreenRatioY;
	y25 = g_xPaperAPI.m_iScreenOffsetY + (pThis->m_xRenderable2D.m_fY + (float)pThis->m_pTextures[0]->m_iHeight * 0.25) * g_xPaperAPI.m_fScreenRatioY;
	y75 = g_xPaperAPI.m_iScreenOffsetY + (pThis->m_xRenderable2D.m_fY + pThis->m_xRenderable2D.m_fHeight - (float)pThis->m_pTextures[0]->m_iHeight * 0.25) * g_xPaperAPI.m_fScreenRatioY;
	y100 = g_xPaperAPI.m_iScreenOffsetY + (pThis->m_xRenderable2D.m_fY + pThis->m_xRenderable2D.m_fHeight * pThis->m_xRenderable2D.m_fScaleY) * g_xPaperAPI.m_fScreenRatioY;

//	if(pThis->m_xRenderable2D.m_fRotation == 0.0)
//	{
		// Top Quad
		InitVector(&vertdata->m_xVertices[0].m_xVector, x0, y0);
		InitVector(&vertdata->m_xVertices[1].m_xVector, x0, y25);
		InitVector(&vertdata->m_xVertices[2].m_xVector, x100, y25);
		InitVector(&vertdata->m_xVertices[3].m_xVector, x100, y0);

		// Center Quad
		InitVector(&vertdata->m_xVertices[4].m_xVector, x0, y25);
		InitVector(&vertdata->m_xVertices[5].m_xVector, x0, y75);
		InitVector(&vertdata->m_xVertices[6].m_xVector, x100, y75);
		InitVector(&vertdata->m_xVertices[7].m_xVector, x100, y25);

		// Bottom Quad
		InitVector(&vertdata->m_xVertices[8].m_xVector, x0, y75);
		InitVector(&vertdata->m_xVertices[9].m_xVector, x0, y100);
		InitVector(&vertdata->m_xVertices[10].m_xVector, x100, y100);
		InitVector(&vertdata->m_xVertices[11].m_xVector, x100, y75);
/*	}
	else
	{
		xRenderable2DRotateVerts(&pThis->m_xRenderable2D,
								 &vertdata->m_xVertices[0].x, 
								 &vertdata->m_xVertices[0].y,
								 &vertdata->m_xVertices[1].x,
								 &vertdata->m_xVertices[1].y,
								 &vertdata->m_xVertices[2].x,
								 &vertdata->m_xVertices[2].y,
								 &vertdata->m_xVertices[3].x,
								 &vertdata->m_xVertices[3].y);
	}
*/
	x100 = (float)pThis->m_pTextures[0]->m_iWidth / (float)pThis->m_pTextures[0]->m_iDataWidth;

	y100 = ((float)pThis->m_pTextures[0]->m_iHeight / (float)pThis->m_pTextures[0]->m_iDataHeight);
	y25 = 1.0 - (y100 * 0.25);
	y75 = 1.0 - (y100 * 0.75);
	y100 = 1.0 - y100;

	// Top Quad
	InitVector(&vertdata->m_xVertices[0].m_xTextureCoords, 0.0, 1.0);
	InitVector(&vertdata->m_xVertices[1].m_xTextureCoords, 0.0, y25);
	InitVector(&vertdata->m_xVertices[2].m_xTextureCoords, x100, y25);
	InitVector(&vertdata->m_xVertices[3].m_xTextureCoords, x100, 1.0);

	// Center Quad
	InitVector(&vertdata->m_xVertices[4].m_xTextureCoords, 0.0, y25);
	InitVector(&vertdata->m_xVertices[5].m_xTextureCoords, 0.0, y75);
	InitVector(&vertdata->m_xVertices[6].m_xTextureCoords, x100, y75);
	InitVector(&vertdata->m_xVertices[7].m_xTextureCoords, x100, y25);

	// Bottom Quad
	InitVector(&vertdata->m_xVertices[8].m_xTextureCoords, 0.0, y75);
	InitVector(&vertdata->m_xVertices[9].m_xTextureCoords, 0.0, y100);
	InitVector(&vertdata->m_xVertices[10].m_xTextureCoords, x100, y100);
	InitVector(&vertdata->m_xVertices[11].m_xTextureCoords, x100, y75);

	vertdata->m_uiIndexBuffer = g_xGraphics.m_ui3RectIndexBuffer;

	if(!vertdata->m_uiVertexBuffer)
		glGenBuffers(1, &vertdata->m_uiVertexBuffer);
	glBindBuffer(GL_ARRAY_BUFFER, vertdata->m_uiVertexBuffer);
	glBufferData(GL_ARRAY_BUFFER, sizeof(xTexturedVert) * vertdata->m_iVectorArrayLength, vertdata->m_xVertices, GL_STATIC_DRAW);

	xRenderable2DQuadUpdateShaderParameters(pThis);
}

void xRenderable2DQuad4UpdateRadialPercentage(xRenderable2DQuad *pThis, float fPercentage)
{
	xRenderDataVerts *vertdata;
	float halfwidth, halfheight, xcoord, ycoord, angle;

	vertdata = pThis->m_xRenderable2D.m_pVertData;

	halfwidth = pThis->m_xRenderable2D.m_fWidth / 2;
	halfheight = pThis->m_xRenderable2D.m_fHeight / 2;

	// Top Right Quad
	if(fPercentage > 0.75)
	{
		angle = ((fPercentage - 0.75) / 0.25) * (PI / 2);
		if(fPercentage >= 0.875)
		{
			xcoord = 0.5 + ((cos(angle) / sin(angle)) * 0.5);
			ycoord = 1.0;
		}
		else
		{
			ycoord = 0.5 + ((sin(angle) / cos(angle)) * 0.5);
			xcoord = 1.0;
		}

		//Top Left Vertex
		InitVector(&vertdata->m_xVertices[0].m_xTextureCoords, xcoord, ycoord);
		InitVector(&vertdata->m_xVertices[0].m_xVector, g_xPaperAPI.m_iScreenOffsetX + (pThis->m_xRenderable2D.m_fX + (xcoord * pThis->m_xRenderable2D.m_fWidth)) * g_xPaperAPI.m_fScreenRatioX, g_xPaperAPI.m_iScreenOffsetY + (pThis->m_xRenderable2D.m_fY + ((1.0 - ycoord) * pThis->m_xRenderable2D.m_fHeight)) * g_xPaperAPI.m_fScreenRatioY);

		//Bottom Left Vertex
		InitVector(&vertdata->m_xVertices[1].m_xTextureCoords, 0.5, 0.5);
		InitVector(&vertdata->m_xVertices[1].m_xVector, g_xPaperAPI.m_iScreenOffsetX + (pThis->m_xRenderable2D.m_fX + halfwidth) * g_xPaperAPI.m_fScreenRatioX, g_xPaperAPI.m_iScreenOffsetY + (pThis->m_xRenderable2D.m_fY + halfheight) * g_xPaperAPI.m_fScreenRatioY);

		//Bottom Right Vertex
		InitVector(&vertdata->m_xVertices[2].m_xTextureCoords, 1.0, 0.5);
		InitVector(&vertdata->m_xVertices[2].m_xVector, g_xPaperAPI.m_iScreenOffsetX + (pThis->m_xRenderable2D.m_fX + pThis->m_xRenderable2D.m_fWidth) * g_xPaperAPI.m_fScreenRatioX, g_xPaperAPI.m_iScreenOffsetY + (pThis->m_xRenderable2D.m_fY + halfheight) * g_xPaperAPI.m_fScreenRatioY);

		//Top Right Vertex
		InitVector(&vertdata->m_xVertices[3].m_xTextureCoords, 1.0, ycoord);
		InitVector(&vertdata->m_xVertices[3].m_xVector, g_xPaperAPI.m_iScreenOffsetX + (pThis->m_xRenderable2D.m_fX + pThis->m_xRenderable2D.m_fWidth) * g_xPaperAPI.m_fScreenRatioX, g_xPaperAPI.m_iScreenOffsetY + (pThis->m_xRenderable2D.m_fY + ((1.0 - ycoord) * pThis->m_xRenderable2D.m_fHeight)) * g_xPaperAPI.m_fScreenRatioY);
	}
	else
	{
		InitVector(&vertdata->m_xVertices[0].m_xVector, pThis->m_xRenderable2D.m_fX, pThis->m_xRenderable2D.m_fY);
		InitVector(&vertdata->m_xVertices[1].m_xVector, pThis->m_xRenderable2D.m_fX, pThis->m_xRenderable2D.m_fY);
		InitVector(&vertdata->m_xVertices[2].m_xVector, pThis->m_xRenderable2D.m_fX, pThis->m_xRenderable2D.m_fY);
		InitVector(&vertdata->m_xVertices[3].m_xVector, pThis->m_xRenderable2D.m_fX, pThis->m_xRenderable2D.m_fY);
	}

	// Bottom Right Quad
	if(fPercentage > 0.50)
	{
		if(fPercentage >= 0.75)
		{
			xcoord = 1.0;
			ycoord = 0.5;
		}
		else
		{
			angle = ((fPercentage - 0.50) / 0.25) * (PI / 2);
			if(fPercentage >= 0.625)
			{
				ycoord = (1.0 - (cos(angle) / sin(angle))) * 0.5;
				xcoord = 1.0;
			}
			else
			{
				xcoord = 0.5 + ((sin(angle) / cos(angle)) * 0.5);
				ycoord = 0.0;
			}
		}

		//Top Left Vertex
		InitVector(&vertdata->m_xVertices[4].m_xTextureCoords, 0.5, 0.5);
		InitVector(&vertdata->m_xVertices[4].m_xVector, g_xPaperAPI.m_iScreenOffsetX + (pThis->m_xRenderable2D.m_fX + halfwidth) * g_xPaperAPI.m_fScreenRatioX, g_xPaperAPI.m_iScreenOffsetY + (pThis->m_xRenderable2D.m_fY + halfheight) * g_xPaperAPI.m_fScreenRatioY);

		//Bottom Left Vertex
		InitVector(&vertdata->m_xVertices[5].m_xTextureCoords, 0.5, 0.0);
		InitVector(&vertdata->m_xVertices[5].m_xVector, g_xPaperAPI.m_iScreenOffsetX + (pThis->m_xRenderable2D.m_fX + halfwidth) * g_xPaperAPI.m_fScreenRatioX, g_xPaperAPI.m_iScreenOffsetY + (pThis->m_xRenderable2D.m_fY + pThis->m_xRenderable2D.m_fHeight) * g_xPaperAPI.m_fScreenRatioY);

		//Bottom Right Vertex
		InitVector(&vertdata->m_xVertices[6].m_xTextureCoords, xcoord, 0.0);
		InitVector(&vertdata->m_xVertices[6].m_xVector, g_xPaperAPI.m_iScreenOffsetX + (pThis->m_xRenderable2D.m_fX + (xcoord * pThis->m_xRenderable2D.m_fWidth)) * g_xPaperAPI.m_fScreenRatioX, g_xPaperAPI.m_iScreenOffsetY + (pThis->m_xRenderable2D.m_fY + pThis->m_xRenderable2D.m_fHeight) * g_xPaperAPI.m_fScreenRatioY);

		//Top Right Vertex
		InitVector(&vertdata->m_xVertices[7].m_xTextureCoords, xcoord, ycoord);
		InitVector(&vertdata->m_xVertices[7].m_xVector, g_xPaperAPI.m_iScreenOffsetX + (pThis->m_xRenderable2D.m_fX + (xcoord * pThis->m_xRenderable2D.m_fWidth)) * g_xPaperAPI.m_fScreenRatioX, g_xPaperAPI.m_iScreenOffsetY + (pThis->m_xRenderable2D.m_fY + ((1.0 - ycoord) * pThis->m_xRenderable2D.m_fHeight)) * g_xPaperAPI.m_fScreenRatioY);
	}
	else
	{
		InitVector(&vertdata->m_xVertices[4].m_xVector, pThis->m_xRenderable2D.m_fX, pThis->m_xRenderable2D.m_fY);
		InitVector(&vertdata->m_xVertices[5].m_xVector, pThis->m_xRenderable2D.m_fX, pThis->m_xRenderable2D.m_fY);
		InitVector(&vertdata->m_xVertices[6].m_xVector, pThis->m_xRenderable2D.m_fX, pThis->m_xRenderable2D.m_fY);
		InitVector(&vertdata->m_xVertices[7].m_xVector, pThis->m_xRenderable2D.m_fX, pThis->m_xRenderable2D.m_fY);
	}

	// Bottom Left Quad
	if(fPercentage > 0.25)
	{
		if(fPercentage >= 0.5)
		{
			xcoord = 0.5;
			ycoord = 0.0;
		}
		else
		{
			angle = ((fPercentage - 0.25) / 0.25) * (PI / 2);
			if(fPercentage >= 0.375)
			{
				xcoord = (1.0 - (cos(angle) / sin(angle))) * 0.5;
				ycoord = 0.0;
			}
			else
			{
				ycoord = (1.0 - (sin(angle) / cos(angle))) * 0.5;
				xcoord = 0.0;
			}
		}

		//Top Left Vertex
		InitVector(&vertdata->m_xVertices[8].m_xTextureCoords, 0.0, 0.5);
		InitVector(&vertdata->m_xVertices[8].m_xVector, g_xPaperAPI.m_iScreenOffsetX + pThis->m_xRenderable2D.m_fX * g_xPaperAPI.m_fScreenRatioX, g_xPaperAPI.m_iScreenOffsetY + (pThis->m_xRenderable2D.m_fY + halfheight) * g_xPaperAPI.m_fScreenRatioY);

		//Bottom Left Vertex
		InitVector(&vertdata->m_xVertices[9].m_xTextureCoords, 0.0, ycoord);
		InitVector(&vertdata->m_xVertices[9].m_xVector, g_xPaperAPI.m_iScreenOffsetX + pThis->m_xRenderable2D.m_fX * g_xPaperAPI.m_fScreenRatioX, g_xPaperAPI.m_iScreenOffsetY + (pThis->m_xRenderable2D.m_fY + ((1.0 - ycoord) * pThis->m_xRenderable2D.m_fHeight)) * g_xPaperAPI.m_fScreenRatioY);

		//Bottom Right Vertex
		InitVector(&vertdata->m_xVertices[10].m_xTextureCoords, xcoord, ycoord);
		InitVector(&vertdata->m_xVertices[10].m_xVector, g_xPaperAPI.m_iScreenOffsetX + (pThis->m_xRenderable2D.m_fX + (xcoord * pThis->m_xRenderable2D.m_fWidth)) * g_xPaperAPI.m_fScreenRatioX, g_xPaperAPI.m_iScreenOffsetY + (pThis->m_xRenderable2D.m_fY + ((1.0 - ycoord) * pThis->m_xRenderable2D.m_fHeight)) * g_xPaperAPI.m_fScreenRatioY);

		//Top Right Vertex
		InitVector(&vertdata->m_xVertices[11].m_xTextureCoords, 0.5, 0.5);
		InitVector(&vertdata->m_xVertices[11].m_xVector, g_xPaperAPI.m_iScreenOffsetX + (pThis->m_xRenderable2D.m_fX + halfwidth) * g_xPaperAPI.m_fScreenRatioX, g_xPaperAPI.m_iScreenOffsetY + (pThis->m_xRenderable2D.m_fY + halfheight) * g_xPaperAPI.m_fScreenRatioY);
	}
	else
	{
		InitVector(&vertdata->m_xVertices[8].m_xVector, pThis->m_xRenderable2D.m_fX, pThis->m_xRenderable2D.m_fY);
		InitVector(&vertdata->m_xVertices[9].m_xVector, pThis->m_xRenderable2D.m_fX, pThis->m_xRenderable2D.m_fY);
		InitVector(&vertdata->m_xVertices[10].m_xVector, pThis->m_xRenderable2D.m_fX, pThis->m_xRenderable2D.m_fY);
		InitVector(&vertdata->m_xVertices[11].m_xVector, pThis->m_xRenderable2D.m_fX, pThis->m_xRenderable2D.m_fY);
	}

	// Top Left Quad
	if(fPercentage > 0.0)
	{
		if(fPercentage >= 0.25)
		{
			xcoord = 0.0;
			ycoord = 0.5;
		}
		else
		{
			angle = (fPercentage / 0.25) * (PI / 2);
			if(fPercentage >= 0.125)
			{
				ycoord = 0.5 + ((cos(angle) / sin(angle)) * 0.5);
				xcoord = 0.0;
			}
			else
			{
				xcoord = (1.0 - (sin(angle) / cos(angle))) * 0.5;
				ycoord = 1.0;
			}
		}

		//Top Left Vertex
		InitVector(&vertdata->m_xVertices[12].m_xTextureCoords, xcoord, 1.0);
		InitVector(&vertdata->m_xVertices[12].m_xVector, g_xPaperAPI.m_iScreenOffsetX + (pThis->m_xRenderable2D.m_fX + (xcoord * pThis->m_xRenderable2D.m_fWidth)) * g_xPaperAPI.m_fScreenRatioX, g_xPaperAPI.m_iScreenOffsetY + pThis->m_xRenderable2D.m_fY * g_xPaperAPI.m_fScreenRatioY);

		//Bottom Left Vertex
		InitVector(&vertdata->m_xVertices[13].m_xTextureCoords, xcoord, ycoord);
		InitVector(&vertdata->m_xVertices[13].m_xVector, g_xPaperAPI.m_iScreenOffsetX + (pThis->m_xRenderable2D.m_fX + (xcoord * pThis->m_xRenderable2D.m_fWidth)) * g_xPaperAPI.m_fScreenRatioX, g_xPaperAPI.m_iScreenOffsetY + (pThis->m_xRenderable2D.m_fY + ((1.0 - ycoord) * pThis->m_xRenderable2D.m_fHeight)) * g_xPaperAPI.m_fScreenRatioY);

		//Bottom Right Vertex
		InitVector(&vertdata->m_xVertices[14].m_xTextureCoords, 0.5, 0.5);
		InitVector(&vertdata->m_xVertices[14].m_xVector, g_xPaperAPI.m_iScreenOffsetX + (pThis->m_xRenderable2D.m_fX + halfwidth) * g_xPaperAPI.m_fScreenRatioX, g_xPaperAPI.m_iScreenOffsetY + (pThis->m_xRenderable2D.m_fY + halfheight) * g_xPaperAPI.m_fScreenRatioY);

		//Top Right Vertex
		InitVector(&vertdata->m_xVertices[15].m_xTextureCoords, 0.5, 1.0);
		InitVector(&vertdata->m_xVertices[15].m_xVector, g_xPaperAPI.m_iScreenOffsetX + (pThis->m_xRenderable2D.m_fX + halfwidth) * g_xPaperAPI.m_fScreenRatioX, g_xPaperAPI.m_iScreenOffsetY + pThis->m_xRenderable2D.m_fY * g_xPaperAPI.m_fScreenRatioY);
	}
	else
	{
		InitVector(&vertdata->m_xVertices[12].m_xVector, pThis->m_xRenderable2D.m_fX, pThis->m_xRenderable2D.m_fY);
		InitVector(&vertdata->m_xVertices[13].m_xVector, pThis->m_xRenderable2D.m_fX, pThis->m_xRenderable2D.m_fY);
		InitVector(&vertdata->m_xVertices[14].m_xVector, pThis->m_xRenderable2D.m_fX, pThis->m_xRenderable2D.m_fY);
		InitVector(&vertdata->m_xVertices[15].m_xVector, pThis->m_xRenderable2D.m_fX, pThis->m_xRenderable2D.m_fY);
	}

	vertdata->m_uiIndexBuffer = g_xGraphics.m_ui4RectIndexBuffer;

	if(!vertdata->m_uiVertexBuffer)
		glGenBuffers(1, &vertdata->m_uiVertexBuffer);
	glBindBuffer(GL_ARRAY_BUFFER, vertdata->m_uiVertexBuffer);
	glBufferData(GL_ARRAY_BUFFER, sizeof(xTexturedVert) * vertdata->m_iVectorArrayLength, vertdata->m_xVertices, GL_STATIC_DRAW);
}

void xRenderable2DQuad9Update(xRenderable2DQuad *pThis)
{
	xRenderDataVerts *vertdata;
	float x0, x25, x75, x100;
	float y0, y25, y75, y100;

	DEBUGCHECK(!pThis || !pThis->m_xRenderable2D.m_pVertData || !pThis->m_xRenderable2D.m_pVertData->m_pTextureData || !pThis->m_xRenderable2D.m_pVertData->m_pShaderData);

	vertdata = pThis->m_xRenderable2D.m_pVertData;

	x0 = g_xPaperAPI.m_iScreenOffsetX + pThis->m_xRenderable2D.m_fX * g_xPaperAPI.m_fScreenRatioX;
	x100 = g_xPaperAPI.m_iScreenOffsetX + (pThis->m_xRenderable2D.m_fX + pThis->m_xRenderable2D.m_fWidth * pThis->m_xRenderable2D.m_fScaleX) * g_xPaperAPI.m_fScreenRatioX;
	x25 = g_xPaperAPI.m_iScreenOffsetX + (pThis->m_xRenderable2D.m_fX + (float)pThis->m_pTextures[0]->m_iWidth * 0.25) * g_xPaperAPI.m_fScreenRatioX;
	x75 = x100 - ((float)pThis->m_pTextures[0]->m_iWidth * 0.25) * g_xPaperAPI.m_fScreenRatioX;

	y0 = g_xPaperAPI.m_iScreenOffsetY + pThis->m_xRenderable2D.m_fY * g_xPaperAPI.m_fScreenRatioY;
	y100 = g_xPaperAPI.m_iScreenOffsetY + (pThis->m_xRenderable2D.m_fY + pThis->m_xRenderable2D.m_fHeight * pThis->m_xRenderable2D.m_fScaleY) * g_xPaperAPI.m_fScreenRatioY;
	y25 = g_xPaperAPI.m_iScreenOffsetY + (pThis->m_xRenderable2D.m_fY + (float)pThis->m_pTextures[0]->m_iHeight * 0.25) * g_xPaperAPI.m_fScreenRatioY;
	y75 = y100 - ((float)pThis->m_pTextures[0]->m_iHeight * 0.25) * g_xPaperAPI.m_fScreenRatioY;

//	if(pThis->m_xRenderable2D.m_fRotation == 0.0)
//	{
		// Top Left Quad
		InitVector(&vertdata->m_xVertices[0].m_xVector, x0, y0);
		InitVector(&vertdata->m_xVertices[1].m_xVector, x0, y25);
		InitVector(&vertdata->m_xVertices[2].m_xVector, x25, y25);
		InitVector(&vertdata->m_xVertices[3].m_xVector, x25, y0);

		// Top Center Quad
		InitVector(&vertdata->m_xVertices[4].m_xVector, x25, y0);
		InitVector(&vertdata->m_xVertices[5].m_xVector, x25, y25);
		InitVector(&vertdata->m_xVertices[6].m_xVector, x75, y25);
		InitVector(&vertdata->m_xVertices[7].m_xVector, x75, y0);

		// Top Right Quad
		InitVector(&vertdata->m_xVertices[8].m_xVector, x75, y0);
		InitVector(&vertdata->m_xVertices[9].m_xVector, x75, y25);
		InitVector(&vertdata->m_xVertices[10].m_xVector, x100, y25);
		InitVector(&vertdata->m_xVertices[11].m_xVector, x100, y0);

		// Middle Left Quad
		InitVector(&vertdata->m_xVertices[12].m_xVector, x0, y25);
		InitVector(&vertdata->m_xVertices[13].m_xVector, x0, y75);
		InitVector(&vertdata->m_xVertices[14].m_xVector, x25, y75);
		InitVector(&vertdata->m_xVertices[15].m_xVector, x25, y25);

		// Middle Center Quad
		InitVector(&vertdata->m_xVertices[16].m_xVector, x25, y25);
		InitVector(&vertdata->m_xVertices[17].m_xVector, x25, y75);
		InitVector(&vertdata->m_xVertices[18].m_xVector, x75, y75);
		InitVector(&vertdata->m_xVertices[19].m_xVector, x75, y25);

		// Middle Right Quad
		InitVector(&vertdata->m_xVertices[20].m_xVector, x75, y25);
		InitVector(&vertdata->m_xVertices[21].m_xVector, x75, y75);
		InitVector(&vertdata->m_xVertices[22].m_xVector, x100, y75);
		InitVector(&vertdata->m_xVertices[23].m_xVector, x100, y25);

		// Bottom Left Quad
		InitVector(&vertdata->m_xVertices[24].m_xVector, x0, y75);
		InitVector(&vertdata->m_xVertices[25].m_xVector, x0, y100);
		InitVector(&vertdata->m_xVertices[26].m_xVector, x25, y100);
		InitVector(&vertdata->m_xVertices[27].m_xVector, x25, y75);

		// Bottom Center Quad
		InitVector(&vertdata->m_xVertices[28].m_xVector, x25, y75);
		InitVector(&vertdata->m_xVertices[29].m_xVector, x25, y100);
		InitVector(&vertdata->m_xVertices[30].m_xVector, x75, y100);
		InitVector(&vertdata->m_xVertices[31].m_xVector, x75, y75);

		// Bottom Right Quad
		InitVector(&vertdata->m_xVertices[32].m_xVector, x75, y75);
		InitVector(&vertdata->m_xVertices[33].m_xVector, x75, y100);
		InitVector(&vertdata->m_xVertices[34].m_xVector, x100, y100);
		InitVector(&vertdata->m_xVertices[35].m_xVector, x100, y75);
/*	}
	else
	{
		xRenderable2DRotateVerts(&pThis->m_xRenderable2D,
								 &vertdata->m_xVertices[0].x, 
								 &vertdata->m_xVertices[0].y,
								 &vertdata->m_xVertices[1].x,
								 &vertdata->m_xVertices[1].y,
								 &vertdata->m_xVertices[2].x,
								 &vertdata->m_xVertices[2].y,
								 &vertdata->m_xVertices[3].x,
								 &vertdata->m_xVertices[3].y);
	}
*/
	x100 = (float)pThis->m_pTextures[0]->m_iWidth / (float)pThis->m_pTextures[0]->m_iDataWidth;
	x0 = 0.0;
	x25 = x100 * 0.25;
	x75 = x100 * 0.75;

	y100 = ((float)pThis->m_pTextures[0]->m_iHeight / (float)pThis->m_pTextures[0]->m_iDataHeight);
	y0 = 1.0;
	y25 = 1.0 - (y100 * 0.25);
	y75 = 1.0 - (y100 * 0.75);
	y100 = 1.0 - y100;

	// Top Left Quad
	InitVector(&vertdata->m_xVertices[0].m_xTextureCoords, x0, y0);
	InitVector(&vertdata->m_xVertices[1].m_xTextureCoords, x0, y25);
	InitVector(&vertdata->m_xVertices[2].m_xTextureCoords, x25, y25);
	InitVector(&vertdata->m_xVertices[3].m_xTextureCoords, x25, y0);

	// Top Center Quad
	InitVector(&vertdata->m_xVertices[4].m_xTextureCoords, x25, y0);
	InitVector(&vertdata->m_xVertices[5].m_xTextureCoords, x25, y25);
	InitVector(&vertdata->m_xVertices[6].m_xTextureCoords, x75, y25);
	InitVector(&vertdata->m_xVertices[7].m_xTextureCoords, x75, y0);

	// Top Right Quad
	InitVector(&vertdata->m_xVertices[8].m_xTextureCoords, x75, y0);
	InitVector(&vertdata->m_xVertices[9].m_xTextureCoords, x75, y25);
	InitVector(&vertdata->m_xVertices[10].m_xTextureCoords, x100, y25);
	InitVector(&vertdata->m_xVertices[11].m_xTextureCoords, x100, y0);

	// Middle Left Quad
	InitVector(&vertdata->m_xVertices[12].m_xTextureCoords, x0, y25);
	InitVector(&vertdata->m_xVertices[13].m_xTextureCoords, x0, y75);
	InitVector(&vertdata->m_xVertices[14].m_xTextureCoords, x25, y75);
	InitVector(&vertdata->m_xVertices[15].m_xTextureCoords, x25, y25);

	// Middle Center Quad
	InitVector(&vertdata->m_xVertices[16].m_xTextureCoords, x25, y25);
	InitVector(&vertdata->m_xVertices[17].m_xTextureCoords, x25, y75);
	InitVector(&vertdata->m_xVertices[18].m_xTextureCoords, x75, y75);
	InitVector(&vertdata->m_xVertices[19].m_xTextureCoords, x75, y25);

	// Middle Right Quad
	InitVector(&vertdata->m_xVertices[20].m_xTextureCoords, x75, y25);
	InitVector(&vertdata->m_xVertices[21].m_xTextureCoords, x75, y75);
	InitVector(&vertdata->m_xVertices[22].m_xTextureCoords, x100, y75);
	InitVector(&vertdata->m_xVertices[23].m_xTextureCoords, x100, y25);

	// Bottom Left Quad
	InitVector(&vertdata->m_xVertices[24].m_xTextureCoords, x0, y75);
	InitVector(&vertdata->m_xVertices[25].m_xTextureCoords, x0, y100);
	InitVector(&vertdata->m_xVertices[26].m_xTextureCoords, x25, y100);
	InitVector(&vertdata->m_xVertices[27].m_xTextureCoords, x25, y75);

	// Bottom Center Quad
	InitVector(&vertdata->m_xVertices[28].m_xTextureCoords, x25, y75);
	InitVector(&vertdata->m_xVertices[29].m_xTextureCoords, x25, y100);
	InitVector(&vertdata->m_xVertices[30].m_xTextureCoords, x75, y100);
	InitVector(&vertdata->m_xVertices[31].m_xTextureCoords, x75, y75);

	// Bottom Right Quad
	InitVector(&vertdata->m_xVertices[32].m_xTextureCoords, x75, y75);
	InitVector(&vertdata->m_xVertices[33].m_xTextureCoords, x75, y100);
	InitVector(&vertdata->m_xVertices[34].m_xTextureCoords, x100, y100);
	InitVector(&vertdata->m_xVertices[35].m_xTextureCoords, x100, y75);

	vertdata->m_uiIndexBuffer = g_xGraphics.m_ui9RectIndexBuffer;

	if(!vertdata->m_uiVertexBuffer)
		glGenBuffers(1, &vertdata->m_uiVertexBuffer);
	glBindBuffer(GL_ARRAY_BUFFER, vertdata->m_uiVertexBuffer);
	glBufferData(GL_ARRAY_BUFFER, sizeof(xTexturedVert) * vertdata->m_iVectorArrayLength, vertdata->m_xVertices, GL_STATIC_DRAW);

	xRenderable2DQuadUpdateShaderParameters(pThis);
}

void xRenderable2DTextSetText(xRenderable2DText *pThis, xSceneGraph *pSceneGraph, const char *strNewText, bool bForceUniqueColorData)
{
	int length = strlen(strNewText), oldlength, numspaces, i;
	xRenderDataVerts *vertdata;
	float x, y, width, spacewidth, cosangle, sinangle;

	oldlength = pThis->m_iStringLength;

	if(oldlength != length)
	{
		if(!pThis->m_xRenderable.m_xRenderable2D.m_pVertData)
		{
			xRenderable2DQuadSetTexture(&pThis->m_xRenderable, pThis->m_pFont->m_pTexture);
			xSceneGraphInsertQuad(pSceneGraph, &pThis->m_xRenderable, length, pThis->m_xRenderable.m_xRenderable2D.m_fDepth, 0, bForceUniqueColorData);
			vertdata = pThis->m_xRenderable.m_xRenderable2D.m_pVertData;
			xRenderable2DQuadUpdateShaderParameters(&pThis->m_xRenderable);
		}
		else
		{
			vertdata = pThis->m_xRenderable.m_xRenderable2D.m_pVertData;

			dlfree(vertdata->m_xVertices);

			vertdata->m_iVectorArrayLength = length * 4;
			vertdata->m_xVertices = (xTexturedVert*)dlmalloc(sizeof(xTexturedVert) * vertdata->m_iVectorArrayLength);
			memset(vertdata->m_xVertices, 0, sizeof(xTexturedVert) * vertdata->m_iVectorArrayLength);
		}
		
		if(!vertdata->m_uiIndexBuffer)
			glGenBuffers(1, &vertdata->m_uiIndexBuffer);
		
		GLushort *indices = (GLushort*)dlmalloc(sizeof(GLushort) * length * 6);
		for (i = 0; i < length; i++)
		{
			indices[i * 6] = i * 4;
			indices[i * 6 + 1] = i * 4 + 1;
			indices[i * 6 + 2] = i * 4 + 2;
			indices[i * 6 + 3] = i * 4;
			indices[i * 6 + 4] = i * 4 + 3;
			indices[i * 6 + 5] = i * 4 + 2;
		}

		glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, vertdata->m_uiIndexBuffer);
		glBufferData(GL_ELEMENT_ARRAY_BUFFER, sizeof(GLushort) * length * 6, indices, GL_STATIC_DRAW);
		
		dlfree(indices);
		
		pThis->m_iStringLength = length;
	}
	else
		vertdata = pThis->m_xRenderable.m_xRenderable2D.m_pVertData;

	if(pThis->m_xAlignment == PE_TEXTALIGN_JUSTIFIED)
	{
		numspaces = 0;

		for(i = 0; i < length; i++)
		{
			if(strNewText[i] == ' ')
				numspaces++;
		}

		spacewidth = (pThis->m_xRenderable.m_xRenderable2D.m_fWidth - xFontGetWidth(pThis->m_pFont, strNewText)) / (float)numspaces;

		//Only let justified spacing get to three times the size of normal spacing
		if(spacewidth <= xFontGetWidth(pThis->m_pFont, ' ') * 2)
			spacewidth = (spacewidth + xFontGetWidth(pThis->m_pFont, ' ')) * pThis->m_xRenderable.m_xRenderable2D.m_fScaleX;
		else
			spacewidth = xFontGetWidth(pThis->m_pFont, ' ') * pThis->m_xRenderable.m_xRenderable2D.m_fScaleX;
	}
	else
		spacewidth = xFontGetWidth(pThis->m_pFont, ' ') * pThis->m_xRenderable.m_xRenderable2D.m_fScaleX;

	if(pThis->m_xRenderable.m_xRenderable2D.m_fRotation == 0.0)
	{
		x = pThis->m_xRenderable.m_xRenderable2D.m_fX;
		for(i = 0; i < length; i++)
		{
			if(strNewText[i] == ' ')
				width = spacewidth;
			else
				width = xFontGetWidth(pThis->m_pFont, strNewText[i]) * pThis->m_xRenderable.m_xRenderable2D.m_fScaleX;

			//Top Left Vertex
			vertdata->m_xVertices[i * 4].m_xVector.x = g_xPaperAPI.m_iScreenOffsetX + x * g_xPaperAPI.m_fScreenRatioX;
			vertdata->m_xVertices[i * 4].m_xVector.y = g_xPaperAPI.m_iScreenOffsetY + pThis->m_xRenderable.m_xRenderable2D.m_fY * g_xPaperAPI.m_fScreenRatioY;
			vertdata->m_xVertices[i * 4].m_xTextureCoords.x = xFontGetCharacterLeft(pThis->m_pFont, strNewText[i]);
			vertdata->m_xVertices[i * 4].m_xTextureCoords.y = xFontGetCharacterTop(pThis->m_pFont, strNewText[i]);

			//Bottom Left Vertex
			vertdata->m_xVertices[i * 4 + 1].m_xVector.x = g_xPaperAPI.m_iScreenOffsetX + x * g_xPaperAPI.m_fScreenRatioX;
			vertdata->m_xVertices[i * 4 + 1].m_xVector.y = g_xPaperAPI.m_iScreenOffsetY + (pThis->m_xRenderable.m_xRenderable2D.m_fY + xFontGetHeight(pThis->m_pFont, strNewText[i]) * pThis->m_xRenderable.m_xRenderable2D.m_fScaleY) * g_xPaperAPI.m_fScreenRatioY;
			vertdata->m_xVertices[i * 4 + 1].m_xTextureCoords.x = xFontGetCharacterLeft(pThis->m_pFont, strNewText[i]);
			vertdata->m_xVertices[i * 4 + 1].m_xTextureCoords.y = xFontGetCharacterBottom(pThis->m_pFont, strNewText[i]);

			//Bottom Right Vertex
			vertdata->m_xVertices[i * 4 + 2].m_xVector.x = g_xPaperAPI.m_iScreenOffsetX + (x + width) * g_xPaperAPI.m_fScreenRatioX;
			vertdata->m_xVertices[i * 4 + 2].m_xVector.y = g_xPaperAPI.m_iScreenOffsetY + (pThis->m_xRenderable.m_xRenderable2D.m_fY + xFontGetHeight(pThis->m_pFont, strNewText[i]) * pThis->m_xRenderable.m_xRenderable2D.m_fScaleY) * g_xPaperAPI.m_fScreenRatioY;
			vertdata->m_xVertices[i * 4 + 2].m_xTextureCoords.x = xFontGetCharacterRight(pThis->m_pFont, strNewText[i]);
			vertdata->m_xVertices[i * 4 + 2].m_xTextureCoords.y = xFontGetCharacterBottom(pThis->m_pFont, strNewText[i]);

			//Top Right Vertex
			vertdata->m_xVertices[i * 4 + 3].m_xVector.x = g_xPaperAPI.m_iScreenOffsetX + (x + width) * g_xPaperAPI.m_fScreenRatioX;
			vertdata->m_xVertices[i * 4 + 3].m_xVector.y = g_xPaperAPI.m_iScreenOffsetY + pThis->m_xRenderable.m_xRenderable2D.m_fY * g_xPaperAPI.m_fScreenRatioY;
			vertdata->m_xVertices[i * 4 + 3].m_xTextureCoords.x = xFontGetCharacterRight(pThis->m_pFont, strNewText[i]);
			vertdata->m_xVertices[i * 4 + 3].m_xTextureCoords.y = xFontGetCharacterTop(pThis->m_pFont, strNewText[i]);

			x += width;
		}
	}
	else
	{
		cosangle = cos(pThis->m_xRenderable.m_xRenderable2D.m_fRotation * (PI / 180.0f));
		sinangle = sin(pThis->m_xRenderable.m_xRenderable2D.m_fRotation * (PI / 180.0f));

		x = pThis->m_xRenderable.m_xRenderable2D.m_fX;
		y = pThis->m_xRenderable.m_xRenderable2D.m_fY;

		for(i = 0; i < length; i++)
		{
			if(strNewText[i] == ' ')
				width = spacewidth;
			else
				width = xFontGetWidth(pThis->m_pFont, strNewText[i]) * pThis->m_xRenderable.m_xRenderable2D.m_fScaleX;

			//Top Left Vertex
			vertdata->m_xVertices[i * 4].m_xVector.x = g_xPaperAPI.m_iScreenOffsetX + x * g_xPaperAPI.m_fScreenRatioX;
			vertdata->m_xVertices[i * 4].m_xVector.y = g_xPaperAPI.m_iScreenOffsetY + y * g_xPaperAPI.m_fScreenRatioY;
			vertdata->m_xVertices[i * 4].m_xTextureCoords.x = xFontGetCharacterLeft(pThis->m_pFont, strNewText[i]);
			vertdata->m_xVertices[i * 4].m_xTextureCoords.y = xFontGetCharacterTop(pThis->m_pFont, strNewText[i]);

			//Bottom Left Vertex
			vertdata->m_xVertices[i * 4 + 1].m_xVector.x = g_xPaperAPI.m_iScreenOffsetX + x * g_xPaperAPI.m_fScreenRatioX + xFontGetHeight(pThis->m_pFont, strNewText[i]) * sinangle * pThis->m_xRenderable.m_xRenderable2D.m_fScaleY * g_xPaperAPI.m_fScreenRatioY;
			vertdata->m_xVertices[i * 4 + 1].m_xVector.y = g_xPaperAPI.m_iScreenOffsetY + y * g_xPaperAPI.m_fScreenRatioY + xFontGetHeight(pThis->m_pFont, strNewText[i]) * cosangle * pThis->m_xRenderable.m_xRenderable2D.m_fScaleY * g_xPaperAPI.m_fScreenRatioY;
			vertdata->m_xVertices[i * 4 + 1].m_xTextureCoords.x = xFontGetCharacterLeft(pThis->m_pFont, strNewText[i]);
			vertdata->m_xVertices[i * 4 + 1].m_xTextureCoords.y = xFontGetCharacterBottom(pThis->m_pFont, strNewText[i]);

			//Bottom Right Vertex
			vertdata->m_xVertices[i * 4 + 2].m_xVector.x = vertdata->m_xVertices[i * 4 + 1].m_xVector.x + width * cosangle * g_xPaperAPI.m_fScreenRatioX;
			vertdata->m_xVertices[i * 4 + 2].m_xVector.y = vertdata->m_xVertices[i * 4 + 1].m_xVector.y - width * sinangle * g_xPaperAPI.m_fScreenRatioX;
			vertdata->m_xVertices[i * 4 + 2].m_xTextureCoords.x = xFontGetCharacterRight(pThis->m_pFont, strNewText[i]);
			vertdata->m_xVertices[i * 4 + 2].m_xTextureCoords.y = xFontGetCharacterBottom(pThis->m_pFont, strNewText[i]);

			//Top Right Vertex
			vertdata->m_xVertices[i * 4 + 3].m_xVector.x = g_xPaperAPI.m_iScreenOffsetX + x * g_xPaperAPI.m_fScreenRatioX + width * cosangle * g_xPaperAPI.m_fScreenRatioX;
			vertdata->m_xVertices[i * 4 + 3].m_xVector.y = g_xPaperAPI.m_iScreenOffsetY + y * g_xPaperAPI.m_fScreenRatioY - width * sinangle * g_xPaperAPI.m_fScreenRatioX;
			vertdata->m_xVertices[i * 4 + 3].m_xTextureCoords.x = xFontGetCharacterRight(pThis->m_pFont, strNewText[i]);
			vertdata->m_xVertices[i * 4 + 3].m_xTextureCoords.y = xFontGetCharacterTop(pThis->m_pFont, strNewText[i]);

			x += width * cosangle;
			y -= width * sinangle;
		}
	}

	if(vertdata)
	{
		if(!vertdata->m_uiVertexBuffer)
			glGenBuffers(1, &vertdata->m_uiVertexBuffer);
		glBindBuffer(GL_ARRAY_BUFFER, vertdata->m_uiVertexBuffer);
		glBufferData(GL_ARRAY_BUFFER, sizeof(xTexturedVert) * vertdata->m_iVectorArrayLength, vertdata->m_xVertices, GL_STATIC_DRAW);
	}
}
