/////////////////////////////////////////////////////////////////
// Name: xResults.h
/////////////////////////////////////////////////////////////////
// Description:
// Result messages from application. 
/////////////////////////////////////////////////////////////////
// - 7.6.2004, Update, Arto Ruotsalainen(Arex)
//   Comment stuff added to begin of the file.
//   Add new updates/fixes above this, so the old updates
//   will be at the bottom.
/////////////////////////////////////////////////////////////////
#ifndef XRESULTS_H_
#define XRESULTS_H_

enum
{
	PE_RES_NOERROR = 0,
	PE_RES_PLATFORMERROR,
	PE_RES_CREATEWINDOWERROR,
	PE_RES_DI8CREATEERROR,
	PE_RES_DI8CREATEKEYBOARDERROR,
	PE_RES_DI8AQUIREKEYBOARDERROR,
	PE_RES_DI8GETKEYBOARDSTATEERROR,
	PE_RES_DI8CREATEMOUSEERROR,
	PE_RES_DI8AQUIREMOUSEERROR,
	PE_RES_DI8GETMOUSESTATEERROR,
	PE_RES_D3DGETDISPLAYERROR,
	PE_RES_D3DUSINGSOFTWAREVERTICES,
	PE_RES_D3DCREATEDEVICEERROR,
	PE_RES_D3DGETBACKBUFFERERROR,
	PE_RES_D3DINVALIDTEXTURERESOURCE,
	PE_RES_D3DTEXTURELOADERROR,
	PE_RES_D3DDEVICENOTREADY,
	PE_RES_OGLFULLSCREENERROR,
	PE_RES_OGLPIXELFORMATERROR,
	PE_RES_FILEDOESNOTEXIST,
	PE_RES_FILEOPENERROR,
	PE_RES_FILENOTOPEN,
	PE_RES_FILEREADERROR,
	PE_RES_SWFCOMPRESSNOTSUPPORTED,
	PE_RES_DMUSICLOADFILEERROR,
	PE_RES_OPENALMUSICLOADFILEERROR,
	PE_RES_ENDOFSCRIPT,
	PE_RES_FUNCTIONNOTFOUND,
	PE_RES_VARNOTFOUND,
	PE_RES_FONTOBJECTNOTLOADED,
	PE_RES_INVALIDGUIOBJECTTYPE,
	PE_RES_WSINTERNALERROR,
	PE_RES_WSVERSIONERROR,
	PE_RES_FRAGMENTERROR,
	PE_RES_MAXERRORS,
};

enum
{
	PE_RESLEVEL_NOACTION = 0,	//No action required
	PE_RESLEVEL_GOTOMENU,		//Goto the Main Menu
	PE_RESLEVEL_GOTOSETTINGS,	//Goto the Settings Window(Launched before the game engine)
	PE_RESLEVEL_KILLAPP,		//Kill the whole program and exit
};

typedef void (*pfMainMenuCallBack)(void);
typedef void (*pfSettingsCallBack)(void);

class xResults
{
public:
	void  Init(void *pfMainMenu, void *pfSettings);
	int   ReactToError(int iResult);
	int	  GetErrorLevel(int iResult);
	char* GetResultString(int iResult);
private:
	pfMainMenuCallBack m_pfMainMenu;
	pfSettingsCallBack m_pfSettings;
};

#endif