#include "Paper.h"

#if 0 && defined _DEBUG
	#define DEBUG_VERIFY_SCENEGRAPH(x,y)	xSceneGraphVerify(x,y)
	FORCE_INLINE void xSceneGraphVerify(xSceneGraph *pThis, bool bCheckRenderables);

	#define DEBUG_ADD_RENDERABLE2D(x,y)	xSceneGraphVerifyAddRenderable2D(x,y)
	FORCE_INLINE void xSceneGraphVerifyAddRenderable2D(xSceneGraph *pThis, xRenderable2D *pRenderable);

	#define DEBUG_REMOVE_RENDERABLE2D(x,y)	xSceneGraphVerifyRemoveRenderable2D(x,y)
	FORCE_INLINE void xSceneGraphVerifyRemoveRenderable2D(xSceneGraph *pThis, xRenderable2D *pRenderable);
#else
	#define DEBUG_VERIFY_SCENEGRAPH(x,y)
	#define DEBUG_ADD_RENDERABLE2D(x,y)
	#define DEBUG_REMOVE_RENDERABLE2D(x,y)
#endif

FORCE_INLINE xRenderDataShader* xSceneGraphGetRenderDataShader(xSceneGraph *pThis, float fDepth, int iBlendMode, bool bIs3D);
FORCE_INLINE xRenderDataShader* xSceneGraphInsertRenderDataShader(xRenderDataShader *pData, float fDepth);
FORCE_INLINE xRenderDataTexture* xSceneGraphGetRenderDataTexture(xSceneGraph *pThis, xRenderDataShader *pShaderData, float fDepth, bool bForceUniqueTextureData, GLenum iRenderType, int iNumTextures, GLuint *pTextureIDs);
FORCE_INLINE xRenderDataTexture* xSceneGraphInsertRenderDataTexture(xRenderDataTexture *pData, float fDepth);
FORCE_INLINE xRenderDataTexture* xSceneGraphSplitRenderDataTexture(xRenderDataTexture *pData, float fDepth);
FORCE_INLINE xRenderDataVerts* xSceneGraphGetRenderDataVerts(xSceneGraph *pThis, xRenderDataTexture *pData, float fDepth);
FORCE_INLINE void xSceneGraphMoveRenderDataVerts(xRenderDataVerts *pThis, xRenderDataTexture *pTextureData);
FORCE_INLINE void xSceneGraphRemoveInline(xSceneGraph *pThis, xRenderDataVerts *pVertData);

FORCE_INLINE xRenderDataShader* xSceneGraphGetRenderDataShader(xSceneGraph *pThis, float fDepth, int iBlendMode, bool bIs3D)
{
	xRenderDataShader *object, *temp;

	if(pThis->m_xRenderData.m_pNext)
	{
		object = pThis->m_xRenderData.m_pNext;
		while(1)
		{
			if(fDepth < object->m_fMinDepth || fDepth <= object->m_fMaxDepth)
			{
				if(iBlendMode == object->m_iBlendMode && bIs3D == object->m_bIs3D)
				{
					if(fDepth < object->m_fMinDepth)
						object->m_fMinDepth = fDepth;
				}
				else if(fDepth < object->m_fMinDepth && object->m_pPrev && object->m_pPrev->m_pPrev && iBlendMode == object->m_pPrev->m_iBlendMode && bIs3D == object->m_pPrev->m_bIs3D)
				{
					object = object->m_pPrev;
					object->m_fMaxDepth = fDepth;
				}
				else
				{
					if(fDepth <= object->m_fMinDepth)
					{
						temp = object->m_pPrev;
						object->m_pPrev = (xRenderDataShader*)dlmalloc(sizeof(xRenderDataShader));
						xRenderDataShaderInit(object->m_pPrev);

						object->m_pPrev->m_pPrev = temp;
						object->m_pPrev->m_pNext = object;
						object = object->m_pPrev;
						temp->m_pNext = object;

						DEBUG_VERIFY_SCENEGRAPH(pThis, 1);
					}
					else if(fDepth == object->m_fMaxDepth)
					{
						temp = object->m_pNext;
						object->m_pNext = (xRenderDataShader*)dlmalloc(sizeof(xRenderDataShader));
						xRenderDataShaderInit(object->m_pNext);

						object->m_pNext->m_pPrev = object;
						object->m_pNext->m_pNext = temp;
						object = object->m_pNext;

						if(temp)
							temp->m_pPrev = object;

						DEBUG_VERIFY_SCENEGRAPH(pThis, 1);
					}
					else
					{
						object = xSceneGraphInsertRenderDataShader(object, fDepth);

						DEBUG_VERIFY_SCENEGRAPH(pThis, 1);
					}

					object->m_bIs3D = bIs3D;
					object->m_iBlendMode = iBlendMode;
					object->m_fMinDepth = fDepth;
					object->m_fMaxDepth = fDepth;
				}

				return object;
			}

			if(!object->m_pNext)
			{
				if(iBlendMode == object->m_iBlendMode)
				{
					object->m_fMaxDepth = fDepth;
					return object;
				}

				object->m_pNext = (xRenderDataShader*)dlmalloc(sizeof(xRenderDataShader));
				xRenderDataShaderInit(object->m_pNext);

				object->m_pNext->m_pPrev = object;
				object = object->m_pNext;

				object->m_bIs3D = bIs3D;
				object->m_iBlendMode = iBlendMode;
				object->m_fMinDepth = fDepth;
				object->m_fMaxDepth = fDepth;

				DEBUG_VERIFY_SCENEGRAPH(pThis, 1);

				return object;
			}

			object = object->m_pNext;
		}
	}
	else
	{
		object = (xRenderDataShader*)dlmalloc(sizeof(xRenderDataShader));
		xRenderDataShaderInit(object);

		pThis->m_xRenderData.m_pNext = object;
		object->m_pPrev = &pThis->m_xRenderData;

		object->m_bIs3D = bIs3D;
		object->m_iBlendMode = iBlendMode;
		object->m_fMinDepth = fDepth;
		object->m_fMaxDepth = fDepth;

		DEBUG_VERIFY_SCENEGRAPH(pThis, 1);
	}

	return object;
}

FORCE_INLINE xRenderDataShader* xSceneGraphInsertRenderDataShader(xRenderDataShader *pData, float fDepth)
{
	xRenderDataShader *ret, *duplicate;
	xRenderDataTexture *texdata, *duptexdata;
	xRenderDataVerts *vertdata;

	ret = (xRenderDataShader*)dlmalloc(sizeof(xRenderDataShader));
	duplicate = (xRenderDataShader*)dlmalloc(sizeof(xRenderDataShader));

	xRenderDataShaderInit(ret);
	xRenderDataShaderInit(duplicate);

	duplicate->m_bIs3D = pData->m_bIs3D;
	duplicate->m_iBlendMode = pData->m_iBlendMode;
	duplicate->m_fMinDepth = pData->m_fMinDepth;
	duplicate->m_pNext = ret;
	duplicate->m_pPrev = pData->m_pPrev;

	ret->m_pNext = pData;
	ret->m_pPrev = duplicate;

	pData->m_pPrev->m_pNext = duplicate;
	pData->m_pPrev = ret;

	texdata = pData->m_xTextureDataList.m_pNext;
	duptexdata = &duplicate->m_xTextureDataList;
	while(1)
	{
		if(texdata->m_fMinDepth > fDepth)
		{
			pData->m_fMinDepth = texdata->m_fMinDepth;
			break;
		}

		if(texdata->m_fMaxDepth > fDepth)
		{
			assert(0); // xSceneGraphSplitRenderDataTexture hasn't been created(need to make sure it keeps up with Min and Max Depth values)
			duptexdata->m_pNext = xSceneGraphSplitRenderDataTexture(texdata, fDepth);
			break;
		}

		texdata->m_pPrev = duptexdata;
		duptexdata->m_pNext = texdata;
		duptexdata = texdata;

		duplicate->m_fMaxDepth = duptexdata->m_fMaxDepth;

		vertdata = duptexdata->m_xVertDataList.m_pNext;
		while(vertdata)
		{
			vertdata->m_pShaderData = duplicate;
			vertdata->m_pTextureData = duptexdata;
			vertdata = vertdata->m_pNext;
		}
		
		texdata = texdata->m_pNext;

		duptexdata->m_pNext = 0;
	}

	texdata->m_pPrev = &pData->m_xTextureDataList;
	pData->m_xTextureDataList.m_pNext = texdata;

	return ret;
}

FORCE_INLINE xRenderDataTexture* xSceneGraphGetRenderDataTexture(xSceneGraph *pThis, xRenderDataShader *pShaderData, float fDepth, bool bForceUniqueTextureData, GLenum iRenderType, int iNumTextures, GLuint *pTextureIDs)
{
	xRenderDataTexture *object, *temp;

	if(pShaderData->m_xTextureDataList.m_pNext)
	{
		object = pShaderData->m_xTextureDataList.m_pNext;
		while(1)
		{
			if(fDepth < object->m_fMinDepth || fDepth <= object->m_fMaxDepth)
			{
				if(!bForceUniqueTextureData && !object->m_bForcedUnique && iRenderType == object->m_uiRenderType && iNumTextures == object->m_iTextureIndexArrayLength && pTextureIDs[0] == object->m_uiTextureIndexArray[0])
				{
					if(fDepth < object->m_fMinDepth)
						object->m_fMinDepth = fDepth;
				}
				else if(!bForceUniqueTextureData && !object->m_bForcedUnique && fDepth < object->m_fMinDepth && object->m_pPrev && object->m_pPrev->m_pPrev && iRenderType == object->m_pPrev->m_uiRenderType && iNumTextures == object->m_pPrev->m_iTextureIndexArrayLength && pTextureIDs[0] == object->m_pPrev->m_uiTextureIndexArray[0])
				{
					object = object->m_pPrev;
					object->m_fMaxDepth = fDepth;
				}
				else
				{
					if(!bForceUniqueTextureData && fDepth == object->m_fMaxDepth)
					{
						temp = object->m_pNext;
						while(temp && fDepth == temp->m_fMaxDepth)
						{
							if(iRenderType == temp->m_uiRenderType && iNumTextures == temp->m_iTextureIndexArrayLength && pTextureIDs[0] == temp->m_uiTextureIndexArray[0])
								return temp;

							temp = temp->m_pNext;
						}
					}

					if(fDepth <= object->m_fMinDepth)
					{
						temp = object->m_pPrev;
						object->m_pPrev = (xRenderDataTexture*)dlmalloc(sizeof(xRenderDataTexture));
						xRenderDataTextureInit(object->m_pPrev);

						object->m_pPrev->m_pPrev = temp;
						object->m_pPrev->m_pNext = object;
						object = object->m_pPrev;
						temp->m_pNext = object;
					}
					else if(fDepth == object->m_fMaxDepth)
					{
						temp = object->m_pNext;
						object->m_pNext = (xRenderDataTexture*)dlmalloc(sizeof(xRenderDataTexture));
						xRenderDataTextureInit(object->m_pNext);

						object->m_pNext->m_pNext = temp;
						object->m_pNext->m_pPrev = object;
						object = object->m_pNext;

						if(temp)
							temp->m_pPrev = object;
					}
					else
						object = xSceneGraphInsertRenderDataTexture(object, fDepth);

					xRenderDataTextureInit(object, pShaderData->m_iBlendMode, iRenderType, iNumTextures, pTextureIDs, fDepth, bForceUniqueTextureData);
				}

				return object;
			}

			if(!object->m_pNext)
			{
				if(!bForceUniqueTextureData && !object->m_bForcedUnique && iRenderType == object->m_uiRenderType && iNumTextures == object->m_iTextureIndexArrayLength && pTextureIDs[0] == object->m_uiTextureIndexArray[0])
				{
					object->m_fMaxDepth = fDepth;
					return object;
				}

				object->m_pNext = (xRenderDataTexture*)dlmalloc(sizeof(xRenderDataTexture));
				xRenderDataTextureInit(object->m_pNext);

				object->m_pNext->m_pPrev = object;
				object = object->m_pNext;

				xRenderDataTextureInit(object, pShaderData->m_iBlendMode, iRenderType, iNumTextures, pTextureIDs, fDepth, bForceUniqueTextureData);

				return object;
			}

			object = object->m_pNext;
		}
	}
	else
	{
		object = (xRenderDataTexture*)dlmalloc(sizeof(xRenderDataTexture));
		xRenderDataTextureInit(object);

		pShaderData->m_xTextureDataList.m_pNext = object;
		object->m_pPrev = &pShaderData->m_xTextureDataList;

		xRenderDataTextureInit(object, pShaderData->m_iBlendMode, iRenderType, iNumTextures, pTextureIDs, fDepth, bForceUniqueTextureData);
	}

	return object;
}

FORCE_INLINE xRenderDataTexture* xSceneGraphInsertRenderDataTexture(xRenderDataTexture *pData, float fDepth)
{
	xRenderDataTexture *ret, *duplicate;
	xRenderDataVerts *vertdata, *dupvertdata;

	ret = (xRenderDataTexture*)dlmalloc(sizeof(xRenderDataTexture));
	duplicate = (xRenderDataTexture*)dlmalloc(sizeof(xRenderDataTexture));

	xRenderDataTextureInit(ret);
	xRenderDataTextureInit(duplicate);

	duplicate->m_pNext = ret;
	duplicate->m_pPrev = pData->m_pPrev;

	duplicate->m_uiRenderType = pData->m_uiRenderType;
	duplicate->m_iTextureIndexArrayLength = pData->m_iTextureIndexArrayLength;
	duplicate->m_uiTextureIndexArray = (GLuint*)dlmalloc(sizeof(GLuint) * pData->m_iTextureIndexArrayLength);
	duplicate->m_uiTextureIndexArray[0] = pData->m_uiTextureIndexArray[0];

	if(pData->m_iTextureIndexArrayLength > 1)
		duplicate->m_uiTextureIndexArray[1] = pData->m_uiTextureIndexArray[1];

	ret->m_pNext = pData;
	ret->m_pPrev = duplicate;

	vertdata = pData->m_xVertDataList.m_pNext;
	dupvertdata = &duplicate->m_xVertDataList;
	while(vertdata->m_fDepth <= fDepth)
	{
		vertdata->m_pPrev = dupvertdata;
		dupvertdata->m_pNext = vertdata;
		dupvertdata = vertdata;
		
		dupvertdata->m_pTextureData = duplicate;

		if(!vertdata->m_pNext)
		{
			dupvertdata->m_pNext = 0;
			break;
		}

		vertdata = vertdata->m_pNext;

		dupvertdata->m_pNext = 0;
	}

	vertdata->m_pPrev = &pData->m_xVertDataList;
	pData->m_xVertDataList.m_pNext = vertdata;

	return ret;
}

FORCE_INLINE xRenderDataTexture* xSceneGraphSplitRenderDataTexture(xRenderDataTexture *pData, float fDepth)
{
	return pData;
}

FORCE_INLINE xRenderDataVerts* xSceneGraphGetRenderDataVerts(xSceneGraph *pThis, xRenderDataTexture *pData, float fDepth)
{
	xRenderDataVerts *temp;
	xRenderDataVerts *current = &pData->m_xVertDataList;

	while(current->m_pNext)
	{
		if(fDepth <= current->m_fDepth)
		{
			if(current->m_pPrev)
				current = current->m_pPrev;

			break;
		}

		current = current->m_pNext;
	}

	if(current->m_fDepth > fDepth)
		current = current->m_pPrev;

	temp = current->m_pNext;
	current->m_pNext = (xRenderDataVerts*)dlmalloc(sizeof(xRenderDataVerts));

	xRenderDataVertsInit(current->m_pNext);

	current->m_pNext->m_pPrev = current;
	current->m_pNext->m_pNext = temp;
	current->m_pNext->m_fDepth = fDepth;

	if(temp)
		temp->m_pPrev = current->m_pNext;

	return current->m_pNext;
}

FORCE_INLINE void xSceneGraphMoveRenderDataVerts(xRenderDataVerts *pThis, xRenderDataTexture *pTextureData)
{
	xRenderDataVerts *curvertdata;

	if(pThis->m_pPrev)
		pThis->m_pPrev->m_pNext = pThis->m_pNext;

	if(pThis->m_pNext)
		pThis->m_pNext->m_pPrev = pThis->m_pPrev;

	curvertdata = &pTextureData->m_xVertDataList;
	while(curvertdata->m_pNext)
	{
		if(pThis->m_fDepth < curvertdata->m_pNext->m_fDepth)
			break;

		curvertdata = curvertdata->m_pNext;
	}

	pThis->m_pNext = curvertdata->m_pNext;
	pThis->m_pPrev = curvertdata;

	if(curvertdata->m_pNext)
		curvertdata->m_pNext->m_pPrev = pThis;

	curvertdata->m_pNext = pThis;
}

void xSceneGraphDepthChanged(xSceneGraph *pThis, xRenderDataVerts *pVertData, float fDepth)
{
	xRenderDataTexture *oldtexturedata;
	xRenderDataShader *oldshaderdata;
	bool onlydata;

	DEBUG_VERIFY_SCENEGRAPH(pThis, 1);

	pVertData->m_fDepth = fDepth;

	if(fDepth > pVertData->m_pTextureData->m_fMinDepth && fDepth < pVertData->m_pTextureData->m_fMaxDepth)
	{
		xSceneGraphMoveRenderDataVerts(pVertData, pVertData->m_pTextureData);

		DEBUG_VERIFY_SCENEGRAPH(pThis, 1);
	}
	else if(fDepth < pVertData->m_pTextureData->m_fMinDepth && fDepth > pVertData->m_pTextureData->m_pPrev->m_fMaxDepth &&
		    (fDepth > pVertData->m_pShaderData->m_fMinDepth || fDepth > pVertData->m_pShaderData->m_pPrev->m_fMaxDepth))
	{
		pVertData->m_pTextureData->m_fMinDepth = fDepth;

		if(fDepth < pVertData->m_pShaderData->m_fMinDepth)
			pVertData->m_pShaderData->m_fMinDepth = fDepth;

		xSceneGraphMoveRenderDataVerts(pVertData, pVertData->m_pTextureData);

		DEBUG_VERIFY_SCENEGRAPH(pThis, 1);
	}
	else if((!pVertData->m_pTextureData->m_pNext || (fDepth > pVertData->m_pTextureData->m_fMaxDepth && fDepth < pVertData->m_pTextureData->m_pNext->m_fMinDepth)) &&
		    (fDepth < pVertData->m_pShaderData->m_fMaxDepth || !pVertData->m_pShaderData->m_pNext || fDepth < pVertData->m_pShaderData->m_pNext->m_fMinDepth))
	{
		pVertData->m_pTextureData->m_fMaxDepth = fDepth;

		if(fDepth > pVertData->m_pShaderData->m_fMaxDepth)
			pVertData->m_pShaderData->m_fMaxDepth = fDepth;

		xSceneGraphMoveRenderDataVerts(pVertData, pVertData->m_pTextureData);

		DEBUG_VERIFY_SCENEGRAPH(pThis, 1);
	}
	else
	{
		onlydata = !pVertData->m_pNext && pVertData->m_pPrev == &pVertData->m_pTextureData->m_xVertDataList;

		if(onlydata)
		{
			onlydata = !pVertData->m_pTextureData->m_pNext && pVertData->m_pTextureData->m_pPrev == &pVertData->m_pShaderData->m_xTextureDataList;

			pVertData->m_pPrev = 0;

			pVertData->m_pTextureData->m_pPrev->m_pNext = pVertData->m_pTextureData->m_pNext;

			if(pVertData->m_pTextureData->m_pNext)
				pVertData->m_pTextureData->m_pNext->m_pPrev = pVertData->m_pTextureData->m_pPrev;

			if(onlydata)
			{
				pVertData->m_pTextureData->m_pPrev = 0;

				pVertData->m_pShaderData->m_pPrev->m_pNext = pVertData->m_pShaderData->m_pNext;

				if(pVertData->m_pShaderData->m_pNext)
					pVertData->m_pShaderData->m_pNext->m_pPrev = pVertData->m_pShaderData->m_pPrev;

				oldshaderdata = pVertData->m_pShaderData;

				pVertData->m_pShaderData = xSceneGraphGetRenderDataShader(pThis, fDepth, pVertData->m_pShaderData->m_iBlendMode, 0);

				dlfree(oldshaderdata);

				DEBUG_VERIFY_SCENEGRAPH(pThis, 0);
			}
			else
			{
				pVertData->m_pShaderData = xSceneGraphGetRenderDataShader(pThis, fDepth, pVertData->m_pShaderData->m_iBlendMode, 0);
				DEBUG_VERIFY_SCENEGRAPH(pThis, 0);
			}

			oldtexturedata = pVertData->m_pTextureData;

			pVertData->m_pTextureData = xSceneGraphGetRenderDataTexture(pThis,
																		pVertData->m_pShaderData,
																		fDepth,
																		pVertData->m_pTextureData->m_bForcedUnique,
																		pVertData->m_pTextureData->m_uiRenderType,
																		pVertData->m_pTextureData->m_iTextureIndexArrayLength,
																		pVertData->m_pTextureData->m_uiTextureIndexArray);

			dlfree(oldtexturedata);

			DEBUG_VERIFY_SCENEGRAPH(pThis, 0);
		}
		else
		{
			pVertData->m_pShaderData = xSceneGraphGetRenderDataShader(pThis, fDepth, pVertData->m_pShaderData->m_iBlendMode, 0);

			DEBUG_VERIFY_SCENEGRAPH(pThis, 0);

			pVertData->m_pTextureData = xSceneGraphGetRenderDataTexture(pThis,
																		pVertData->m_pShaderData,
																		fDepth,
																		pVertData->m_pTextureData->m_bForcedUnique,
																		pVertData->m_pTextureData->m_uiRenderType,
																		pVertData->m_pTextureData->m_iTextureIndexArrayLength,
																		pVertData->m_pTextureData->m_uiTextureIndexArray);

			DEBUG_VERIFY_SCENEGRAPH(pThis, 0);
		}

		xSceneGraphMoveRenderDataVerts(pVertData, pVertData->m_pTextureData);

		DEBUG_VERIFY_SCENEGRAPH(pThis, 1);
	}
}

FORCE_INLINE void xSceneGraphRemoveInline(xSceneGraph *pThis, xRenderDataVerts *pVertData)
{
	bool onlydata;

	if(pVertData)
	{
		onlydata = !pVertData->m_pNext && pVertData->m_pPrev == &pVertData->m_pTextureData->m_xVertDataList;

		pVertData->m_pPrev->m_pNext = pVertData->m_pNext;

		if(!pVertData->m_pNext)
		{
			pVertData->m_pTextureData->m_fMaxDepth = pVertData->m_pPrev->m_fDepth;

			if(!pVertData->m_pTextureData->m_pNext)
				pVertData->m_pShaderData->m_fMaxDepth = pVertData->m_pPrev->m_fDepth;
		}
		else
			pVertData->m_pNext->m_pPrev = pVertData->m_pPrev;

		if(onlydata)
		{
			onlydata = !pVertData->m_pTextureData->m_pNext && pVertData->m_pTextureData->m_pPrev == &pVertData->m_pShaderData->m_xTextureDataList;

			pVertData->m_pTextureData->m_pPrev->m_pNext = pVertData->m_pTextureData->m_pNext;

			if(pVertData->m_pTextureData->m_pNext)
				pVertData->m_pTextureData->m_pNext->m_pPrev = pVertData->m_pTextureData->m_pPrev;
			else
				pVertData->m_pShaderData->m_fMaxDepth = pVertData->m_pTextureData->m_pPrev->m_fMaxDepth;

			dlfree(pVertData->m_pTextureData);

			if(onlydata)
			{
				pVertData->m_pShaderData->m_pPrev->m_pNext = pVertData->m_pShaderData->m_pNext;

				if(pVertData->m_pShaderData->m_pNext)
					pVertData->m_pShaderData->m_pNext->m_pPrev = pVertData->m_pShaderData->m_pPrev;

				dlfree(pVertData->m_pShaderData);
			}
		}

		dlfree(pVertData);
	}

	DEBUG_VERIFY_SCENEGRAPH(pThis, 1);
}
	
void xSceneGraphRemove2D(xSceneGraph *pThis, xRenderable2D *pRenderable)
{
	DEBUG_REMOVE_RENDERABLE2D(pThis, pRenderable);

	xSceneGraphRemoveInline(pThis, pRenderable->m_pVertData);
}

xRenderable2DLine* xSceneGraphCreateLine()
{
	xRenderable2DLine *ret = (xRenderable2DLine*)dlmalloc(sizeof(xRenderable2DLine));
	xRenderable2DLineInit(ret);

	ret->m_xRenderable2D.m_iBlendMode = PE_BLEND_MODE_ALPHA_NOSHADER;

	return ret;
}

void xSceneGraphInsertLine(xSceneGraph *pThis, xRenderable2DLine *pLine, float fDepth)
{
	GLuint textureids[1] = {0};
	xRenderDataShader *shaderdata;
	xRenderDataTexture *texturedata;
	xRenderDataVerts *vertdata;
	
	shaderdata = xSceneGraphGetRenderDataShader(pThis, fDepth, pLine->m_xRenderable2D.m_iBlendMode, 0);

	texturedata = xSceneGraphGetRenderDataTexture(pThis, shaderdata, fDepth, false, GL_LINES, 0, textureids);

	vertdata = xSceneGraphGetRenderDataVerts(pThis, texturedata, fDepth);

	vertdata->m_iVectorArrayLength = 2;
	vertdata->m_xVertices = (xTexturedVert*)dlmalloc(sizeof(xTexturedVert) * vertdata->m_iVectorArrayLength);
	memset(vertdata->m_xVertices, 0, sizeof(xTexturedVert) * vertdata->m_iVectorArrayLength);

	vertdata->m_fDepth = fDepth;

	pLine->m_xRenderable2D.m_pVertData = vertdata;
	pLine->m_xRenderable2D.m_pVertData->m_pShaderData = shaderdata;
	pLine->m_xRenderable2D.m_pVertData->m_pTextureData = texturedata;

	DEBUG_ADD_RENDERABLE2D(pThis, &pLine->m_xRenderable2D);
	DEBUG_VERIFY_SCENEGRAPH(pThis, 1);
}

void xSceneGraphDeleteLine(xSceneGraph *pThis, xRenderable2DLine *pLine)
{
	DEBUG_REMOVE_RENDERABLE2D(pThis, &pLine->m_xRenderable2D);

	dlfree(pLine->m_xRenderable2D.m_pVertData->m_xVertices);

	xSceneGraphRemoveInline(pThis, pLine->m_xRenderable2D.m_pVertData);

	dlfree(pLine);
}

xRenderable2DBox* xSceneGraphCreateBox()
{
	xRenderable2DBox *ret = (xRenderable2DBox*)dlmalloc(sizeof(xRenderable2DBox));
	xRenderable2DBoxInit(ret);

	ret->m_xRenderable2D.m_iBlendMode = PE_BLEND_MODE_ALPHA_NOSHADER;

	return ret;
}

void xSceneGraphInsertBox(xSceneGraph *pThis, xRenderable2DBox *pBox, float fDepth)
{
	GLuint textureids[1] = {0};
	xRenderDataShader *shaderdata;
	xRenderDataTexture *texturedata;
	xRenderDataVerts *vertdata;
	
	shaderdata = xSceneGraphGetRenderDataShader(pThis, fDepth, pBox->m_xRenderable2D.m_iBlendMode, 0);

	texturedata = xSceneGraphGetRenderDataTexture(pThis, shaderdata, fDepth, false, GL_LINE_LOOP, 0, textureids);

	vertdata = xSceneGraphGetRenderDataVerts(pThis, texturedata, fDepth);

	vertdata->m_iVectorArrayLength = 4;
	vertdata->m_xVertices = (xTexturedVert*)dlmalloc(sizeof(xTexturedVert) * vertdata->m_iVectorArrayLength);
	memset(vertdata->m_xVertices, 0, sizeof(xTexturedVert) * vertdata->m_iVectorArrayLength);

	vertdata->m_fDepth = fDepth;

	pBox->m_xRenderable2D.m_pVertData = vertdata;
	pBox->m_xRenderable2D.m_pVertData->m_pShaderData = shaderdata;
	pBox->m_xRenderable2D.m_pVertData->m_pTextureData = texturedata;

	DEBUG_ADD_RENDERABLE2D(pThis, &pBox->m_xRenderable2D);
	DEBUG_VERIFY_SCENEGRAPH(pThis, 1);
}

void xSceneGraphDeleteBox(xSceneGraph *pThis, xRenderable2DBox *pBox)
{
	DEBUG_REMOVE_RENDERABLE2D(pThis, &pBox->m_xRenderable2D);

	dlfree(pBox->m_xRenderable2D.m_pVertData->m_xVertices);

	xSceneGraphRemoveInline(pThis, pBox->m_xRenderable2D.m_pVertData);

	dlfree(pBox);
}

xRenderable2DQuad* xSceneGraphCreateQuad(const char* strFilePath, int iFrame)
{
	xRenderable2DQuad *ret = (xRenderable2DQuad*)dlmalloc(sizeof(xRenderable2DQuad));
	xRenderable2DQuadInit(ret);

	ret->m_iNumTextures = xGraphicsGetTextures(strFilePath, &ret->m_pTextures, &ret->m_fAnimationRate);

	ret->m_pTextures[0] = ret->m_pTextures[iFrame];

	xRenderable2DQuadSetSize(ret, ret->m_pTextures[0]->m_iWidth, ret->m_pTextures[0]->m_iHeight);

	return ret;
}

xRenderable2DQuad* xSceneGraphCreateQuad(xTexture *pTexture)
{
	xRenderable2DQuad *ret = (xRenderable2DQuad*)dlmalloc(sizeof(xRenderable2DQuad));
	xRenderable2DQuadInit(ret);

	xRenderable2DQuadSetTexture(ret, pTexture);
	pTexture->m_iReferenceCount++;

	xRenderable2DQuadSetSize(ret, pTexture->m_iWidth, pTexture->m_iHeight);

	return ret;
}

xRenderable2DQuad* xSceneGraphCreateQuad(xColor *pColor)
{
	xRenderable2DQuad *ret = (xRenderable2DQuad*)dlmalloc(sizeof(xRenderable2DQuad));
	xRenderable2DQuadInit(ret);

	xRenderable2DQuadSetBlendMode(ret, PE_BLEND_MODE_ALPHA_NOSHADER);
	xRenderable2DQuadSetColor(ret, pColor);

	return ret;
}

void xSceneGraphInsertQuad(xSceneGraph *pThis, xRenderable2DQuad *pQuad, int iQuadCount, float fDepth, bool bColorArray, bool bForceUniqueTextureData)
{
	int numtextures;
	GLuint textureids[2];
	xRenderDataShader *shaderdata;
	xRenderDataTexture *texturedata;
	xRenderDataVerts *vertdata;
	
	shaderdata = xSceneGraphGetRenderDataShader(pThis, fDepth, pQuad->m_xRenderable2D.m_iBlendMode, 0);
	shaderdata->m_bRender = 1;

	if(pQuad->m_iNumTextures > 1)
	{
		numtextures = 2;
		textureids[0] = pQuad->m_pTextures[0]->m_uiID;
		textureids[1] = pQuad->m_pTextures[1]->m_uiID;
	}
	else if(pQuad->m_pTextures)
	{
		numtextures = 1;
		textureids[0] = pQuad->m_pTextures[0]->m_uiID;
	}
	else
		numtextures = 0;

	texturedata = xSceneGraphGetRenderDataTexture(pThis, shaderdata, fDepth, bForceUniqueTextureData, BB_GL_QUADS, numtextures, textureids);
	texturedata->m_bRender = 1;

	vertdata = xSceneGraphGetRenderDataVerts(pThis, texturedata, fDepth);

	vertdata->m_iVectorArrayLength = 4 * iQuadCount;
	vertdata->m_xVertices = (xTexturedVert*)dlmalloc(sizeof(xTexturedVert) * vertdata->m_iVectorArrayLength);
	memset(vertdata->m_xVertices, 0, sizeof(xTexturedVert) * vertdata->m_iVectorArrayLength);

/*	if(bColorArray)
	{
		vertdata->m_pColorArray = (xColor*)dlmalloc(sizeof(xColor) * vertdata->m_iVectorArrayLength);
		memset(vertdata->m_pColorArray, 0, sizeof(xColor) * vertdata->m_iVectorArrayLength);
	}
	else
*/		xColorCopy(&vertdata->m_xColor, &pQuad->m_xRenderable2D.m_xColor);

	vertdata->m_fDepth = fDepth;

	pQuad->m_xRenderable2D.m_pVertData = vertdata;
	pQuad->m_xRenderable2D.m_pVertData->m_pShaderData = shaderdata;
	pQuad->m_xRenderable2D.m_pVertData->m_pTextureData = texturedata;

	DEBUG_ADD_RENDERABLE2D(pThis, &pQuad->m_xRenderable2D);
	DEBUG_VERIFY_SCENEGRAPH(pThis, 1);
}

void xSceneGraphDeleteQuad(xSceneGraph *pThis, xRenderable2DQuad *pQuad, bool bDeleteTexture)
{
	int i;

	DEBUGCHECK(!pThis || !pQuad->m_xRenderable2D.m_pVertData || !pQuad->m_xRenderable2D.m_pVertData->m_pTextureData || !pQuad->m_xRenderable2D.m_pVertData->m_pShaderData || !pQuad->m_xRenderable2D.m_pVertData->m_xVertices);

	DEBUG_REMOVE_RENDERABLE2D(pThis, &pQuad->m_xRenderable2D);

	dlfree(pQuad->m_xRenderable2D.m_pVertData->m_xVertices);

	xSceneGraphRemoveInline(pThis, pQuad->m_xRenderable2D.m_pVertData);

	if(pQuad->m_pTextures)
	{
		if(bDeleteTexture)
		{
			for(i = 0; i < pQuad->m_iNumTextures; i++)
				xGraphicsDeleteTexture(pQuad->m_pTextures[i]);
		}
		else
		{
			for(i = 0; i < pQuad->m_iNumTextures; i++)
				xGraphicsDeleteTextureReference(pQuad->m_pTextures[i]);
		}
	}

	dlfree(pQuad);
}

void xSceneGraphQuadTextureChanged(xSceneGraph *pThis, xRenderable2DQuad *pQuad)
{
	xRenderDataTexture *texturedata;
	xRenderDataVerts *vertdata;

	if(pQuad->m_xRenderable2D.m_pVertData->m_pTextureData->m_uiTextureIndexArray[0] == pQuad->m_pTextures[0]->m_uiID)
		return;

	if(pQuad->m_xRenderable2D.m_pVertData->m_pTextureData->m_bForcedUnique ||
	   (!pQuad->m_xRenderable2D.m_pVertData->m_pNext && pQuad->m_xRenderable2D.m_pVertData->m_pPrev == &pQuad->m_xRenderable2D.m_pVertData->m_pTextureData->m_xVertDataList))
	{
		pQuad->m_xRenderable2D.m_pVertData->m_pTextureData->m_uiTextureIndexArray[0] = pQuad->m_pTextures[0]->m_uiID;

		if(pQuad->m_iNumTextures > 1)
			pQuad->m_xRenderable2D.m_pVertData->m_pTextureData->m_uiTextureIndexArray[1] = pQuad->m_pTextures[1]->m_uiID;

		return;
	}

	DEBUG_VERIFY_SCENEGRAPH(pThis, 1);

	vertdata = pQuad->m_xRenderable2D.m_pVertData;
	vertdata->m_pPrev->m_pNext = vertdata->m_pNext;

	if(vertdata->m_pNext)
		vertdata->m_pNext->m_pPrev = vertdata->m_pPrev;

	DEBUG_VERIFY_SCENEGRAPH(pThis, 0);

	texturedata = (xRenderDataTexture*)dlmalloc(sizeof(xRenderDataTexture));
	xRenderDataTextureInit(texturedata);

	texturedata->m_pPrev = pQuad->m_xRenderable2D.m_pVertData->m_pTextureData->m_pPrev;
	texturedata->m_pNext = pQuad->m_xRenderable2D.m_pVertData->m_pTextureData;
	texturedata->m_pPrev->m_pNext = texturedata;
	texturedata->m_pNext->m_pPrev = texturedata;

	DEBUG_VERIFY_SCENEGRAPH(pThis, 0);

	texturedata->m_fMinDepth = vertdata->m_fDepth;
	texturedata->m_fMaxDepth = vertdata->m_fDepth;

	texturedata->m_uiRenderType = pQuad->m_xRenderable2D.m_pVertData->m_pTextureData->m_uiRenderType;
	texturedata->m_iTextureIndexArrayLength = pQuad->m_xRenderable2D.m_pVertData->m_pTextureData->m_iTextureIndexArrayLength;
	texturedata->m_uiTextureIndexArray = (GLuint*)dlmalloc(sizeof(GLuint) * texturedata->m_iTextureIndexArrayLength);
	texturedata->m_uiTextureIndexArray[0] = pQuad->m_pTextures[0]->m_uiID;

	if(texturedata->m_iTextureIndexArrayLength > 1)
		texturedata->m_uiTextureIndexArray[1] = pQuad->m_pTextures[1]->m_uiID;

	texturedata->m_xVertDataList.m_pNext = vertdata;
	vertdata->m_pPrev = &texturedata->m_xVertDataList;
	vertdata->m_pNext = 0;

	switch(pQuad->m_xRenderable2D.m_iBlendMode)
	{
		case PE_BLEND_MODE_MASKED:
			texturedata->m_xShaderParameterArray = (xColor*)dlmalloc(sizeof(xColor) * 2);
			memcpy(texturedata->m_xShaderParameterArray, pQuad->m_xRenderable2D.m_pVertData->m_pTextureData->m_xShaderParameterArray, sizeof(xColor) * 2);
			break;
		case PE_BLEND_MODE_2COLOR:
			texturedata->m_xShaderParameterArray = (xColor*)dlmalloc(sizeof(xColor) * 2);
			memcpy(texturedata->m_xShaderParameterArray, pQuad->m_xRenderable2D.m_pVertData->m_pTextureData->m_xShaderParameterArray, sizeof(xColor) * 2);
			break;
	}

	pQuad->m_xRenderable2D.m_pVertData->m_pTextureData = texturedata;

	DEBUG_VERIFY_SCENEGRAPH(pThis, 1);
}

xRenderable3D* xSceneGraphCreateMesh(const char* strTexturePath, int iFrame)
{
	xRenderable3D *ret = (xRenderable3D*)dlmalloc(sizeof(xRenderable3D));
	xRenderable3DInit(ret);

	ret->m_pTextures[0] = xGraphicsGetTexture(strTexturePath, iFrame);

	return ret;
}

xRenderable3D* xSceneGraphCreateMesh(xTexture* pTexture)
{
	xRenderable3D *ret = (xRenderable3D*)dlmalloc(sizeof(xRenderable3D));
	xRenderable3DInit(ret);

	ret->m_pTextures[0] = pTexture;

	return ret;
}

void xSceneGraphInsertMesh(xSceneGraph *pThis, xRenderable3D *pRenderable, int iTriangleCount, float fDepth, bool bForceUniqueTextureData)
{
	int numtextures;
	GLuint textureids[2];
	xRenderDataShader *shaderdata;
	xRenderDataTexture *texturedata;
	xRenderDataVerts *vertdata;
	
	shaderdata = xSceneGraphGetRenderDataShader(pThis, fDepth, pRenderable->m_iBlendMode, 1);

	if(pRenderable->m_pTextures[1])
	{
		numtextures = 2;
		textureids[0] = pRenderable->m_pTextures[0]->m_uiID;
		textureids[1] = pRenderable->m_pTextures[1]->m_uiID;
	}
	else
	{
		numtextures = 1;
		textureids[0] = pRenderable->m_pTextures[0]->m_uiID;
	}

	texturedata = xSceneGraphGetRenderDataTexture(pThis, shaderdata, fDepth, bForceUniqueTextureData, GL_TRIANGLES, numtextures, textureids);

	vertdata = xSceneGraphGetRenderDataVerts(pThis, texturedata, fDepth);

	vertdata->m_iVectorArrayLength = 3 * iTriangleCount;
	vertdata->m_xVertices = (xTexturedVert*)dlmalloc(sizeof(xTexturedVert) * vertdata->m_iVectorArrayLength);
	memset(vertdata->m_xVertices, 0, sizeof(xTexturedVert) * vertdata->m_iVectorArrayLength);

	vertdata->m_fDepth = fDepth;
	
	xVectorCopy(&vertdata->m_xRotation, &pRenderable->m_xRotation);

	pRenderable->m_pVertData = vertdata;
	pRenderable->m_pVertData->m_pShaderData = shaderdata;
	pRenderable->m_pVertData->m_pTextureData = texturedata;

	//DEBUG_ADD_RENDERABLE3D(pThis, &pRenderable);
	DEBUG_VERIFY_SCENEGRAPH(pThis, 1);
}

void xSceneGraphDeleteMesh(xSceneGraph *pThis, xRenderable3D *pRenderable, bool bDeleteTexture)
{
	DEBUGCHECK(!pThis || !pRenderable->m_pVertData || !pRenderable->m_pVertData->m_pTextureData || !pRenderable->m_pVertData->m_pShaderData || !pRenderable->m_pVertData->m_xVertices);

	//DEBUG_REMOVE_RENDERABLE3D(pThis, &pRenderable);

	dlfree(pRenderable->m_pVertData->m_xVertices);

	xSceneGraphRemoveInline(pThis, pRenderable->m_pVertData);

	if(pRenderable->m_pTextures[0])
	{
		if(bDeleteTexture)
			xGraphicsDeleteTexture(pRenderable->m_pTextures[0]);
		else
			xGraphicsDeleteTextureReference(pRenderable->m_pTextures[0]);
	}

	if(pRenderable->m_pTextures[1])
	{
		if(bDeleteTexture)
			xGraphicsDeleteTexture(pRenderable->m_pTextures[1]);
		else
			xGraphicsDeleteTextureReference(pRenderable->m_pTextures[1]);
	}

	dlfree(pRenderable);
}

void xSceneGraphRemoveAllRenderables(xSceneGraph *pThis)
{
	pThis->m_xRenderData.m_pNext = NULL;
}

#ifdef _DEBUG
	FORCE_INLINE void xSceneGraphVerifyAddRenderable2D(xSceneGraph *pThis, xRenderable2D *pRenderable)
	{
		int i;

		for(i = 0; i < MAX_RENDERABLE2DS; i++)
		{
			if(!pThis->Renderable2DArray[i])
			{
				pThis->Renderable2DArray[i] = pRenderable;
				break;
			}
		}
	}

	FORCE_INLINE void xSceneGraphVerifyRemoveRenderable2D(xSceneGraph *pThis, xRenderable2D *pRenderable)
	{
		int i;

		for(i = 0; i < MAX_RENDERABLE2DS; i++)
		{
			if(pThis->Renderable2DArray[i] == pRenderable)
			{
				pThis->Renderable2DArray[i] = 0;
			}
		}
	}

	void xSceneGraphVerifyAddQuads(xSceneGraph *pThis, xRenderable2DQuad *pQuads, int iCount)
	{
		int i;

		for(i = 0; i < iCount; i++)
			xSceneGraphVerifyAddRenderable2D(pThis, &pQuads[i].m_xRenderable2D);
	}

	void xSceneGraphVerifyRemoveQuads(xSceneGraph *pThis, xRenderable2DQuad *pQuads, int iCount)
	{
		int i;

		for(i = 0; i < iCount; i++)
			xSceneGraphVerifyRemoveRenderable2D(pThis, &pQuads[i].m_xRenderable2D);
	}

	FORCE_INLINE void xSceneGraphVerify(xSceneGraph *pThis, bool bCheckRenderables)
	{
		xRenderDataShader *shaderdata, *tempshaderdata;
		xRenderDataTexture *texturedata, *temptexturedata;
		xRenderDataVerts *vertdata, *tempvertdata;
		int i;
			
		shaderdata = pThis->m_xRenderData.m_pNext;
		while(shaderdata)
		{
			if(shaderdata->m_pPrev && shaderdata->m_pPrev->m_pNext != shaderdata)
				assert(0);

			tempshaderdata = shaderdata->m_pNext;
			while(tempshaderdata)
			{
				if(tempshaderdata == shaderdata)
					assert(0);

				tempshaderdata = tempshaderdata->m_pNext;
			}

			texturedata = shaderdata->m_xTextureDataList.m_pNext;
			while(texturedata)
			{
				if(texturedata->m_pPrev && texturedata->m_pPrev->m_pNext != texturedata)
					assert(0);

				if(!texturedata->m_pNext && texturedata->m_fMaxDepth != shaderdata->m_fMaxDepth)
					assert(0);

				tempshaderdata = shaderdata->m_pNext;
				while(tempshaderdata)
				{
					temptexturedata = tempshaderdata->m_xTextureDataList.m_pNext;
					while(temptexturedata)
					{
						if(temptexturedata == texturedata)
							assert(0);

						temptexturedata = temptexturedata->m_pNext;
					}

					tempshaderdata = tempshaderdata->m_pNext;
				}

				temptexturedata = texturedata->m_pNext;
				while(temptexturedata)
				{
					if(temptexturedata == texturedata)
						assert(0);

					temptexturedata = temptexturedata->m_pNext;
				}

				vertdata = texturedata->m_xVertDataList.m_pNext;
				while(vertdata)
				{
					if(vertdata->m_pPrev && vertdata->m_pPrev->m_pNext != vertdata)
						assert(0);

					if(!vertdata->m_pNext && vertdata->m_fDepth != texturedata->m_fMaxDepth)
						assert(0);

					tempshaderdata = shaderdata->m_pNext;
					while(tempshaderdata)
					{
						temptexturedata = tempshaderdata->m_xTextureDataList.m_pNext;
						while(temptexturedata)
						{
							tempvertdata = temptexturedata->m_xVertDataList.m_pNext;
							while(tempvertdata)
							{
								if(tempvertdata == vertdata)
									assert(0);

								tempvertdata = tempvertdata->m_pNext;
							}

							temptexturedata = temptexturedata->m_pNext;
						}

						tempshaderdata = tempshaderdata->m_pNext;
					}

					temptexturedata = texturedata->m_pNext;
					while(temptexturedata)
					{
						tempvertdata = temptexturedata->m_xVertDataList.m_pNext;
						while(tempvertdata)
						{
							if(tempvertdata == vertdata)
								assert(0);

							tempvertdata = tempvertdata->m_pNext;
						}

						temptexturedata = temptexturedata->m_pNext;
					}

					tempvertdata = vertdata->m_pNext;
					while(tempvertdata)
					{
						if(tempvertdata == vertdata)
							assert(0);

						tempvertdata = tempvertdata->m_pNext;
					}

					vertdata = vertdata->m_pNext;
				}

				texturedata = texturedata->m_pNext;
			}

			shaderdata = shaderdata->m_pNext;
		}

		if(bCheckRenderables)
		{
			for(i = 0; i < MAX_RENDERABLE2DS; i++)
			{
				if(pThis->Renderable2DArray[i])
				{
					if(pThis->Renderable2DArray[i]->m_pVertData->m_pShaderData->m_pPrev->m_pNext != pThis->Renderable2DArray[i]->m_pVertData->m_pShaderData)
						assert(0);
					
					if(pThis->Renderable2DArray[i]->m_pVertData->m_pShaderData->m_pNext && pThis->Renderable2DArray[i]->m_pVertData->m_pShaderData->m_pNext->m_pPrev != pThis->Renderable2DArray[i]->m_pVertData->m_pShaderData)
						assert(0);

					if(pThis->Renderable2DArray[i]->m_pVertData->m_pTextureData->m_pPrev->m_pNext != pThis->Renderable2DArray[i]->m_pVertData->m_pTextureData)
						assert(0);
					
					if(pThis->Renderable2DArray[i]->m_pVertData->m_pTextureData->m_pNext && pThis->Renderable2DArray[i]->m_pVertData->m_pTextureData->m_pNext->m_pPrev != pThis->Renderable2DArray[i]->m_pVertData->m_pTextureData)
						assert(0);

					if(pThis->Renderable2DArray[i]->m_pVertData->m_pPrev->m_pNext != pThis->Renderable2DArray[i]->m_pVertData)
						assert(0);
					
					if(pThis->Renderable2DArray[i]->m_pVertData->m_pNext && pThis->Renderable2DArray[i]->m_pVertData->m_pNext->m_pPrev != pThis->Renderable2DArray[i]->m_pVertData)
						assert(0);
				}
			}
		}
	}
#endif
